SystemOrganization addCategory: #'HV-Base'!
SystemOrganization addCategory: #'HV-Builder'!
SystemOrganization addCategory: #'HV-Canvas'!
SystemOrganization addCategory: #'HV-Canvas-Tests'!
SystemOrganization addCategory: #'HV-Examples'!
SystemOrganization addCategory: #'HV-Extras-Swiki'!
SystemOrganization addCategory: #'HV-Extras-TOCs'!
SystemOrganization addCategory: #'HV-Tests'!
SystemOrganization addCategory: #'HV-XHTMLCanvas'!
SystemOrganization addCategory: #'HV-XHTMLCanvas-Tests'!
SystemOrganization addCategory: #'HV-base'!

Notification subclass: #HVResponseNotification
	instanceVariableNames: 'response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Base'!

!HVResponseNotification class methodsFor: 'as yet unclassified' stamp: 'gk 3/3/2004 16:33'!
signal: aResponse
	^(self new response: aResponse) signal! !

!HVResponseNotification methodsFor: 'as yet unclassified' stamp: 'gk 3/3/2004 16:34'!
response
	^response! !

!HVResponseNotification methodsFor: 'as yet unclassified' stamp: 'gk 3/3/2004 16:34'!
response: aResponse
	response _ aResponse! !

Error subclass: #HVAttributeError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Canvas'!

Error subclass: #HVAttributeNotUnderstood
	instanceVariableNames: 'htmlTag attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Canvas'!

!HVAttributeNotUnderstood class methodsFor: 'instance creation' stamp: 'gc 2/12/2007 08:59'!
tag: aTag attribute: aString
	^ (self new)
		htmlTag: aTag;
		attribute: aString;
		yourself! !

!HVAttributeNotUnderstood methodsFor: 'accessing' stamp: 'gc 2/12/2007 08:59'!
attribute
	^attribute! !

!HVAttributeNotUnderstood methodsFor: 'accessing' stamp: 'gc 2/12/2007 08:59'!
attribute: anObject
	attribute := anObject! !

!HVAttributeNotUnderstood methodsFor: 'exceptionDescription' stamp: 'gc 2/12/2007 11:46'!
defaultAction! !

!HVAttributeNotUnderstood methodsFor: 'accessing' stamp: 'gc 2/12/2007 08:59'!
htmlTag
	^htmlTag! !

!HVAttributeNotUnderstood methodsFor: 'accessing' stamp: 'gc 2/12/2007 08:59'!
htmlTag: anObject
	htmlTag := anObject! !

!HVAttributeNotUnderstood methodsFor: 'exceptionDescription' stamp: 'gc 2/12/2007 11:45'!
isResumable
	^ true! !

!HVAttributeNotUnderstood methodsFor: 'printing' stamp: 'gc 2/12/2007 11:44'!
messageText
	^ 'Tag ''{1}'' does not understand attribute ''{2}''' format: {self htmlTag tag. self attribute}! !

Object subclass: #HVCanvas
	instanceVariableNames: 'stream request view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Canvas'!

!HVCanvas class methodsFor: 'constants' stamp: 'gc 8/1/2007 12:53'!
contentType
	^ 'application/xml'! !

!HVCanvas class methodsFor: 'constants' stamp: 'gc 8/1/2007 11:39'!
doctype
	^ ''! !

!HVCanvas class methodsFor: 'instance creation' stamp: 'gc 8/1/2007 12:33'!
request: request view: view
	^ (self new)
		request: request;
		view: view;
		yourself.! !

!HVCanvas class methodsFor: 'constants' stamp: 'gc 8/1/2007 11:38'!
xmlTag
	^ '<?xml version="1.0" encoding="UTF-8"?>'! !

!HVCanvas class methodsFor: 'constants' stamp: 'gc 8/1/2007 11:38'!
xmlns
	^ ''! !

!HVCanvas methodsFor: 'comanche' stamp: 'gc 8/1/2007 13:06'!
asHttpResponseTo: aRequest
	| response |
	response := view response.
	response contentType: self class contentType.
	response contents: stream contents readStream.
	^ response! !

!HVCanvas methodsFor: 'constants' stamp: 'gc 7/31/2007 21:26'!
doctype
	^ self class doctype! !

!HVCanvas methodsFor: 'initialize-release' stamp: 'gc 7/31/2007 21:26'!
initialize
	stream := WriteStream on: String new.! !

!HVCanvas methodsFor: 'testing' stamp: 'gc 7/31/2007 21:26'!
isEmpty
	^ self stream isEmpty! !

!HVCanvas methodsFor: 'rendering' stamp: 'gc 7/31/2007 21:26'!
nextPut: aCharacter
	^ stream nextPut: aCharacter! !

!HVCanvas methodsFor: 'rendering' stamp: 'gc 7/31/2007 21:27'!
nextPutAll: aString
	^ stream nextPutAll: aString! !

!HVCanvas methodsFor: 'rendering' stamp: 'gc 7/31/2007 21:27'!
preamble
	stream nextPutAll: self xmlTag.
	stream nextPutAll: self doctype! !

!HVCanvas methodsFor: 'rendering' stamp: 'gc 7/31/2007 21:27'!
render
	^ stream contents! !

!HVCanvas methodsFor: 'accessing' stamp: 'gc 8/1/2007 12:32'!
request
	^ request! !

!HVCanvas methodsFor: 'accessing' stamp: 'gc 8/1/2007 12:32'!
request: anObject
	request := anObject! !

!HVCanvas methodsFor: 'accessing' stamp: 'gc 7/31/2007 21:27'!
stream
	^stream! !

!HVCanvas methodsFor: 'tags' stamp: 'gc 8/1/2007 12:17'!
tag: aString
	^ (HVTag tag: aString) canvas: self! !

!HVCanvas methodsFor: 'html' stamp: 'gc 8/1/2007 12:02'!
text: aString
	^ self nextPutAll: aString! !

!HVCanvas methodsFor: 'accessing' stamp: 'gc 8/1/2007 12:32'!
view
	^ view! !

!HVCanvas methodsFor: 'accessing' stamp: 'gc 8/1/2007 12:32'!
view: anObject
	view := anObject! !

!HVCanvas methodsFor: 'constants' stamp: 'gc 7/31/2007 21:26'!
xmlTag
	^ self class xmlTag! !

!HVCanvas methodsFor: 'constants' stamp: 'gc 7/31/2007 21:26'!
xmlns
	^ self class xmlns! !

HVCanvas subclass: #HVXHTMLCanvas
	instanceVariableNames: 'currentFormId currentFormElementId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVXHTMLCanvas class methodsFor: 'constants' stamp: 'gc 8/1/2007 13:04'!
contentType
	^ 'text/xml'! !

!HVXHTMLCanvas class methodsFor: 'constants' stamp: 'gc 2/9/2007 12:06'!
doctype
	^ '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">'! !

!HVXHTMLCanvas class methodsFor: 'constants' stamp: 'gc 2/9/2007 12:08'!
xmlns
	^ 'http://www.w3.org/1999/xhtml'! !

!HVXHTMLCanvas methodsFor: 'hypertext' stamp: 'gc 2/18/2007 20:44'!
a
	^ self anchor! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 11:33'!
abbr
	^ self abbreviation ! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:11'!
abbreviation
	^ self tag: 'abbr'! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:12'!
acronym
	^ self tag: 'acronym'! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:12'!
address
	^ self tag: 'address'! !

!HVXHTMLCanvas methodsFor: 'hypertext' stamp: 'gc 2/18/2007 20:43'!
anchor
	^ HVAnchorTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'image map' stamp: 'gc 7/25/2007 13:21'!
area
	^ HVAreaTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:42'!
b: aBlock
	^ self bold with: aBlock! !

!HVXHTMLCanvas methodsFor: 'base' stamp: 'gc 2/10/2007 18:48'!
base
	^ HVBaseTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'base' stamp: 'gc 7/31/2007 20:51'!
base: aString
	^ self base
		href: aString! !

!HVXHTMLCanvas methodsFor: 'bidirectional text' stamp: 'gc 7/24/2007 17:38'!
bdo
	^ self direction! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 8/1/2007 12:12'!
big
	^ self tag: 'big'! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:42'!
big: aBlock
	^ self big with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/30/2007 17:55'!
blockquote
	^ (HVTextTag tag: 'blockquote') canvas: self! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:20'!
blockquote: aBlock
	^ self blockquote with: aBlock! !

!HVXHTMLCanvas methodsFor: 'structure' stamp: 'gc 8/1/2007 12:12'!
body
	^ self tag: 'body'! !

!HVXHTMLCanvas methodsFor: 'structure' stamp: 'gc 2/8/2007 11:38'!
body: aBlock
	^ self body with: aBlock! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 8/1/2007 12:13'!
bold
	^ self tag: 'b'! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/11/2007 15:55'!
bold: aBlock
	^ self bold with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/24/2007 16:45'!
br
	^ self break! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/24/2007 16:47'!
break
	^ (HVBreakTag canvas: self) with: []! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 8/25/2008 18:14'!
button
	^ self setNameOfFormElement: (HVButtonTag canvas: self)! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/24/2007 18:19'!
button: aBlock
	^ self button with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 8/1/2007 12:13'!
caption
	^ self tag: 'caption'! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 19:07'!
caption: aBlock
	^ self caption with: aBlock! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/31/2007 12:08'!
checkboxInput
	^ self input beCheckbox! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:13'!
citation
	^ self tag: 'cite'! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:22'!
citation: aBlock
	^ self citation with: aBlock ! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:31'!
cite: aBlock
	^ self citation with: aBlock ! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:13'!
code
	^ self tag: 'code'! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:26'!
code: aBlock
	^ self code with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:31'!
col: aBlock
	^ self column with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/25/2007 00:02'!
colGroup: aBlock
	^ self columnGroup with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:31'!
column
	^ (HVTableColumnElementTag tag: 'col') canvas: self! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:30'!
column: aBlock
	^ self column with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:32'!
columnGroup
	^ (HVTableColumnElementTag tag: 'colgroup') canvas: self! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:32'!
columnGroup: aBlock
	^ self columnGroup with: aBlock! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:11'!
dd: aBlock
	^ self definitionData with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:13'!
definition
	^ (self tag: 'dfn')! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:30'!
definition: aBlock
	^ self definition with: aBlock! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 8/1/2007 12:13'!
definitionData
	^ (self tag: 'dd') ! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:10'!
definitionData: aBlock
	^ self definitionData with: aBlock! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 8/1/2007 12:13'!
definitionList
	^ (self tag: 'dl') ! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:08'!
definitionList: aBlock
	^ self definitionList with: aBlock! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 8/1/2007 12:14'!
definitionTerm
	^ (self tag: 'dt') ! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:09'!
definitionTerm: aBlock
	^ self definitionTerm with: aBlock! !

!HVXHTMLCanvas methodsFor: 'edit' stamp: 'gc 7/24/2007 17:09'!
del: aBlock
	^ self deletion with: aBlock! !

!HVXHTMLCanvas methodsFor: 'edit' stamp: 'gc 7/25/2007 00:07'!
deletion
	^ (HVEditTag tag: 'del') canvas: self! !

!HVXHTMLCanvas methodsFor: 'edit' stamp: 'gc 7/24/2007 17:08'!
deletion: aBlock
	^ self deletion with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:31'!
dfn: aBlock
	^ self definition with: aBlock! !

!HVXHTMLCanvas methodsFor: 'bidirectional text' stamp: 'gc 7/24/2007 17:38'!
direction
	^ HVDirectionTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 22:48'!
div
	^ self division ! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:14'!
division
	^ (self tag: 'div') ! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:08'!
dl: aBlock
	^ self definitionList with: aBlock! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:09'!
dt: aBlock
	^ self definitionTerm with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:33'!
em: aBlock
	^ self emphasis with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:14'!
emphasis
	^ (self tag: 'em') ! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:33'!
emphasis: aBlock
	^ self emphasis with: aBlock! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 8/1/2007 12:14'!
fieldset
	^ (self tag: 'fieldset') ! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/16/2007 23:16'!
fieldset: aBlock
	^ self fieldset with: aBlock! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/31/2007 12:09'!
fileInput
	^ self input beFile! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 8/25/2008 18:12'!
form
	| form |
	form := HVFormTag canvas: self.
	form action: request url.
	self setNameOfForm: form.
	^ form! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/10/2007 18:49'!
h1
	^ HVHeadingTag level: 1 canvas: self! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/10/2007 18:50'!
h1: aBlock
	^ self h1 with: aBlock
	! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/8/2007 15:36'!
h2
	^ HVHeadingTag level: 2 canvas: self! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/8/2007 15:37'!
h2: aBlock
	^ self h2 with: aBlock
	! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/10/2007 18:50'!
h3
	^ HVHeadingTag level: 3 canvas: self! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/10/2007 18:50'!
h3: aBlock
	^ self h3 with: aBlock
	! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/10/2007 18:51'!
h4
	^ HVHeadingTag level: 4 canvas: self! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/10/2007 18:51'!
h4: aBlock
	^ self h4 with: aBlock
	! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/10/2007 18:52'!
h5
	^ HVHeadingTag level: 5 canvas: self! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/10/2007 18:52'!
h5: aBlock
	^ self h5 with: aBlock
	! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/10/2007 18:53'!
h6
	^ HVHeadingTag level: 6 canvas: self! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/10/2007 18:52'!
h6: aBlock
	^ self h6 with: aBlock
	! !

!HVXHTMLCanvas methodsFor: 'structure' stamp: 'gc 2/8/2007 11:28'!
head
	^ HVHeadTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'structure' stamp: 'gc 2/8/2007 11:28'!
head: aBlock
	^ self head with: aBlock! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/31/2007 12:10'!
hiddenInput
	^ self input beHidden! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/30/2007 17:47'!
horizontalRule
	^ ((HVClosingTag tag: 'hr') canvas: self) with: []! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:49'!
hr
	^ self horizontalRule! !

!HVXHTMLCanvas methodsFor: 'structure' stamp: 'gc 2/8/2007 00:09'!
html
	^ HVHtmlTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'structure' stamp: 'gc 7/31/2007 21:22'!
html: aBlock 
	self preamble.
	^ self html with: aBlock! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:50'!
i: aBlock
	^ self italic with: aBlock! !

!HVXHTMLCanvas methodsFor: 'image' stamp: 'gc 7/25/2007 12:36'!
image
	^ (HVImageTag canvas: self)! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/31/2007 12:11'!
imageInput
	^ self input beImage! !

!HVXHTMLCanvas methodsFor: 'initialize-release' stamp: 'gc 8/25/2008 18:13'!
initialize
	super initialize.
	currentFormId := 0.
	currentFormElementId := 0.! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 8/25/2008 18:15'!
input
	^ self setNameOfFormElement: (HVInputTag canvas: self)! !

!HVXHTMLCanvas methodsFor: 'edit' stamp: 'gc 7/24/2007 17:30'!
ins: aBlock
	^ self insertion with: aBlock! !

!HVXHTMLCanvas methodsFor: 'edit' stamp: 'gc 7/25/2007 00:08'!
insertion
	^ (HVEditTag tag: 'ins') canvas: self! !

!HVXHTMLCanvas methodsFor: 'edit' stamp: 'gc 7/24/2007 17:29'!
insertion: aBlock
	^ self insertion with: aBlock! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 8/1/2007 12:14'!
italic
	^ (self tag: 'i') ! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:50'!
italic: aBlock
	^ self italic with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:39'!
kbd: aBlock
	^ self keyboard with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:14'!
keyboard
	^ (self tag: 'kbd') ! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:38'!
keyboard: aBlock
	^ self keyboard with: aBlock! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/17/2007 10:31'!
label
	^ HVLabelTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/17/2007 10:22'!
legend
	^ HVLegendTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/17/2007 10:23'!
legend: aBlock
	^ self legend with: aBlock ! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:18'!
li: aBlock
	^ self listItem with: aBlock! !

!HVXHTMLCanvas methodsFor: 'link' stamp: 'gc 7/25/2007 15:54'!
link
	^ HVLinkTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 8/1/2007 12:14'!
listItem
	^ (self tag: 'li') ! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:17'!
listItem: aBlock
	^ self listItem with: aBlock! !

!HVXHTMLCanvas methodsFor: 'image map' stamp: 'gc 7/31/2007 14:54'!
map
	^ HVMapTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'image map' stamp: 'gc 7/25/2007 12:44'!
map: aBlock
	^ self map with: aBlock! !

!HVXHTMLCanvas methodsFor: 'metainformation' stamp: 'gc 7/25/2007 14:40'!
meta
	^ HVMetaTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'scripting' stamp: 'gc 8/1/2007 12:14'!
noscript
	^ (self tag: 'noscript') ! !

!HVXHTMLCanvas methodsFor: 'scripting' stamp: 'gc 7/25/2007 14:46'!
noscript: aBlock
	^ self noscript with: aBlock! !

!HVXHTMLCanvas methodsFor: 'object' stamp: 'gc 7/24/2007 16:09'!
object
	^ HVObjectTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:15'!
ol: aBlock
	^ self orderedList with: aBlock! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/17/2007 11:40'!
option
	^ HVOptionTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/24/2007 18:28'!
optionGroup
	^ HVOptionGroupTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/24/2007 18:28'!
optionGroup: aBlock
	^ self optionGroup with: aBlock! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 8/1/2007 12:14'!
orderedList
	^ (self tag: 'ol') ! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:14'!
orderedList: aBlock
	^ self orderedList with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 2/19/2007 23:07'!
p
	^ self paragraph! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:15'!
paragraph
	^ (self tag: 'p') ! !

!HVXHTMLCanvas methodsFor: 'object' stamp: 'gc 7/24/2007 16:34'!
param
	^ self parameter! !

!HVXHTMLCanvas methodsFor: 'object' stamp: 'gc 7/24/2007 16:34'!
parameter
	^ HVParameterTag canvas: self.! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/31/2007 12:12'!
passwordInput
	^ self input bePassword! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:44'!
pre: aBlock
	^ self preformatted with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:15'!
preformatted
	^ (self tag: 'pre') ! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:44'!
preformatted: aBlock
	^ self preformatted with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:47'!
q: aBlock
	^ self quote with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/30/2007 17:55'!
quote
	^ (HVTextTag tag: 'q') canvas: self! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:47'!
quote: aBlock
	^ self quote with: aBlock! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/31/2007 12:13'!
radioInput
	^ self input beRadio! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 7/25/2007 16:04'!
rb: aBlock
	^ self rubyBase with: aBlock! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 7/25/2007 16:01'!
rbc: aBlock
	^ self rubyBaseContainer with: aBlock! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/31/2007 12:14'!
resetInput
	^ self input beReset! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 8/1/2007 12:15'!
rp
	^ (self tag: 'rp') ! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 7/25/2007 16:09'!
rp: aBlock
	^ self rp with: aBlock! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 7/25/2007 16:09'!
rt: aBlock
	^ self rubyText with: aBlock! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 7/25/2007 16:03'!
rtc: aBlock
	^ self rubyTextContainer with: aBlock! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 8/1/2007 12:15'!
ruby
	^ (self tag: 'ruby') ! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 7/25/2007 16:00'!
ruby: aBlock
	^ self ruby with: aBlock! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 8/1/2007 12:15'!
rubyBase
	^ (self tag: 'rb') ! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 7/25/2007 16:03'!
rubyBase: aBlock
	^ self rubyBase with: aBlock! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 8/1/2007 12:15'!
rubyBaseContainer
	^ (self tag: 'rbc') ! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 7/25/2007 16:01'!
rubyBaseContainer: aBlock
	^ self rubyBaseContainer with: aBlock! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 7/25/2007 16:08'!
rubyText
	^ (HVRubyTextTag) canvas: self! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 7/25/2007 16:04'!
rubyText: aBlock
	^ self rubyText with: aBlock! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 8/1/2007 12:15'!
rubyTextContainer
	^ (self tag: 'rtc') ! !

!HVXHTMLCanvas methodsFor: 'ruby annotations' stamp: 'gc 7/25/2007 16:02'!
rubyTextContainer: aBlock
	^ self rubyTextContainer with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:51'!
samp: aBlock
	^ self sample with: aBlock ! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:15'!
sample
	^ (self tag: 'samp') ! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:51'!
sample: aBlock
	^ self sample with: aBlock ! !

!HVXHTMLCanvas methodsFor: 'scripting' stamp: 'gc 7/25/2007 15:12'!
script
	^ HVScriptTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 8/25/2008 18:15'!
select
	^ self setNameOfFormElement: (HVSelectTag canvas: self)! !

!HVXHTMLCanvas methodsFor: 'private' stamp: 'gc 8/25/2008 18:11'!
setNameOfForm: form 
	currentFormId := currentFormId + 1.
	form name: currentFormId asString.
	currentFormElementId := 0.
	^ form! !

!HVXHTMLCanvas methodsFor: 'private' stamp: 'gc 8/25/2008 18:11'!
setNameOfFormElement: input 
	currentFormElementId := currentFormElementId + 1.
	input name: currentFormId asString , '-' , currentFormElementId asString.
	^ input! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 8/1/2007 12:15'!
small
	^ (self tag: 'small') ! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:53'!
small: aBlock
	^ self small with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:15'!
span
	^ (self tag: 'span')! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:15'!
strong
	^ (self tag: 'strong')! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:53'!
strong: aBlock
	^ self strong with: aBlock! !

!HVXHTMLCanvas methodsFor: 'style sheet' stamp: 'gc 7/25/2007 15:36'!
style
	^ HVStyleTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'style sheet' stamp: 'gc 7/25/2007 15:36'!
style: aBlock
	^ self style with: aBlock! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:56'!
sub: aBlock
	^ self subscript with: aBlock! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/31/2007 12:15'!
submitInput
	^ self input beSubmit! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 8/1/2007 12:15'!
subscript
	^ (self tag: 'sub')! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:55'!
subscript: aBlock
	^ self subscript with: aBlock! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:57'!
sup: aBlock
	^ self superscript with: aBlock! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 8/1/2007 12:15'!
superscript
	^ (self tag: 'sup')! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:56'!
superscript: aBlock
	^ self superscript with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 19:05'!
table
	^ HVTableTag canvas: self! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 19:05'!
table: aBlock
	^ self table with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:12'!
tableBody
	^ (HVTableElementTag tag: 'tbody') canvas: self! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:12'!
tableBody: aBlock
	^ self tableBody with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 22:10'!
tableData
	^ (HVTableCellTag tag: 'td') canvas: self! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 21:08'!
tableData: aBlock
	^ self tableData with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:11'!
tableFoot
	^ (HVTableElementTag tag: 'tfoot') canvas: self! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:11'!
tableFoot: aBlock
	^ self tableFoot with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:09'!
tableHead
	^ (HVTableElementTag tag: 'thead') canvas: self! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:09'!
tableHead: aBlock
	^ self tableHead with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 22:12'!
tableHeader
	^ (HVTableCellTag tag: 'th') canvas: self! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 22:12'!
tableHeader: aBlock
	^ self tableHeader with: aBlock! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 23:08'!
tableRow
	^ (HVTableElementTag tag: 'tr') canvas: self! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 19:58'!
tableRow: aBlock
	^ self tableRow with: aBlock! !

!HVXHTMLCanvas methodsFor: 'tags' stamp: 'gc 8/1/2007 12:17'!
tag: aString 
	^ (HVCommonTag tag: aString) canvas: self! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 8/1/2007 12:16'!
teletype
	^ (self tag: 'tt') ! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:58'!
teletype: aBlock
	^ self teletype with: aBlock! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 8/25/2008 18:16'!
textArea
	^ self setNameOfFormElement: (HVTextAreaTag canvas: self)! !

!HVXHTMLCanvas methodsFor: 'forms' stamp: 'gc 7/31/2007 12:21'!
textInput
	^ self input beText! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 22:12'!
th: aBlock
	^ self tableHeader with: aBlock! !

!HVXHTMLCanvas methodsFor: 'structure' stamp: 'gc 7/30/2007 15:22'!
title
	^ (HVBasicTag tag: 'title') canvas: self! !

!HVXHTMLCanvas methodsFor: 'structure' stamp: 'gc 2/8/2007 15:33'!
title: aString
	^ self title with: [self nextPutAll: aString]! !

!HVXHTMLCanvas methodsFor: 'table' stamp: 'gc 7/24/2007 20:01'!
tr: aBlock
	^ self tableRow with: aBlock! !

!HVXHTMLCanvas methodsFor: 'presentation' stamp: 'gc 7/24/2007 16:59'!
tt: aBlock
	^ self teletype with: aBlock! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:16'!
ul: aBlock
	^ self unorderedList with: aBlock! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 8/1/2007 12:16'!
unorderedList
	^ (self tag: 'ul')! !

!HVXHTMLCanvas methodsFor: 'list' stamp: 'gc 7/24/2007 11:16'!
unorderedList: aBlock
	^ self unorderedList with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:55'!
var: aBlock
	^ self variable with: aBlock! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 8/1/2007 12:16'!
variable
	^ (self tag: 'var')! !

!HVXHTMLCanvas methodsFor: 'text' stamp: 'gc 7/23/2007 23:55'!
variable: aBlock
	^ self variable with: aBlock! !

Object subclass: #HVCascadingStyleSheet
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVCascadingStyleSheet class methodsFor: 'instance creation' stamp: 'gh 8/30/2002 10:56'!
string: aString
	^self new string: aString! !

!HVCascadingStyleSheet methodsFor: 'as yet unclassified' stamp: 'gh 10/14/2002 16:39'!
asHttpResponseTo: request

	^HttpResponse new
		status: #ok;
		contentType: MIMEDocument contentTypeTextCSS;
		contents: (ReadStream on: string);
		yourself! !

!HVCascadingStyleSheet methodsFor: 'accessing' stamp: 'gh 9/18/2002 13:18'!
string
	^string! !

!HVCascadingStyleSheet methodsFor: 'accessing' stamp: 'gh 8/30/2002 10:26'!
string: aString
	string _ aString! !

Object subclass: #HVHtmlColorPalette
	instanceVariableNames: ''
	classVariableNames: 'HtmlColor'
	poolDictionaries: ''
	category: 'HV-Base'!

HVHtmlColorPalette class
	instanceVariableNames: 'container htmlColorTable'!

HVHtmlColorPalette class
	instanceVariableNames: 'container htmlColorTable'!

!HVHtmlColorPalette class methodsFor: 'as yet unclassified' stamp: 'edc 12/8/2005 11:35'!
colorRandom
" HVHtmlColorPalette colorRandom"

^ htmlColorTable atRandom.
! !

!HVHtmlColorPalette class methodsFor: 'as yet unclassified' stamp: 'edc 12/18/2005 08:31'!
example
	"HVHtmlColorPalette example"
	| htmlValues r v a m rS vS aS x y htmlColor index |
	htmlColorTable := OrderedCollection new.
	container := PasteUpMorph new behaveLikeHolder openInWorld.
	container borderWidth: 2;
		 borderColor: Color black;
		 color: Color white.
	htmlValues := #('00' '33' '66' '99' 'CC' 'FF' ).
	x := 0.
	y := 0.
	index := 0.
	1
		to: 6
		do: [:rojo | 
			r := htmlValues at: rojo.
			1
				to: 6
				do: [:verde | 
					v := htmlValues at: verde.
					1
						to: 6
						do: [:azul | 
							a := htmlValues at: azul.
							htmlColor := '#' , r , v , a.
							htmlColorTable add: htmlColor.
							rS := (Number readFrom: r base: 16)
										/ 255.
							vS := (Number readFrom: v base: 16)
										/ 255.
							aS := (Number readFrom: a base: 16)
										/ 255.
							index := index + 1.
							m := SimpleButtonMorph newWithLabel: ''.
							m extent: 45 @ 15.
							m target: self;
								 actionSelector: #setColor:;
								
								arguments: (Array
										with: (htmlColorTable at: index));
								
								color: (Color
										r: rS
										g: vS
										b: aS).
							m label: ''.
							m position: x @ y.
							container addMorph: m.
							x := m right + 2].
					x := 0.
					y := m bottom + 2]].
	container extent: 190 @ 410! !

!HVHtmlColorPalette class methodsFor: 'as yet unclassified' stamp: 'edc 11/1/2003 10:36'!
getColor


^ HtmlColor ! !

!HVHtmlColorPalette class methodsFor: 'as yet unclassified' stamp: 'edc 11/1/2003 10:36'!
setColor: b



HtmlColor _ b! !

Object subclass: #HVHttpRequestMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Tests'!

!HVHttpRequestMock methodsFor: 'as yet unclassified' stamp: 'gk 4/7/2005 11:26'!
getFields
	^Dictionary new! !

!HVHttpRequestMock methodsFor: 'as yet unclassified' stamp: 'gk 4/7/2005 11:25'!
isPostRequest
	^false! !

Object subclass: #HVHttpView
	instanceVariableNames: 'model'
	classVariableNames: 'UltraSafeChars HtmlEntities SafeChars'
	poolDictionaries: ''
	category: 'HV-Base'!

!HVHttpView commentStamp: 'gk 10/24/2003 10:55' prior: 0!
A HVHttpView is a web user interface - it is an object that handles a HttpRequest and returns a result.

A view has a domain object as a model, and thus the HVHttpView hierarchy often typically mirrors the domain class hierarchy. It also has a reference to it's parent view which ultimately is a HVRootView.

A view is instantiated for every request which means that it does not have to care about multiple Processes (each view instance is only used by one Process - the one started to serve the request) - but since the model can be shared with other views either the model needs to care or the views needs to serialize their access to the model.

The HVRootView is not instantiated for every request - it represents the web application itself that is plugged into Komanche - so it must be written Process safe.

A view holds a reference to the request - 'req' - which it is given upon instantiation. Most of the interaction with the request is done easier through the use of an HVHtmlBuilder which has a lot of support for handling HTML Forms.

Based on the url the framework will call the method with the same name. These methods are kept by convention in the 'urls' category. If no method name is given in the url the default method #default is called. The methods should return something responds to #asHttpResponseTo:. The root view sends this message to the object returned and returns the result to Komanche which expects an HttpResponse.

String implements #asHttpResponseTo: so the simplest would be to just return a String with HTML in it. A better approach would be to use an HVHtmlBuilder. Look at the sample applications.

Finally HVHttpView includes some simple facilities for keeping track of the user and the current user account.!

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 10/24/2003 10:21'!
createModel
	"This is called when a HVRootView is created
	and no model has been specified.
	Default model is nil, override in subclass."

	^nil! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 10/24/2003 10:43'!
defaultAlias
	"This is called when a HVRootView is created
	and no alias has been specified.
	Default alias, override in subclass."

	^''! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 12/4/2003 13:39'!
defaultPort
	"This is called when a HVRootView is created
	and no port number has been specified.
	Default alias, override in subclass."

	^8080! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 11/13/2003 23:31'!
defaultViewClass
	"This is called when a HVRootView is created
	and no viewClass has been specified.
	Default alias, override in subclass."

	^self! !

!HVHttpView class methodsFor: 'html' stamp: 'gk 3/31/2005 14:34'!
escapeForHtml: string
	"Replace a lot of characters so that the string
	is safe for verbatim inclusion in a HTML page,
	for example for editing in a textarea."

	| temp |
	(string isEmpty or: [string isNil]) ifTrue:[^string].
	temp _ string copyReplaceAll: '&' with: '&amp;'.
	HtmlEntities keysAndValuesDo:
		[:entity :char |
		char = $& ifFalse:
			[temp _ temp copyReplaceAll: char asString with: '&' , entity , ';']].
	^temp! !

!HVHttpView class methodsFor: 'class initialization' stamp: 'gk 10/24/2003 10:19'!
initialize
	"HVHttpView initialize"

HtmlEntities _ (Dictionary new: 128)
		at: 'amp'	put: $&;
		at: 'lt'		put: $<;
		at: 'gt'		put: $>;
		at: 'quot'	put: $";
		at: 'euro'	put: Character euro;
		yourself.

SafeChars _ Set new.
('1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/-_()".,''@?!!:; ', '﻿åäöÅÄÖéüèáêôâ') do: [:c | SafeChars add: c].
UltraSafeChars _ SafeChars copy.
UltraSafeChars remove: $/; remove: $.



	"#('nbsp' 'iexcl' 'cent' 'pound' 'curren' 'yen' 'brvbar' 'sect' 'uml' 'copy' 'ordf' 'laquo' 'not' 'shy' 'reg' 'hibar' 'deg' 'plusmn' 'sup2' 'sup3' 'acute' 'micro' 'para' 'middot' 'cedil' 'sup1' 'ordm' 'raquo' 'frac14' 'frac12' 'frac34' 'iquest' 'Agrave' 'Aacute' 'Acirc' 'Atilde' 'Auml' 'Aring' 'AElig' 'Ccedil' 'Egrave' 'Eacute' 'Ecirc' 'Euml' 'Igrave' 'Iacute' 'Icirc' 'Iuml' 'ETH' 'Ntilde' 'Ograve' 'Oacute' 'Ocirc' 'Otilde' 'Ouml' 'times' 'Oslash' 'Ugrave' 'Uacute' 'Ucirc' 'Uuml' 'Yacute' 'THORN' 'szlig' 'agrave' 'aacute' 'acirc' 'atilde' 'auml' 'aring' 'aelig' 'ccedil' 'egrave' 'eacute' 'ecirc' 'euml' 'igrave' 'iacute' 'icirc' 'iuml' 'eth' 'ntilde' 'ograve' 'oacute' 'ocirc' 'otilde' 'ouml' 'divide' 'oslash' 'ugrave' 'uacute' 'ucirc' 'uuml' 'yacute' 'thorn' 'yuml' ) withIndexDo: [:each :index | HtmlEntities at: each put: (index + 159) asCharacter isoToSqueak]"! !

!HVHttpView class methodsFor: 'instance creation' stamp: 'gk 11/4/2004 13:04'!
on: aModel
	"Create a new view on a model.
	We set the model before initializeing so that it
	can use the model."

	^super basicNew model: aModel; initialize; yourself! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 3/3/2004 11:55'!
rootView
	"Return class to use as root view. Override to provide your own.
	Default is the generic HVRootView."

	^HVRootView! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/15/2004 14:51'!
services
	"Return all services."

	^ApplicationService services! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:06'!
start
	"Start service on default port in deployment mode."

	^self startOn: self defaultPort mode: #deployment! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:06'!
startDebug
	"Start service on default port in debug mode."

	^self startOn: self defaultPort mode: #debug! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:06'!
startDebugOn: portNum
	"Start service on port <portNum> in debug mode."

	^self startOn: portNum mode: #debug! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:11'!
startOn: portNum
	"Start service on port <portNum> in deployment mode."

	^self startOn: portNum mode: #deployment! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/9/2004 14:04'!
startOn: portNum mode: mode
	"Start service on port <portNum> in mode <mode>.
	We first create a root view that use us as default view class
	and then we start the root view."

	^(self rootView
		model: self createModel
		alias: self defaultAlias
		viewClass: self defaultViewClass)
		startOn: portNum mode: mode; yourself! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 3/14/2006 14:12'!
stop
	"Stop and unregister service with name of class."

	^(ApplicationService serviceNamed: self name ifAbsent: [^self]) unregister! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/15/2004 14:50'!
stopAll
	"Stop and unregister all services."

	^ApplicationService services do: [:s | s unregister]! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 11/6/2003 14:51'!
useSessions
	"By default we don't."

	^false! !

!HVHttpView methodsFor: 'html' stamp: 'gk 3/31/2005 14:43'!
fixForHtml: string
	^HVHttpView escapeForHtml: string! !

!HVHttpView methodsFor: 'initialize-release' stamp: 'gk 12/19/2003 13:31'!
initialize
	"Do nothing."! !

!HVHttpView methodsFor: 'accessing' stamp: 'gk 10/24/2003 10:26'!
model
	^model! !

!HVHttpView methodsFor: 'accessing' stamp: 'gk 10/24/2003 10:26'!
model: aModel
	model _ aModel! !

!HVHttpView methodsFor: 'responses' stamp: 'gk 4/11/2007 10:05'!
notFound: url
	"Make a not found response."

	HVResponseNotification signal:
		(HttpService current errorResponseStatus: #notFound description: url)! !

!HVHttpView methodsFor: 'responses' stamp: 'gk 3/4/2004 14:31'!
redirectTo: url
	"Make a redirection to another url."

	HVResponseNotification signal:
		(HttpResponse redirectTo: (url isEmpty ifTrue:['/'] ifFalse: [url]))! !

!HVHttpView methodsFor: 'responses' stamp: 'gk 3/4/2004 14:31'!
redirectToDefault
	"Make a redirection to the default url of this view."

	^self redirectTo: self defaultUrl! !

!HVHttpView methodsFor: 'responses' stamp: 'gk 10/12/2005 15:56'!
redirectToLocal: page
	"Make a redirection to another page in this view,
	equaling another method in this class."

	^self redirectTo: (self originalUrlFor: page)! !

HVHttpView subclass: #HVRootView
	instanceVariableNames: 'viewClass coreMod sessionMod alias selectorFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Base'!

!HVRootView commentStamp: 'gk 10/24/2003 10:53' prior: 0!
A HVRootView is a view object that is plugged into Komanche. It holds the model and it is the first entrypoint of a web application. The method #process: is called with a HttpRequest as an argument and Komanche expects a HttpResponse being returned.

The root view typically instantiates a transient view object on the model, put the request into the view and then sends #dispatch to it.

Eventually it will return a result object that is transformed into an HttpResponse.

Simple applications typically don't subclass HVRootView, instead an instance is created when the application is started, see for example HVHttpView class>>startOn:.!

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:08'!
alias: anAlias
	"This relies on model being set in initialize."

	^self model: nil alias: anAlias viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:08'!
model: aModel
	"Create a persistent root view that can be plugged into Komanche."

	^self model: aModel alias: nil viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:07'!
model: aModel alias: anAlias
	"Create a persistent root view that can be plugged into Komanche."

	^self model: aModel alias: anAlias viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 12/9/2003 16:10'!
model: aModel alias: anAlias viewClass: aViewClass
	"Create a persistent root view that can be plugged into Komanche."

	^(super on: aModel) alias: anAlias viewClass: aViewClass! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 11/4/2004 13:05'!
new
	"This relies on that at least model and viewClass
	is set in initialize. Note: in later Squeaks this
	method is superfluous, but it makes it work in
	old Squeaks too."

	^super basicNew initialize! !

!HVRootView class methodsFor: 'defaults' stamp: 'gk 3/3/2004 11:55'!
rootView
	"Return class to use as root view. Override to provide your own.
	Default is self."

	^self! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/25/2004 16:11'!
alias: anAlias viewClass: aClass
	"Set the default alias and viewClass if not already set."

	alias ifNil: [alias _ anAlias].
	viewClass ifNil: [viewClass _ aClass]
! !

!HVRootView methodsFor: 'dispatch' stamp: 'gk 4/2/2004 11:21'!
allowedSelector: aSelector forView: aView
	"Answer true if <aSelector> is ok to call from a URL
	to the view <aView>. Default implementation is to
	use the pluggable filter block."

	^selectorFilter copy value: aSelector value: aView! !

!HVRootView methodsFor: 'dispatch' stamp: 'gk 12/19/2003 13:48'!
allowedSrcSelector: aSelector forView: aView
	"Answer true if it is ok to view the source
	of <aSelector> in the view <aView>.
	Default implementation is the same as for execution."

	^self allowedSelector: aSelector forView: aView! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/4/2004 15:15'!
categoryOfElement: selector inClassOrSuperclass: class
	"Find first category of selector up the superclass chain."

	^class ifNotNil: [
		^(class organization categoryOfElement: selector)
			ifNil: [self categoryOfElement: selector inClassOrSuperclass: class superclass]]! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/4/2004 15:12'!
defaultSelectorFilter
	"Override this method to supply your own selectorFilter.
	Or plug it in using #selectorFilter:"

	^[:selector :view |
		(view respondsTo: selector) and: [
			(self categoryOfElement: selector inClassOrSuperclass: view class) = #urls]]! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 3/4/2004 14:13'!
getTopView: request
	"Default way of instantiating a top view for the model.
	If the viewClass is set we use that, otherwise we try
	a double dispatch on the model using #viewFor:."

	^viewClass
		ifNotNil: [viewClass on: model parent: self]
		ifNil: [(model respondsTo: #viewFor:)
				ifTrue: [model viewFor: self]
				ifFalse: [self error: 'Do not know which view to instantiate!!']]! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/3/2004 12:31'!
initialize
	"Default selector filter is to verify that
	the view responds to the selector and that
	it is in the method category 'urls'."

	alias _ ''.
	selectorFilter _ self defaultSelectorFilter! !

!HVRootView methodsFor: 'views' stamp: 'gk 12/10/2003 10:24'!
parentsDo: aBlock
	"Don't have a parent, do nothing."
! !

!HVRootView methodsFor: 'views' stamp: 'gk 12/10/2003 10:25'!
parentsDoReverse: aBlock
	"Have no parent, do nothing."! !

!HVRootView methodsFor: 'comanche' stamp: 'edc 10/15/2009 15:51'!
process: request
	"Process the request. This is the method that is called by Comanche.
	Given the view we stick the request into it and let it take over.
	When the result is returned we turn it into a proper HttpResponse.
	A special notification can be signaled to return a specific response and
	bypassing the call chain."

	| view |
	


	(request url endsWith: '/favicon.ico') ifTrue: [
		^HttpResponse fromString: 'favicon.ico not supported'].
	view := self getTopView: request.
	view request: request. "normally not needed when using #viewFor: but here it is"
	[^view dispatch asHttpResponseTo: request]
		on: HVResponseNotification do: [:ex | ^ex response]! !

!HVRootView methodsFor: 'comanche' stamp: 'edc 10/15/2009 07:21'!
processHttpRequest: anHttpRequest 
| view |
view := self getTopView: anHttpRequest.
view processHttpRequest: anHttpRequest! !

!HVRootView methodsFor: 'private' stamp: 'gk 12/19/2003 00:07'!
request
	"I am the root view and do not hold the request
	because I need to be Process safe."

	^nil! !

!HVRootView methodsFor: 'accessing' stamp: 'gc 8/1/2007 12:58'!
response
	^ nil! !

!HVRootView methodsFor: 'views' stamp: 'gk 11/6/2003 17:26'!
rootView
	"Return the view at the root, that's me."

	^self! !

!HVRootView methodsFor: 'accessing' stamp: 'gk 12/19/2003 13:30'!
selectorFilter
	"Return the filter used in #allowedSelector:forView:"

	^selectorFilter! !

!HVRootView methodsFor: 'accessing' stamp: 'gk 12/19/2003 13:30'!
selectorFilter: aBlock
	"Set the filter used in #allowedSelector:forView:.
	It should implement #value:value: with
	the selector and the view instance as arguments."

	selectorFilter _ aBlock! !

!HVRootView methodsFor: 'defaults' stamp: 'gk 3/4/2004 14:20'!
serviceName
	"By default we use class name of the HVRootView subclass,
	otherwise the class name of viewClass if we have one."

	^(viewClass notNil and: [self class = HVRootView])
		ifTrue: [viewClass name]
		ifFalse: [self class name]! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 4/7/2005 23:11'!
sessionTimedOut: session
	"Delegate if implemented."
	
	(model respondsTo: #sessionTimedOut:) ifTrue:[ model sessionTimedOut: session ]! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 11/6/2003 17:18'!
sessionsDo: aBlock
	"Iterate over sessions. Only works if we have turned sessions on,
	check implementors of #useSessions."

	^sessionMod sessionsDo: aBlock
! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:13'!
start
	"Start service on default port in deployment mode."

	^self startOn: self class defaultPort mode: #deployment! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:13'!
startDebug
	"Start service on default port in debug mode."

	^self startOn: self class defaultPort mode: #debug! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:13'!
startDebugOn: portNum
	"Start service on port <portNum> in debug mode."

	^self startOn: portNum mode: #debug! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:13'!
startOn: portNum
	"Start service on port <portNum> in deployment mode."

	^self startOn: portNum mode: #deployment! !

!HVRootView methodsFor: 'start-stop' stamp: 'edc 10/15/2009 07:54'!
startOn: portNum mode: mode
	"Creates a new standalone http service with this root view plugged in."

	|  name useSessions ma |
	name _ self serviceName.
	useSessions _ self useSessions.
	ma := ModuleAssembly core.
	coreMod _ ma currentModule.
	ma logTo: (KomLogger on: Transcript).
	useSessions ifTrue: [
		ma trackSessions.
		sessionMod _ ma currentModule.
		ma sessionTimeout: 30].
	alias = ''
		ifTrue: [ma addPlug: [:request | self process: request]]
		ifFalse: [ma alias: alias
					to: [ma addPlug: [:request | self process: request]]].
	^(HttpService startOn: portNum named: name)
		plug: ma rootModule; mode: mode! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 3/3/2004 12:13'!
stop
	"Only unregisters the Comanche service,
	override to do proper things when service is stopped."

	self class stop! !

!HVRootView methodsFor: 'views' stamp: 'gk 11/6/2003 14:27'!
topView
	"I have no parent and is thus the top view."

	^self! !

!HVRootView methodsFor: 'private' stamp: 'gk 12/9/2003 16:41'!
urlStream
	"I am the root view and can not hold a urlStream
	because I need to be Process safe."

	^nil! !

!HVRootView methodsFor: 'defaults' stamp: 'gk 3/3/2004 13:03'!
useSessions
	"By default we check with viewClass if we have one,
	otherwise false."

	^viewClass ifNil: [false] ifNotNil: [viewClass useSessions]! !

HVHttpView subclass: #HVTransientView
	instanceVariableNames: 'parent title urlStream urlOriginalPosition request response currentCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Base'!

!HVTransientView commentStamp: 'jlh 12/19/2003 10:30' prior: 0!
A HVHttpView is a web user interface.

A view has a domain object as a model, and thus the HttpView hierarchy often typically mirrors the domain class hierarchy. It also has a reference to it's parent view which ultimately is a HVRootView.

A view is instantiated for every request which means that it does not have to care about multiple Processes (each view instance is only used by one Process - the one started to serve the request) - but since the model can be shared with other views either the model needs to care or the views needs to serialize their access to the model.

The HVRootView is not instantiated for every request - it represents the web application itself that is plugged into Komanche - so it must be written Process safe.

A view holds a reference to the request - 'req' - which it is given upon instantiation. Most of the interaction with the request is done easier through the use of an HVHtmlBuilder which has a lot of support for handling HTML Forms.

Based on the url, the framework will call the method with the same name. For a method to be called from a url the method must be in the 'urls' category. If no method name is given in the url the default method #default is called. The methods should return something responds to #asHttpResponseTo:. The root view sends this message to the object returned and returns the result to Komanche which expects an HttpResponse.

String implements #asHttpResponseTo: so the simplest would be to just return a String with HTML in it. A better approach would be to use an HVHtmlBuilder. Look at HVTodoListView for an example.

Finally HVHttpView includes some simple facilities for keeping track of the user and the current user account.!

HVTransientView subclass: #HVFileDirectoryView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Examples'!

!HVFileDirectoryView commentStamp: 'gk 12/10/2003 14:22' prior: 0!
This web app just gives a file upload/delete user interface on a directory in a filesystem.
Methods commented in detail.

"Fire this app up on port 8080"
HVFileDirectoryView start

"Stop it"
HVFileDirectoryView stop
!

!HVFileDirectoryView class methodsFor: 'as yet unclassified' stamp: 'edc 1/17/2010 18:00'!
createModel
	"This is called when the application is started."
	
	
	^ FileDirectory default directoryNamed: 'uploads/'! !

!HVFileDirectoryView methodsFor: 'urls' stamp: 'edc 1/17/2010 18:02'!
default
	"Show the web page for uploading and deleting files."
	"Create a HTML builder object."
	| b checkBoxes fn size deleteButton |
	b := self builder.
	"Start the page, add a heading level 1."
	b start; h1: 'Files'.
	"Start a multipart form with a POST url to the local view instance +
	'/upload'. This will make the POST go the method #upload in this class."
	b postFormMultiPartLocal: 'upload'.
	"Add an input file field and a submit button with the text 'Upload'.
	In this case we don't care to hold onto the button, the POST goes to
	the #upload method anyways."
	b inputFile; submit: 'Upload'.
	"Add a break making it look better, ending the form and starting a new
	form with no url specified - this makes the POST go to this method by
	default."
	b br; endForm; postForm.
	"Create a table with 3 columns and specify the column labels."
	b
		columnsHeads: #('Choose' 'Filename' 'Size' )
		do: ["Create a dictionary to hold the checkbox widgets for each file
			using the filename as the key."
			checkBoxes := Dictionary new.
			model entries
				do: [:e | "For all entries in the directory we pick out filename
					and size."
					e isDirectory
						ifFalse: [fn := e first.
							size := e last.
							"Add a checkbox to the page and take the
							resulting widget and stuff it into the
							dictionary using the
							filename as key."
							checkBoxes at: fn put: b inputCheckbox.
							"#colTab moves to the next column in the table,
							there we
							add a link for each file that will point to the
							#file method in this class
							with the filename added at the end of the url.
							#colTab also automatically moves to the next
							row in the table."
							b colTab; linkLocal: 'file/' , fn text: fn; colTab; html: size printString; colTab]]].
	"Add a delete button with label."
	deleteButton := b submit: 'Delete selected files'.
	"End the form, add a horisontal ruler, a link to the source of this
	method and end the web page."
	b endForm; hr; srcLink; end.
	"Ok, if this was a POST of the second form the deleteButton will know it
	and the code will be run. We loop through all entries in the dictionary
	and depending on the #value of each checkbox we delete the file."
	deleteButton
		ifPressed: [self halt.checkBoxes
				keysAndValuesDo: [:name :box | box value
						ifTrue: [model deleteFileNamed: name]].
			"We have changed the model (deleted files) so instead of
			returning the page we just built above, because it contains
			rows for files
			that are now deleted - we issue a redirect causing a GET reload
			of this page."
			^ b redirectToDefault].
	"Return the builder which will cause it to be converted to a HTTP
	response and thus
	have it render the page back to the user. The last thing HV does is to
	send #asHttpResponseTo:
	to the object returned from the page methods, see HVRootView>>process:
	which is the method
	called by Comanche."
	^ b! !

!HVFileDirectoryView methodsFor: 'urls' stamp: 'gk 12/10/2003 01:06'!
file
	"Download a file."

	| fileName stream |
	"First we pick out the filename and turn the characters escaped by the browser back."
	fileName _ (self urlStream next) unescapePercents.

	"If the filename is empty we use the inherited method #serverError to return a simple error page.
	Oterwise we open the file and if it exists we finally return the stream which will be converted
	into a HTTP response just before being returned to Comanche."
	fileName isEmpty
		ifTrue: [^self serverError: 'No filename specified in URL.']
		ifFalse:[[stream _ model oldFileNamed: fileName]
					on: FileDoesNotExistException
					do: [^self serverError: 'No file found with name: ', fileName]].
	^stream
! !

!HVFileDirectoryView methodsFor: 'initialize-release' stamp: 'gk 4/12/2007 23:13'!
initialize
	"We set the title of the view - it will show up as the page title."

	super initialize.
	title _ model pathName! !

!HVFileDirectoryView methodsFor: 'urls' stamp: 'gk 10/31/2003 11:03'!
upload
	"Upload a file."

	"Here we utilize an inherited convenience method to handle uploaded
	files. The block sent to #handleUpload: will be executed for each file
	uploaded. The block needs to take one argument - the filename, and
	should return a stream or nil. If a stream is returned the file contents
	will be written to it and then the stream will be closed. Returning nil
	ignores the file."
	self handleUpload: [:filename |
		"We simple first delete it if it exists and then return a FileStream
		so that the file gets written."
		(model fileExists: filename) ifTrue:[model deleteFileNamed: filename].
		model newFileNamed: filename].

	"We are done, redirect the user to the #default page."
	^self redirectToDefault! !

HVTransientView subclass: #HVHelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Examples'!

!HVHelloWorld commentStamp: 'jlh 12/22/2003 22:35' prior: 0!
This is the minimal web app in HttpView consisting of a single class
inheriting from HVTransientView with a single method called #default.

Well, I added a second variation in method #hello too. :)

You can start the app by simply sending messages to the class:

	HVHelloWorld start
	or
	HVHelloWorld startDebug

...and stop it:

	HVHelloWorld stop

When it is running, surf in at http://localhost:8080 or http://localhost:8080/hello to see it in action!!

Notes:
- The port 8080 is the defaultPort, if you want another port just override that class side method or use startOn:.
- As you can see the path in the url maps automatically to the method name. Just add another method!!
- #startDebug is better than #start when doing development, any bugs will open up the debugger.
- You can stop all apps using #stopAll. !

!HVHelloWorld methodsFor: 'urls' stamp: 'edc 2/4/2010 09:52'!
default
	"The shortest Hello World.
	This is the default method that is run in an HVHttpView
	when no other method has been named in the url.
	It can also be reached by it's name 'default'.
	String implements #asHttpResponseTo: so
	it will be converted to a proper HttpResponse just before being
	handed back to Comanche."
	^ '<EMBED 
    TYPE="application/x-squeak-source"
    SRC="test.sts"
    ALIGN="CENTER"
    WIDTH="1024"
    HEIGHT="768"
    PLUGINSPAGE="http://squeakland.org/detect.html">
</EMBED>'! !

!HVHelloWorld methodsFor: 'urls' stamp: 'gk 12/10/2003 11:22'!
hello
	"A slightly longer version using HVHtmlBuilder.
	This is how you normally build HTML pages:
		- Get the builder
		- Feed it with messages to create HTML
		- Return it to Comanche, it will then render the page."

	| builder |
	builder _ self builder.
	builder start; h1: 'Hello world!!'.
	builder p: 'It is a brand new day.'.
	builder hr; srcLink; end.
	^builder! !

!HVHelloWorld methodsFor: 'urls' stamp: 'gk 4/12/2007 23:08'!
hellocanvas
	"An even longer version using the lower level canvas API."

	| canvas |
	canvas := self canvas.
	canvas html: [
		canvas head: [canvas title: self title].
		canvas body: [
			canvas h1 text: 'Hello world!!'.
			canvas p text: 'It is an even newer day.']].
	 ^canvas! !

HVTransientView subclass: #HVHelloWorldPhoto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Examples'!

!HVHelloWorldPhoto commentStamp: 'edc 10/15/2009 06:52' prior: 0!
HVHelloWorldPhoto startDebugOn: 8085
	or
	HVHelloWorldPhoto startDebug
	
HVHelloWorldPhoto stop!

!HVHelloWorldPhoto methodsFor: 'as yet unclassified' stamp: 'edc 2/24/2006 15:36'!
default
	"A slightly longer version using HVHtmlBuilder.
	This is how you normally build HTML pages:
		- Get the builder
		- Feed it with messages to create HTML
		- Return it to Comanche, it will then render the page."

	| builder |

	builder := self builder.

	builder p: 'It is a brand new day.'.
builder image: 'http://img319.imageshack.us/img319/6466/rosario16hk.jpg' description: ''.
	builder hr; srcLink; end.
	^builder! !

!HVHelloWorldPhoto methodsFor: 'as yet unclassified' stamp: 'edc 9/23/2009 19:19'!
ip
	| stream |
	stream := HTTPSocket httpGet: 'http://checkip.dyndns.com'.
	stream upToAll: 'IP Address: '.
	stream := stream upTo: $<.
	^ stream! !

HVTransientView subclass: #HVRandomPhoto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Examples'!

!HVRandomPhoto commentStamp: 'edc 9/4/2009 11:50' prior: 0!
HVRandomPhoto startDebugOn: 8080
	or
	HVRandomPhoto stop!

!HVRandomPhoto methodsFor: 'urls' stamp: 'edc 9/4/2009 11:53'!
default

|  ma dirName listaArchivos choose builder |
self halt.
ma := ModuleAssembly core.

	ma
		logTo: (KomLogger on: (FileStream oldFileNamed: 'server.log')).
dirName := '/Users/edgar/Sites/WalkingOnRosario/'.
ma documentRoot: dirName.
	
listaArchivos := (FileDirectory on: dirName) entries select: [:ea| ea isDirectory not].
listaArchivos := listaArchivos copyWithout: (listaArchivos at: 1).

choose :=  (listaArchivos atRandom) name.




	builder := self builder.

	builder start;  html:  '<h3><font color=',HVHtmlColorPalette colorRandom, '>',choose ,'</font color></h3>'.
	builder image: 'http://www.morphle.com/~edgar/WalkingOnRosario/',choose  description: nil.


	builder hr; srcLink; end.
	^builder! !

HVTransientView subclass: #HVSimpleForms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Examples'!

!HVSimpleForms commentStamp: 'gk 12/10/2003 14:22' prior: 0!
This class shows off most of the Forms abilities of HVHtmlBuilder.

"Fire this app up on port 8080"
HVSimpleForms start

"Stop it"
HVSimpleForms stop
!

!HVSimpleForms methodsFor: 'urls' stamp: 'gk 2/19/2004 15:54'!
autosubmit

	| builder field button |
	builder _ self builder.
	builder start; h1: 'Howdy!!'.
	builder p: 'What is your name?'.
	builder postForm.
	field _ builder selectObjectsFirstSelected: #(Hej Hejsan) .
	field autoSubmit: true.
	button _ builder submit.
	builder endForm.
	builder p: 'You selected ', field value asString, '!!'.
	builder hr; srcLink; end.
	^builder! !

!HVSimpleForms methodsFor: 'urls' stamp: 'gc 11/3/2007 22:28'!
megaform1
	"Exercising some forms stuff."

	| b button checkbox checkbox2 code result codeResult |
	b _ self builder.
	b start; h1: 'Megaform'; postForm.

	"Add a checkbox, this box will either be unchecked for a normal GET
	or be checked if the user checks it and presses submit (a POST)."
	checkbox _ b html: 'Is Squeak great?'; inputCheckbox.

	"Add a checkbox, this box will be checked per default.
	If the form shows a proped model for editing typically we pick the value
	from the model object."
	checkbox2 _ b br; html: 'Does Java suck?'; inputCheckboxValue: true.

	"Add a textarea."
	code _ b br; html: 'Enter some code:';br; textArea.

	"Add a paragraph."
	b p: 'Result of code:'.
	"Add a variable - it is simply a placeholder for some HTML."
	result _ b var.
	
	"Add two breaks and a submit button, end the form."
	button _ b br; br; submit: 'Hit me'.
	b endForm.

	"The values of the widgets can be both used and set even if this is not a POST.
	Check if checkbox2 is checked, it should be even on the first GET."
	checkbox2 value ifTrue: [checkbox2 suffix: 'Of course it does...'].

	"If there is no code, stuff some in there."
	code value isEmpty ifTrue: [code value: '3+4'].

	"Was the button pressed?"
	button ifPressed: [
		"If checkbox is checked we add some HTML as a prefix just before the checkbox.
		Note that the actual rendering of the page happens after this method has returned
		so we can manipulate the elements of the page at this point.
		The #error: method simply adds a suffix in red."
		checkbox value
			ifTrue: [checkbox prefix: ' You bet!! ']
			ifFalse: [checkbox error: '<- Come on, check it!!'].

		checkbox2 value
			ifTrue: [checkbox2 suffix: 'Right on!!']
			ifFalse: [checkbox2 error: '<- Come on, check it!!'].
	].
	b hr; srcLink; end.

	"Compile and execute the code. Note that I cobbled this together - I tried adding a bit
	of error handling etc. Not sure how to do this properly."
	codeResult _ [Compiler evaluate: code value logged: false] on: Exception do: [:ex |
						ex class = InMidstOfFileinNotification
							ifTrue: [ex resume: true]
							ifFalse: [ex return: ex]].

	"As a proof that the page is not yet rendered - we can finally stuff in the result of the code
	into the variable we embedded into the page."
	result value: codeResult printString.
	^b! !

!HVSimpleForms methodsFor: 'urls' stamp: 'gk 12/17/2003 13:42'!
megaform2
	"Exercising some forms stuff."

	| b button age years hidden lastAge pass pass2 radioGroup radio1 radio2 radio3 message |
	b _ self builder.
	b start; h1: 'Megaform 2'; postForm.

	"Add a group of radio buttons working as checkboxes,
	The chain of radios need to be ended using endRadio.
	If value isn't given the first one is selected by default. Only one is
	allowed to be selected at any time. Apple will be true and Orange will
	be ignored and set to false. If all has used #inputRadio (without supplying a value)
	then Banana would have been true."
	radio1 _ b html: 'Banana: '; inputRadio.
	radio2 _ b html: radio1 value asString; br; html: 'Apple: '; inputRadioValue: true.
	radio3 _ b html: radio2 value asString; br; html: 'Orange: '; inputRadioValue: true.
	b html: radio3 value asString; endRadio.

	"Add them as one widget, works like selectObjects:."
	radioGroup _ b br; br; html: 'Select fruit:'; br; radioGroup: {'Banana'. 'Apple'. 'Orange'}.
	radioGroup vertical: true.
	b br; columns: 2.		

	"Add a input field for a number. A number field is a simple subclass of text field."
	age _ b html: 'How old are you?'; colTab; inputNumber.

	"Add a input field for a number with a default value different than 0."
	years _ b colTab; html: 'How old is Squeak?'; colTab; inputNumberValue: 9.
	b endColumns; br.

	"Add a hidden field, see below."
	hidden _ b inputHidden.

	"Add a variable that we will fill a few lines down."
	message _ b var.

	"Add a password."
	pass _ b br; br; html: 'Password: '; inputPassword.
	pass2 _ b br; html: 'Verify: '; inputPassword.

	(pass value isEmpty and: [pass2 value isEmpty]) ifFalse: [
		pass value = pass2 value
			ifTrue: [message value: '<b>Verified correctly!!</b>']
			ifFalse: [message value: '<b>Verified incorrectly!!</b>']].
	
	"Add two breaks and a submit button, end the form."
	button _ b br; br; submit: 'Hit me'.
	b endForm.

	"Was the button pressed?"
	button ifPressed: [
		b p: 'You selected a ', radioGroup value, '!!'.
		"Pick out the hidden field value, hidden fields hold Strings so we convert it to a number."
		lastAge _ hidden value asNumber.

		"We stuff the entered age into the hidden field. This means that we will get
		it back on next post - thus we 'remember' the age by storing it in the page."
		hidden value: age value.
	].

	b p: 'You are ', age value printString, ' years old. Last time you entered ',
			lastAge printString, ' years.'.
	b p: 'Squeak is ', years value printString, ' years old.'.

	b hr; srcLink; end.
	^b! !

!HVSimpleForms methodsFor: 'urls' stamp: 'gk 12/10/2003 13:10'!
simplefield
	"This method is called when accessing http://localhost/hello.
	It is first called with a GET thus building the form with an empty
	text field and showing it. The #postForm defaults to an POST url
	pointing to this method again. So when the user press submit
	we end up here again and the form is built the second time.
	This time around the builder object sees that there is a value
	for the textfield and puts that into the HVHtmlInputText instance -
	this happens when the widget is created using the #inputText method,
	so that we can get it by sending #value to it later in the method."

	| builder field button |
	builder _ self builder.
	builder start; h1: 'Howdy!!'.
	builder p: 'What is your name?'.
	builder postForm.
	field _ builder inputText.
	button _ builder submit.
	builder endForm.
	builder p: 'Your name is ', (button ifPressed: [field value] ifNot:['unknown!!']), '!!'.
	builder hr; srcLink; end.
	^builder! !

HVTransientView subclass: #HVSwikiView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Extras-Swiki'!

!HVSwikiView methodsFor: 'swikification' stamp: 'gc 11/4/2007 13:47'!
resolveTag: aTag builder: aBuilder
	"Translate the String <aTag> to something, like a link during
	parsing of Swiki style Strings. Returning false means we did
	not handle it. If a subclass handles it by producing something
	on the builder it should return true."

	^false! !

HVTransientView subclass: #HVTOCView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Extras-TOCs'!

!HVTOCView methodsFor: 'table of contents' stamp: 'gc 11/4/2007 13:42'!
clearJustClosed
	"Make sure the 'closed' entries are flushed out,
	but only if this is not an expand/collapse request."
	
	| toc tocString tocSym cmd |
	cmd _ urlStream pathElements last utf8ToIso isoToSqueak.
	(cmd = 'expandtoc' or: [cmd = 'collapsetoc']) ifFalse: [
		cmd _ cmd, '-closed'. "reused to match current URL below"
		tocSym := self tocSymbol.
		toc := self attributeAt: tocSym ifAbsent: [nil].
		toc ifNotNil: [
			toc := (((toc findTokens: $,)
					reject: [:s | (s endsWith: '-closed') and: [s ~= cmd]])
						collect: [:ss | ss asSymbol]) asSet.
			tocString := String streamContents: [:s |
				toc do: [:sym | s nextPutAll: sym, ',']]]
			ifNil: [tocString := ''].
		self attributeAt: tocSym put: tocString]! !

!HVTOCView methodsFor: 'urls' stamp: 'gc 11/4/2007 13:44'!
collapsetoc
	"Collapse given entry by updating the session info on which entries to show.
	If the current URL is within the closed tree we redirect to the
	entry that was closed and also mark it specifically so that it isn't
	autoexpanded immediately since we normally autoexpand selected entries."

	| entryName toc tocString tocSym stream goNext |
	tocSym := self tocSymbol.
	entryName := request getFields at: #entry.
	toc := self attributeAt: tocSym ifAbsent: [^ self reloadWithoutLast].
	toc := ((toc findTokens: $,) collect: [:s | s asSymbol]) asSet.
	toc remove: entryName asSymbol ifAbsent: [nil].
	stream := urlStream.
	stream setToEnd.
	goNext := nil.
	
	[stream peek = entryName 
		ifTrue: 
			[toc add: (entryName , '-closed') asSymbol.
			stream next.
			goNext := stream pathWith: entryName squeakToIso isoToUtf8].
	stream position = 1 or: [goNext notNil]] 
			whileFalse: [stream back].
	tocString := String 
				streamContents: [:s | toc do: [:sym | s nextPutAll: sym , ',']].
	self attributeAt: tocSym put: tocString.
	goNext ifNotNil: [^ self reload: goNext utf8ToIso isoToSqueak].
	^ self reloadWithoutLast! !

!HVTOCView methodsFor: 'table of contents' stamp: 'gc 11/4/2007 13:43'!
currentToc
	"Get the TOC for the request."

	^KomSession current attributes at: self tocSymbol ifAbsent: [nil]! !

!HVTOCView methodsFor: 'table of contents' stamp: 'gc 11/4/2007 13:43'!
expandEntry: aTocEntry
	"Expand given entry by updating the session info on which entries to show."

	^self expandEntryName: aTocEntry name! !

!HVTOCView methodsFor: 'table of contents' stamp: 'gc 11/4/2007 13:43'!
expandEntryFull: aTocEntry
	"Expand given entry if it has children
	and make sure all parents of the entry are expanded
	by updating the session info on which entries to show."

	| entry |
	entry := aTocEntry.
	[entry isRoot] whileFalse: [
		entry hasChildren
			ifTrue: [self expandEntryName: entry name].
		entry := entry parent]! !

!HVTOCView methodsFor: 'table of contents' stamp: 'gc 11/4/2007 13:43'!
expandEntryName: entryName
	"Expand given entry by updating the session info on which entries to show.
	If the entry was just closed we do not expand it."

	| toc tocString tocSym closed |
	tocSym := self tocSymbol.
	toc := self attributeAt: tocSym ifAbsent: [nil].
	toc ifNotNil: [
		toc := ((toc findTokens: $,) collect: [:s | s asSymbol]) asSet.
		closed _ (entryName, '-closed') asSymbol.
		(toc includes: closed) ifFalse: [toc add: entryName asSymbol].
		tocString := String streamContents: [:s | toc do: [:sym | s nextPutAll: sym, ',']]]
	ifNil: [tocString := entryName].
	self attributeAt: tocSym put: tocString! !

!HVTOCView methodsFor: 'urls' stamp: 'gc 11/4/2007 13:44'!
expandtoc
	"Expand given entry in request by updating the session
	info on which entries to show."

	self forceExpandEntryName: (request getFields at: #entry).
	^ self reloadWithoutLast! !

!HVTOCView methodsFor: 'table of contents' stamp: 'gc 11/4/2007 13:43'!
forceExpandEntryName: entryName
	"Expand given entry by updating the
	session info on which entries to show."

	| toc tocString tocSym |
	tocSym := self tocSymbol.
	toc := self attributeAt: tocSym ifAbsent: [nil].
	toc ifNotNil: [
		toc := ((toc findTokens: $,) collect: [:s | s asSymbol]) asSet.
		toc add: entryName asSymbol.
		tocString := String streamContents: [:s | toc do: [:sym | s nextPutAll: sym, ',']]]
	ifNil: [tocString := entryName].
	self attributeAt: tocSym put: tocString! !

!HVTOCView methodsFor: 'table of contents' stamp: 'gc 11/4/2007 13:43'!
setToc: aToc 
	request session attributes at: self tocSymbol put: aToc! !

!HVTOCView methodsFor: 'table of contents' stamp: 'gc 11/4/2007 13:43'!
tocRenderClass
	"Default class."

	^HVTOCTreeRenderer! !

HVTransientView subclass: #HVTodoListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Examples'!

HVTodoListView class
	instanceVariableNames: 'portNumber'!

!HVTodoListView commentStamp: 'edc 10/31/2009 11:52' prior: 0!
This is a minimal todo list web application.

The class side method #createModel is called once when the application is started. At that point a HVRootView is instantiated that holds the model and the root view is plugged into Komanche. This class is then instantiated for each request and has the root view as a parent.

This class implements a trivial initialize method in order to set the prefix and title of the webpage. It then implements two urls:

- The default page which shows the todolist and has a form for adding items and links for removing items.
- The removeitem page which is the method called when a remove link is clicked. It redirects back to the default page.

"Fire this app up on port 8080"
HVTodoListView startDebugOn:8888

"Stop it"
HVTodoListView stop
!

HVTodoListView class
	instanceVariableNames: 'portNumber'!

!HVTodoListView class methodsFor: 'startup' stamp: 'gk 12/10/2003 11:22'!
createModel
	"This is called automatically when the web application is started."

	^HVTodoList new! !

!HVTodoListView class methodsFor: 'as yet unclassified' stamp: 'edc 10/31/2009 11:48'!
portNumber
^ portNumber asString! !

!HVTodoListView class methodsFor: 'as yet unclassified' stamp: 'edc 10/31/2009 11:48'!
portNumber: aPortNumber
portNumber := aPortNumber! !

!HVTodoListView class methodsFor: 'as yet unclassified' stamp: 'edc 10/31/2009 11:51'!
startDebugOn: aPortNumber
self portNumber: aPortNumber.
super startDebugOn: aPortNumber! !

!HVTodoListView methodsFor: 'urls' stamp: 'edc 10/31/2009 12:56'!
bajar

| id removeItem temp|
		
	id := (request getFields at: 'id') asNumber.
	removeItem := model items at: id.
	
	temp:= model items at:id.
	model items at: id put: (model items at: id +1).
	model items at: (id+1) put: temp.
	^ self redirectToDefault! !

!HVTodoListView methodsFor: 'urls' stamp: 'edc 1/28/2010 09:22'!
bajarPict
	^ (SimpleButtonMorph newWithLabel: 'Bajar') imageForm! !

!HVTodoListView methodsFor: 'urls' stamp: 'edc 2/15/2010 09:56'!
default
	"This is the default method that is run in an HVHttpView
	when no other method has been named in the url.
	It can also be reached by it's name 'default'."
	| b item count button |
	
	b := self builder.
	b start; h1: 'Todo list'.
	count := 1.
	item := b postForm; html: 'Add item: '; inputTextSize: 40.
	button := b submit.
	button
		ifPressed: [model addItem: item value].
	b
		ol: model items
		do: [:i | 
			b
				html: (b buttonImage: '/subirPict/' linkTo: 'subir?id=' , count fullPrintString).
			b
				html: (b buttonImage: '/bajarPict/' linkTo: 'bajar?id=' , count fullPrintString).
			b linkLocal: 'removeitem?id=' , count fullPrintString text: 'R'.
			b html: ' ' , i.
			count := count + 1].
	b endForm; hr; srcLink; end.
	^ b 
! !

!HVTodoListView methodsFor: 'initialize-release' stamp: 'gk 4/12/2007 23:13'!
initialize
	"We set the title of the view - it will show up as the page title."

	super initialize.
	title _ 'Todo'! !

!HVTodoListView methodsFor: 'urls' stamp: 'edc 10/31/2009 12:53'!
removeitem
	"Remove an item in the todolist. Here we pick out
	the index from the url with some low level methods in the HttpRequest
	object held in the instance variable req.
	When we are finished we do a redirect to the default page,
	which means that the web browser will reload the #default method in this view."

	| id removeItem |
	
	id := (request getFields at: 'id') asNumber.
	removeItem := model items at: id.
	model removeItem: removeItem.
	^ self redirectToDefault! !

!HVTodoListView methodsFor: 'urls' stamp: 'edc 10/31/2009 12:53'!
subir

		| id removeItem temp|
		
	id := (request getFields at: 'id') asNumber.
	removeItem := model items at: id.
	
	temp:= model items at:id.
	model items at: id put: (model items at: id -1).
	model items at: (id-1) put: temp.
	^ self redirectToDefault! !

!HVTodoListView methodsFor: 'urls' stamp: 'edc 10/31/2009 12:18'!
subirPict
^(SimpleButtonMorph newWithLabel: 'Subir')  imageForm ! !

!HVTransientView class methodsFor: 'defaults' stamp: 'gc 8/25/2008 18:27'!
canvasClass
	^ HVXHTMLCanvas! !

!HVTransientView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 10:32'!
on: aModel parent: aParent
	"Create a new view on a model and with aParent as parent view.
	This is normally done on the fly for each request."

	^(super on: aModel) initializeWith: aParent; yourself! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 11/6/2003 17:24'!
accountsLoggedIn
	"Return all accounts logged in now."

	| accounts account |
	accounts _ OrderedCollection new.
	self rootView sessionsDo: [:session |
		account _ session attributes at: #account ifAbsent: [nil].
		account ifNotNil: [accounts add: account]].
	^accounts! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/19/2003 13:27'!
allowedSelector: aSelector
	"Answer true if <aSelector> is ok to call from a URL.
	Default implementation is to delegate to the rootView
	which represents this web application."

	^self rootView allowedSelector: aSelector forView: self ! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/19/2003 13:55'!
allowedSrcSelector: aSelector
	"Answer true if it is ok to view the source for
	<aSelector> from a URL.
	Default implementation is to delegate to the rootView
	which represents this web application."

	^self rootView allowedSrcSelector: aSelector forView: self ! !

!HVTransientView methodsFor: 'comanche' stamp: 'gc 8/21/2007 18:51'!
asHttpResponseTo: aRequest 
	response := self response.
	currentCanvas ifNotNil: 
			[response contentType: currentCanvas class contentType.
			response contents: currentCanvas render readStream].
	^ response! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 3/26/2004 15:54'!
attributeAt: key ifAbsent: block
	^KomSession current attributes at: key ifAbsent: block! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 3/26/2004 15:55'!
attributeAt: key put: value
	^KomSession current attributes at: key put: value! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 10/20/2005 01:47'!
baseUrl
	"This is the original path of the urlStream."

	^self originalUrl! !

!HVTransientView methodsFor: 'html creation' stamp: 'gc 8/1/2007 12:27'!
builder
	"Create a standard builder with our own request."

	^ HVHtmlBuilder request: request view: self! !

!HVTransientView methodsFor: 'html creation' stamp: 'gc 8/25/2008 18:27'!
canvas
	"Create a standard canvas (newer low level render framework)."

	currentCanvas := self class canvasClass request: request view: self.
	^ currentCanvas! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:48'!
createSelectWidget: values name: name 
	"Create a select widget for forms."

	self deprecated: 'Deprecated, use select* methods in HVHtmlBuilder instead.'.
	^self createSelectWidget: values selected: 1 name: name! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:48'!
createSelectWidget: values selected: selected name: name 
	"Create a select widget for forms."

	self deprecated: 'Deprecated, use select* methods in HVHtmlBuilder instead.'.
	^self createSelectWidget: values selected: selected name: name withIds: true
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:48'!
createSelectWidget: objects selected: selected name: name withIds: withIds
	"Create a select widget for forms."

	| obj id |
	self deprecated: 'Deprecated, use select* methods in HVHtmlBuilder instead.'.
	^String streamContents: [:stream |
		stream nextPutAll: '<select name="', name, '" size="1">'.
		1 to: objects size do: [:n |
			obj _ objects at: n.
			withIds ifTrue:[ id _ obj id] ifFalse:[ id _ n].
			(id = selected)
				ifTrue: [ stream nextPutAll: '<option selected']
				ifFalse: [ stream nextPutAll: '<option' ].
			withIds
				ifTrue: [stream nextPutAll: ' value="', id fullPrintString, '">']
				ifFalse: [stream nextPut: $> ].
			stream nextPutAll: obj name; nextPutAll: '</option>'.
		].
		stream nextPutAll: '</select>']
! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 11/6/2003 14:55'!
currentAccount
	"Get the account for the request."

	| session |
	session _ KomSession current.
	^session ifNotNil: [session attributes at: #account ifAbsent: [nil]]! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 3/3/2004 11:47'!
currentAccount: anAccount
	"Set the account for this session."

	KomSession current attributes at: #account put: anAccount! !

!HVTransientView methodsFor: 'urls' stamp: 'gh 2/11/2002 18:33'!
default
	"This is the default method called on a HttpView if no other
	method is named in the url. It is the base page for the view.
	It should always be implemented. This is a simple test implementation."

	| b |
	b _ self builder.
	b start; h1: 'View for model:'; p: model printString; end.
	^b! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 10/12/2005 01:34'!
defaultUrl
	"Return a url String representing this view's
	original position within the url of the request
	with #default appended."

	^self originalUrlFor: #default! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 5/18/2005 13:59'!
dispatch
	"Dispatch to correct method in this view.
	If dispatchOverride returns something
	different from nil, consider it handled."

	| result |
	result _ self dispatchOverride.
	result ifNotNil: [^result].
	^self dispatchOn: self nextMethod! !

!HVTransientView methodsFor: 'dispatching' stamp: 'edc 10/15/2009 08:13'!
dispatchOn: method 
	"Dispatch to correct method:
	- If method is empty we call #default
	- If the selector is allowed to be executed then we just call it
	- If method is prefixed with 'src' and viewing the source is allowed,
		then we return a HTML page with the source for that method."

	| m |
	
	method isEmptyOrNil ifTrue:[ ^self default ].
	m _ method asSymbol.
	(self allowedSelector: m)
		ifTrue:[^self perform: m].

	"Is it a request for the source?"
	(m beginsWith: 'src')
		ifTrue: [
			m _ (m asString last: (m size - 3)) asSymbol.
			(self allowedSrcSelector: m)
				ifTrue: [^self showSourceFor: m]
				ifFalse: [^self serverError: 'Not allowed to view source']]
		ifFalse: [^self serverError: 'Specified URL: #', method, ' not allowed']! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 4/22/2005 14:57'!
dispatchOverride
	"Handle special urls. Subclass implementors
	should call super first and see if it was handled."

	^nil! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:48'!
endhtml
	"Standard end."

	self deprecated: 'Deprecated, use the HVHtmlBuilder to build HTML instead.'.

^'</body></html>'! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:48'!
endhtml: request
	"Standard end. Attach a link to the source of the page."

	| url slash |
	self deprecated: 'Deprecated, use the HVHtmlBuilder to build HTML instead.'.
	slash _ request url findLast: [:c | c = $/ ].
	url _ (request url copyFrom: 1 to: slash), 'src', (request url copyFrom: slash + 1 to: request url size).
^'<hr><br><font size=-1>', (self link: url text: 'See source for this page'), '</font></body></html>'! !

!HVTransientView methodsFor: 'utilities' stamp: 'gc 8/1/2007 12:27'!
handleUpload: aBlock 
	| fileName stream |
	request isPostMultipart 
		ifTrue: 
			[request multipartFormFieldsDo: 
					[:chunk | 
					chunk fileName isEmptyOrNil 
						ifFalse: 
							[fileName := (chunk fileName findTokens: ':/\') last.
							stream := aBlock value: fileName.
							stream ifNotNil: [[chunk saveToStream: stream] ensure: [stream close]]]]]! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'gc 8/1/2007 12:44'!
initialize
	super initialize.
	title _ 'No title set'.
	response := HttpResponse new.! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'gc 8/1/2007 12:58'!
initializeWith: aParent 
	aParent ifNotNil: 
			[parent := aParent.
			request ifNil: 
					[request := parent request.
					urlStream := parent urlStream.
					urlStream ifNotNil: [urlOriginalPosition := urlStream position]].
			aParent response ifNotNil: [response := aParent response]].
	self postInitialize! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 3/3/2004 12:52'!
isLoggedIn
	"Check if the user is logged in."

	| session |
	session _ KomSession current.
	^session ifNotNil: [session attributes includesKey: #account] ifNil: [false]! !

!HVTransientView methodsFor: 'testing' stamp: 'gh 9/20/2002 09:36'!
isTopView
	"Am I a topview?"

	^false! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 03:03'!
link: url text: text
	"Return a HTML link."

	self deprecated: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.
	^String streamContents: [:stream |
		stream
			nextPutAll: '<a href="';
			nextPutAll: url;
			nextPutAll: '">'; nextPutAll: text; nextPutAll: '</a>' ]
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:48'!
linkBack: text
	"Return a local back link to the default page."

	self deprecated: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.
	^self link: self defaultUrl text: text
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:48'!
linkBackParent: text
	"Return a back link to the default page of the parent."

	self deprecated: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.
	^self link: parent defaultUrl text: text
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:48'!
linkBase: server local: relativeUrl text: text
	"Return a local link to the view."

	self deprecated: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.
	^self link: server, (self urlFor: relativeUrl) text: text
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'edc 10/14/2009 17:39'!
linkLocal: relativeUrl text: text
	"Return a local link to the view."
	self deprecated: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.
	^self link: (self urlFor: relativeUrl) text: text
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:48'!
linkback: text
	"Return a local backlink."

	self deprecated: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:47'!
linkbackparent: text
	"Return a parent backlink."

	self deprecated: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.! !

!HVTransientView methodsFor: 'urls' stamp: 'gk 3/4/2004 14:33'!
logout
	"By default we logout the account and redirect to the default page."

	self logoutAccount; redirectToDefault! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 3/4/2004 14:23'!
logoutAccount
	"Tell the account that it is being logged out.
	Clear out the account attribute in the session.
	Return true if all succeded."

	self currentAccount ifNil: [^true].
	(self currentAccount respondsTo: #logout) ifTrue: [
		self currentAccount logout].
	KomSession current attributes removeKey: #account ifAbsent: [^false].
	^true! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 10/12/2005 11:41'!
message: message
	"Return a single page with a message and a back link to base page of this view."

	^self builder start; h1: message; linkDefault: 'Back'; end; yourself
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 12/10/2003 10:57'!
message: message backlink: link
	"Return a single page with a message and a link back relative to the view."

	^self message: message linkLocal: link
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 12/10/2003 10:57'!
message: message link: link
	"Return a single page with a message and an absolute back link."

	| b |
	b _ self builder.
	^b start; h1: message; link: link text: 'Back'; end; yourself
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 12/10/2003 00:01'!
message: message linkLocal: link
	"Return a single page with a message and a back link relative to this view."

	^self message: message linkLocal: link text: 'Back'
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 12/10/2003 10:58'!
message: message linkLocal: link text: text
	"Return a single page with a message and a back link relative to this view."

	| b |
	b _ self builder.
	^b start; h1: message; linkLocal: link text: text; end; yourself
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:47'!
message: message linklocal: link
	"Return a single page with a message and a back link relative to this view."

	self deprecated: 'Deprecated, use #message:linkLocal: instead (capital L).'.
	^self message: message linkLocal: link
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:47'!
message: message linklocal: link text: aText
	"Return a single page with a message and a back link relative to this view."

	self deprecated: 'Deprecated, use #message:linkLocal:text: instead (capital L).'.
	^self message: message linkLocal: link text: aText
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 10/12/2005 11:41'!
message: message text: text
	"Return a single page with a message and a back link to base page of this view."

	^self builder start; h1: message; linkDefault: text; end; yourself
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gc 8/1/2007 12:27'!
methodAfter: aPrefix 
	self deprecated: 'Deprecated, use #nextMethod or similar methods instead.'.
	^ self methodInUrl: request rawUrl after: aPrefix! !

!HVTransientView methodsFor: 'deprecated' stamp: 'edc 10/15/2009 11:31'!
methodInUrl: url after: aPrefix
	"Extracts the method from the url.
	The methodname is after the prefix upto the first $? $/ or end of url like this:
	'/prefix/method/knirk?habbadubba' => 'method'
	'/prefix/method?habbadubba' => 'method'
	'/prefix/method' => 'method'
	'/prefix/' => ''
	'/prefix' => ''"

	| method endq ends pos |
	self deprecated: 'Deprecated, use #nextMethod or similar methods instead.'.

	(url = aPrefix) ifTrue:[ ^'' ].
	pos := url findString: aPrefix.
	method _ url copyFrom: pos + aPrefix size  to: url size.
	(method = '/') | (method = '')ifTrue:[ ^'' ].
	method _ method allButFirst.
	endq _ method indexOf: $?.
	ends _ method indexOf: $/.
	(endq = 0) ifTrue:[ endq _ method size + 1].
	(ends = 0) ifTrue:[ ends _ method size + 1].
	^method copyFrom: 1 to: (ends min: endq) - 1! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/10/2003 11:05'!
nextMethod
	"Pick out the next method (path part = directory) from the urlStream."

	^urlStream next! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gc 7/31/2007 11:39'!
originalUrl
	"Return a url String representing this view's
	original position within the url of the request."

	| curPos result |
	curPos _ urlStream position.
	urlStream position: urlOriginalPosition.
	result _ urlStream path.
	urlStream position: curPos.
	^result! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 10/11/2005 23:00'!
originalUrlFor: stringOrSymbol
	"Return a url String representing this view's
	original position within the url of the request
	with <stringOrSymbol> appended."

	| curPos result |
	curPos _ urlStream position.
	urlStream position: urlOriginalPosition.
	result _ urlStream pathWith: stringOrSymbol.
	urlStream position: curPos.
	^result! !

!HVTransientView methodsFor: 'accessing' stamp: 'gk 12/10/2003 10:21'!
parent
	"Return my parent view."

	^parent! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 12/10/2003 10:23'!
parentsDo: aBlock
	"Iterate over the parent views my parent first."

	aBlock value: parent.
	parent parentsDo: aBlock! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 12/10/2003 10:25'!
parentsDoReverse: aBlock
	"Iterate over the parent views root view first."

	parent parentsDoReverse: aBlock.
	aBlock value: parent! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 3/2/2004 17:28'!
peekNextMethod
	"Pick out the next method (path part = directory) from the urlStream."

	^urlStream peek! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'gh 9/20/2002 14:31'!
postInitialize
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 02:41'!
prefix

	self deprecated: 'Deprecated, use #nextMethod or other methods in category dispatch.'! !

!HVTransientView methodsFor: 'responses' stamp: 'gc 8/1/2007 12:27'!
redirectToReferer
	"Redirect to referer URL. This has problems with IE
	since it sends referer in a barfed partially unescaped iso encoding."

	^ self redirectTo: request referer! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gc 8/1/2007 12:27'!
reload
	"Make a redirection to same url."

	^ HttpResponse redirectTo: request rawUrl! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 6/20/2005 10:38'!
reload: url
	"Make a redirection but adjust the URL.
	Base implementation does nothing."

	^self redirectTo: url! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 6/9/2005 16:00'!
reloadWithoutLast
	"Make a redirection to same url without last
	path element, with parameters stripped and
	ending with a slash."

	^self redirectTo: ((urlStream setToEnd; back; path) utf8ToIso isoToSqueak)! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 4/22/2005 12:44'!
reloadWithoutParameters
	"Make a redirection to same url with parameters stripped."

	^self redirectTo: urlStream fullPath! !

!HVTransientView methodsFor: 'accessing' stamp: 'gc 8/1/2007 12:27'!
request
	^ request! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'edc 10/15/2009 07:57'!
request: aRequest 
	request := aRequest.
	request ifNotNil: 
			[urlStream := HVUrlStream onString: request rawUrl.
			urlStream ifNotNil: [urlOriginalPosition := urlStream position]]! !

!HVTransientView methodsFor: 'accessing' stamp: 'gc 8/1/2007 12:43'!
response
	^ response! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 12/10/2003 10:22'!
rootView
	"Return the view at the root, the root view will return self."

	^parent rootView! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gc 8/1/2007 12:27'!
serverError: aString 
	HVResponseNotification 
		signal: (((self builder)
				start;
				h1: 'Error';
				p: 'Returned by server: <b>' , aString , '</b>';
				end;
				yourself) asHttpResponseTo: request)! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 5/6/2004 15:29'!
sessionAt: key
	"Get the value in the current session for the request."

	^self sessionAt: key ifAbsent: [nil]! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 5/6/2004 15:28'!
sessionAt: key ifAbsent: block
	"Get the value in the current session for the request."

	^KomSession current attributes at: key ifAbsent: block! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 5/6/2004 15:38'!
sessionAt: key ifAbsentPut: block
	"Get the value in the current session for the request.
	If absent, set it to the value of the block."

	^KomSession current attributes at: key ifAbsent: [self sessionAt: key put: block value]! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 5/6/2004 15:29'!
sessionAt: key put: value
	"Set the value in the current session for the request."

	^KomSession current attributes at: key put: value! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 3/31/2005 14:26'!
showSourceFor: selector
	"Show the source for given selector."

	| b |
	b _ self builder.
	^b start; h2: ('Source for ', self class name, '>>', selector);
		pre: ((self fixForHtml: (self class sourceMethodAt: selector) asString)
				copyReplaceAll: '_' with: ':=');
		end; yourself! !

!HVTransientView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 11:59'!
start
	"Start the web app."

	self class start! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:47'!
starthtml
	"Standard start."

	self deprecated: 'Deprecated, use the HVHtmlBuilder to build HTML instead.'.

^'<html><head><title>', self title, '</title></head><body>'! !

!HVTransientView methodsFor: 'start-stop' stamp: 'gk 10/24/2003 09:14'!
stop
	"Stop service with name of class."

	self class stop! !

!HVTransientView methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:58'!
title
	^title! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 11/6/2003 14:26'!
topView
	"Return the view that thinks it is a top view."

	^self isTopView
		ifTrue: [self]
		ifFalse: [parent topView]! !

!HVTransientView methodsFor: 'html creation' stamp: 'gc 8/1/2007 12:27'!
transitionalXHTMLBuilder
	"Create a XHTML transitional builder with our own request."

	| b |
	b := HVHtmlBuilder request: request view: self.
	b 
		declaration: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'.
	b document html attributeAt: #xmlns put: 'http://www.w3.org/1999/xhtml'.
	b
		attributeAt: #'http-equiv' put: 'Content-type';
		attributeAt: #content put: 'text/html; charset=UTF-8';
		headTag: #meta.
	^ b! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/9/2003 16:20'!
urlFor: stringOrSymbol
	"Return a url String representing this view's
	current position within the url of the request
	with <stringOrSymbol> appended."

	^urlStream pathWith: stringOrSymbol! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 1/18/2005 15:01'!
urlPath
	"This is the current path of the urlStream."

	^urlStream path! !

!HVTransientView methodsFor: 'accessing' stamp: 'gk 12/9/2003 15:04'!
urlStream
	^urlStream! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 3/2/2004 16:29'!
validateEmail: aString
	"Validate that <aString> conforms to at least this syntax:
		'something @ something . something'
	"

	| s at dot |
	s _ aString withBlanksTrimmed.
	at _ aString indexOf: $@.
	dot _ s indexOf: $. startingAt: at.
	((dot * at) = 0) ifTrue:[^false].
	(at > 1) & (at < dot) & (dot < s size) ifFalse:[^false].
	^true! !

!HVTransientView methodsFor: 'utilities' stamp: 'gh 5/30/2002 13:42'!
validateSafeString: aString

	aString do: [:c | (SafeChars includes: c) ifFalse:[^false]].
	^true! !

!HVTransientView methodsFor: 'utilities' stamp: 'gh 5/30/2002 13:58'!
validateUltraSafeString: aString

	aString do: [:c | (UltraSafeChars includes: c) ifFalse:[^false]].
	^true! !

!HVTransientView methodsFor: 'css' stamp: 'gk 5/18/2004 15:13'!
w3cButtons: aStream
	"Append some CSS for slick W3C validation buttons."

	aStream nextPutAll:
'div.w3cbutton1 {
  position: relative;
  margin: 1em 0;
  font-family: helvetica,arial,sans-serif;
  font-size: 0.9em;
  font-weight: bold;
}
div.w3cbutton1 a {
  display: block;
  border-top: 1px solid #cecece;
  border-bottom: 2px solid #4a4a4a;
}
div.w3cbutton1 a.w3c1 {
  width: 3em;
  border-left: 1px solid #cecece;
  text-align: center;
}
div.w3cbutton1 a.spec1 {
  position: absolute;
  left: 3em;
  top: 0;
  width: 6em;
  border-right: 2px solid #4a4a4a;
  padding-left: 0.5em;
}
div.w3cbutton1 a.w3c1:link,
div.w3cbutton1 a.w3c1:visited,
div.w3cbutton1 a.w3c1:hover {
  background-color: #fff;
  color: #0c479d;
  text-decoration: none;
}
div.w3cbutton1 a.spec1:link,
div.w3cbutton1 a.spec1:visited,
div.w3cbutton1 a.spec1:hover {
  background-color: #fc6;
  color: #000;
  text-decoration: none;
}'! !

Object subclass: #HVMockHttpRequest
	instanceVariableNames: 'post postFields url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVMockHttpRequest methodsFor: 'accessing' stamp: 'gc 11/3/2007 22:51'!
fields
	^ postFields ! !

!HVMockHttpRequest methodsFor: 'accessing' stamp: 'gc 11/3/2007 22:19'!
isPostRequest
	^ post! !

!HVMockHttpRequest methodsFor: 'accessing' stamp: 'gc 11/3/2007 22:50'!
isSubmitRequest
	^ post! !

!HVMockHttpRequest methodsFor: 'accessing' stamp: 'gc 11/3/2007 22:19'!
post: anObject
	post := anObject! !

!HVMockHttpRequest methodsFor: 'accessing' stamp: 'gc 11/3/2007 22:17'!
postFields
	^ postFields! !

!HVMockHttpRequest methodsFor: 'accessing' stamp: 'gc 11/3/2007 22:17'!
postFields: anObject
	postFields := anObject! !

!HVMockHttpRequest methodsFor: 'accessing' stamp: 'gc 11/4/2007 01:26'!
url
	^ url! !

!HVMockHttpRequest methodsFor: 'accessing' stamp: 'gc 11/4/2007 01:26'!
url: aString
	url := aString! !

Object subclass: #HVMockView
	instanceVariableNames: 'request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVMockView methodsFor: 'urls' stamp: 'gc 11/4/2007 01:33'!
defaultUrl
	^ request url! !

!HVMockView methodsFor: 'urls' stamp: 'gc 11/4/2007 01:22'!
originalUrlFor: aString
	^ request url, aString! !

!HVMockView methodsFor: 'as yet unclassified' stamp: 'gc 11/4/2007 01:31'!
parent
	| req |
	req := request copy.
	req url: 'http://localhost.localdomain/'.
	^ (self species new)
		request: req;
		yourself! !

!HVMockView methodsFor: 'accessing' stamp: 'gc 11/4/2007 01:20'!
request
	^ request! !

!HVMockView methodsFor: 'accessing' stamp: 'gc 11/4/2007 01:20'!
request: anObject
	request := anObject! !

!HVMockView methodsFor: 'as yet unclassified' stamp: 'gc 11/4/2007 01:37'!
topView
	^ self parent! !

Object subclass: #HVTOC
	instanceVariableNames: 'rootEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Extras-TOCs'!

!HVTOC commentStamp: 'gk 3/31/2004 16:24' prior: 0!
This is the model of a hierarchical table of contents. It holds a root entry which typically is invisible and which in turns holds the top level entries.!

!HVTOC class methodsFor: 'instance creation' stamp: 'gk 3/31/2004 15:39'!
new
	^super new initialize! !

!HVTOC methodsFor: 'accessing' stamp: 'gk 3/31/2004 16:17'!
entries
	^rootEntry children! !

!HVTOC methodsFor: 'url testing' stamp: 'gk 5/17/2005 15:37'!
entryForUrl: anUrl
	"Return the entry that corresponds to <anUrl>."

	| stream |
	stream _ HVUrlStream onString: anUrl.
	^rootEntry entryFor: stream! !

!HVTOC methodsFor: 'initialize-release' stamp: 'gk 3/31/2004 15:39'!
initialize

	rootEntry _ HVTOCRootEntry parent: self! !

!HVTOC methodsFor: 'testing' stamp: 'gk 12/29/2004 15:25'!
isRoot
	^true! !

!HVTOC methodsFor: 'accessing' stamp: 'gk 3/31/2004 15:30'!
name: aName label: aLabel
	"Add a new top level entry in the TOC.
	Return the entry."

	^rootEntry name: aName label: aLabel! !

!HVTOC methodsFor: 'accessing' stamp: 'gk 4/7/2004 13:46'!
parent
	^nil! !

!HVTOC methodsFor: 'accessing' stamp: 'gk 3/31/2004 16:17'!
rootEntry
	^rootEntry! !

Object subclass: #HVTOCEntryRenderer
	instanceVariableNames: 'entry parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Extras-TOCs'!

!HVTOCEntryRenderer class methodsFor: 'instance creation' stamp: 'gk 4/1/2004 16:44'!
on: entry parent: renderer
	^self new entry: entry; parent: renderer! !

!HVTOCEntryRenderer methodsFor: 'rendering' stamp: 'gk 4/4/2004 19:03'!
baseUrl

	^parent baseUrl! !

!HVTOCEntryRenderer methodsFor: 'rendering' stamp: 'gk 4/22/2005 12:31'!
builder
	^parent builder
	! !

!HVTOCEntryRenderer methodsFor: 'rendering' stamp: 'gk 4/7/2004 13:59'!
cssSelected: aBlock on: stream
	"Render entry."

	stream nextPutAll: '<span class="',
		(entry isSelected ifTrue: ['selectedTocEntry'] ifFalse: ['tocEntry']) ,'">'.
	aBlock value.
	stream nextPutAll: '</span>'! !

!HVTOCEntryRenderer methodsFor: 'initialize-release' stamp: 'gk 4/1/2004 16:44'!
entry: anEntry
	entry _ anEntry! !

!HVTOCEntryRenderer methodsFor: 'rendering' stamp: 'gk 1/3/2005 13:17'!
fullName
	| base full |
	base := self baseUrl.
	full := entry fullName.
	^(base isEmpty not and: [base last = $/]) ifTrue: [base, full] ifFalse: [base, '/', full]
	! !

!HVTOCEntryRenderer methodsFor: 'initialize-release' stamp: 'gk 4/1/2004 16:44'!
parent: aParent
	parent _ aParent! !

!HVTOCEntryRenderer methodsFor: 'rendering' stamp: 'gk 4/7/2004 14:00'!
printHtmlOn: stream builder: aBuilder vertical: vertical
	"Render entry."

	self cssSelected: [
		stream nextPutAll: (aBuilder getLink: self fullName text: entry label).
		vertical
			ifTrue: [stream nextPutAll: '</br>']
			ifFalse: [stream nextPutAll: '&nbsp;&nbsp;']] on: stream! !

HVTOCEntryRenderer subclass: #HVTOCEntryTreeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Extras-TOCs'!

!HVTOCEntryTreeRenderer commentStamp: 'gk 3/31/2004 16:28' prior: 0!
Renders a HVTOCEntry as an expandable/collapsable node in tree view in HTML. Used "on the fly" by HVTOCTreeRenderer.!

!HVTOCEntryTreeRenderer class methodsFor: 'instance creation' stamp: 'gk 3/31/2004 15:48'!
on: entry parent: renderer
	^self new entry: entry; parent: renderer! !

!HVTOCEntryTreeRenderer methodsFor: 'rendering' stamp: 'gk 3/31/2004 15:47'!
closedImageUrl
	^parent closedImageUrl! !

!HVTOCEntryTreeRenderer methodsFor: 'rendering' stamp: 'gk 5/17/2005 15:28'!
collapseUrl
	| str tail |
	str _ parent builder url.
	tail _ 'collapsetoc?entry=', entry name.
	^(str isEmpty or: [str last = $/]) ifTrue: [str, tail] ifFalse: [str, '/', tail]! !

!HVTOCEntryTreeRenderer methodsFor: 'rendering' stamp: 'gk 5/31/2005 10:22'!
expandUrl
	| str tail |
	str _ parent builder url.
	tail _ 'expandtoc?entry=', entry name.
	^(str isEmpty or: [str last = $/]) ifTrue: [str, tail] ifFalse: [str, '/', tail]! !

!HVTOCEntryTreeRenderer methodsFor: 'rendering' stamp: 'gk 3/31/2004 15:47'!
leafImageUrl
	^parent leafImageUrl! !

!HVTOCEntryTreeRenderer methodsFor: 'rendering' stamp: 'gk 3/31/2004 15:47'!
openImageUrl
	^parent openImageUrl! !

!HVTOCEntryTreeRenderer methodsFor: 'rendering' stamp: 'gk 4/7/2004 14:02'!
printHtmlOn: stream expanded: exp level: aLevel builder: aBuilder
	"Render entry."

	| url expanded linkUrl icon |
	aLevel timesRepeat: [stream nextPutAll: '&nbsp;&nbsp;&nbsp;'].
	self cssSelected: [
	url _ self fullName.
	entry children isEmpty
		ifTrue: [linkUrl _ url. icon _ aBuilder getImage: self leafImageUrl. expanded _ false]
		ifFalse: [
			expanded _ exp includes: entry name.
			expanded
				ifTrue: [linkUrl _ self collapseUrl. icon _ aBuilder getImage: self openImageUrl]
				ifFalse: [linkUrl _ self expandUrl. icon _ aBuilder getImage: self closedImageUrl]].
	stream
		nextPutAll: (aBuilder getLink: linkUrl text: icon);
		nextPutAll: '&nbsp;';
		nextPutAll: (aBuilder getLink: url text: entry label);
		nextPutAll: '<br />'] on: stream.
	expanded ifTrue: [
		entry children do: [:child |
			(HVTOCEntryTreeRenderer on: child parent: self)
				printHtmlOn: stream expanded: exp level: aLevel + 1 builder: aBuilder]]! !

Object subclass: #HVTOCRootEntry
	instanceVariableNames: 'parent children selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Extras-TOCs'!

!HVTOCRootEntry commentStamp: 'gk 3/31/2004 16:26' prior: 0!
This is a special table of contents entry model representing the normally invisible root entry. It is owned by an instance of HVTOC.!

HVTOCRootEntry subclass: #HVTOCEntry
	instanceVariableNames: 'name label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Extras-TOCs'!

!HVTOCEntry commentStamp: 'gk 3/31/2004 16:25' prior: 0!
This it the model object for a table of contents entry. An entry has a label (the visible String), a name (typically a symbol corresponding to the URL path part of the entry) and a parent entry.!

!HVTOCEntry class methodsFor: 'instance creation' stamp: 'gk 3/31/2004 15:33'!
name: aSymbol label: aString parent: entry
	^self new name: aSymbol label: aString parent: entry! !

!HVTOCEntry methodsFor: 'entries' stamp: 'gk 4/4/2004 19:01'!
fullName
	| str |
	str _ parent fullName.
	^(str isEmpty or: [str last = $/]) ifTrue: [str, name] ifFalse: [str, '/', name]! !

!HVTOCEntry methodsFor: 'testing' stamp: 'gk 12/29/2004 15:19'!
isEntry
	^ true! !

!HVTOCEntry methodsFor: 'testing' stamp: 'gk 12/29/2004 15:20'!
isRoot
	^ false! !

!HVTOCEntry methodsFor: 'accessing' stamp: 'gk 3/31/2004 15:52'!
label
	^label! !

!HVTOCEntry methodsFor: 'accessing' stamp: 'gk 3/31/2004 15:52'!
name
	^name! !

!HVTOCEntry methodsFor: 'initialize-release' stamp: 'gk 3/31/2004 15:26'!
name: aSymbol label: aString parent: entry
	name _ aSymbol.
	parent _ entry.
	label _ aString! !

!HVTOCEntry methodsFor: 'printing' stamp: 'gk 1/5/2005 12:55'!
printOn: stream
	stream nextPutAll: self class name, '[', name asString, ']'
	! !

!HVTOCRootEntry class methodsFor: 'instance creation' stamp: 'gk 3/31/2004 15:34'!
parent: aToc
	^self new parent: aToc! !

!HVTOCRootEntry methodsFor: 'entries' stamp: 'gk 3/31/2004 15:24'!
children
	"Return children of this entry."

	^children ifNil: [#()]! !

!HVTOCRootEntry methodsFor: 'entries' stamp: 'gk 4/2/2004 15:33'!
entries
	"Return children of this entry."

	^self children! !

!HVTOCRootEntry methodsFor: 'entries' stamp: 'gk 4/7/2004 14:26'!
entryFor: urlStream
	"Find the child matching the relative url."

	| next found |
	next _ urlStream next.
	next ifNil: [^self].
	found _ self children detect: [:c | c name = next] ifNone: [nil].
	found ifNil: [children isEmptyOrNil ifTrue: [^self]ifFalse: [^self]].
	^found entryFor: urlStream! !

!HVTOCRootEntry methodsFor: 'entries' stamp: 'gk 4/4/2004 19:06'!
fullName
	^''! !

!HVTOCRootEntry methodsFor: 'entries' stamp: 'gk 12/29/2004 15:29'!
hasChildren
	"Do I have children?"

	^self children isEmpty not! !

!HVTOCRootEntry methodsFor: 'testing' stamp: 'gk 12/29/2004 15:20'!
isRoot
	^ true! !

!HVTOCRootEntry methodsFor: 'initialize-release' stamp: 'gk 4/7/2004 13:51'!
isSelected
	^selected notNil! !

!HVTOCRootEntry methodsFor: 'entries' stamp: 'gk 3/31/2004 15:25'!
name: aName label: aLabel
	"Add a new child entry.
	Return the entry."

	children ifNil: [children _ OrderedCollection new].
	^children add: (HVTOCEntry name: aName label: aLabel parent: self)! !

!HVTOCRootEntry methodsFor: 'entries' stamp: 'gk 4/5/2004 10:57'!
parent

	^parent! !

!HVTOCRootEntry methodsFor: 'initialize-release' stamp: 'gk 3/31/2004 15:34'!
parent: aToc
	parent _ aToc! !

!HVTOCRootEntry methodsFor: 'initialize-release' stamp: 'gk 4/7/2004 13:51'!
setSelected
	selected _ true! !

Object subclass: #HVTag
	instanceVariableNames: 'canvas attributes tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Canvas'!

HVTag subclass: #HVBaseTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVBaseTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 20:50'!
href: aString 
	self attributeAt: 'href' put: aString.
	self with: []! !

!HVBaseTag methodsFor: 'attributes - core' stamp: 'gc 7/31/2007 20:49'!
id: aString
	self attributeAt: 'id' put: aString! !

!HVBaseTag methodsFor: 'accessing' stamp: 'gc 2/9/2007 12:59'!
tag
	^ 'base'! !

!HVBaseTag methodsFor: 'private' stamp: 'gc 7/31/2007 20:46'!
tag: aString do: aBlock 
	self canvas
		nextPut: $<;
		nextPutAll: aString.
	self attributes keysAndValuesDo: [:key :value | self putAttribute: key value: value].
	self canvas nextPutAll: '/>'! !

HVTag subclass: #HVBasicTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVBasicTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 21:25'!
attributeAt: key putNumber: anInteger 
	anInteger < 0 ifTrue: [self attributeError: key, ' can''t be negative'].
	^ attributes at: key put: anInteger asString! !

!HVBasicTag methodsFor: 'attributes - private' stamp: 'gc 7/30/2007 15:12'!
dir: dir 
	^ self attributeAt: 'dir' put: dir! !

!HVBasicTag methodsFor: 'attributes - core' stamp: 'gc 7/30/2007 15:13'!
id: aString
	^ self attributeAt: 'id' put: aString! !

!HVBasicTag methodsFor: 'attributes - i18n' stamp: 'gc 7/30/2007 15:13'!
leftToRight
	self dir: 'ltr'! !

!HVBasicTag methodsFor: 'attributes - i18n' stamp: 'gc 7/30/2007 15:13'!
rightToLeft
	self dir: 'rtl'! !

!HVBasicTag methodsFor: 'attributes - i18n' stamp: 'gc 7/30/2007 15:13'!
xmlLang: aString
	self attributeAt: 'xml:lang' put: aString! !

HVBasicTag subclass: #HVCommonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

HVCommonTag subclass: #HVBodyTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVBodyTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:50'!
onLoad: aString
	self onEvent: 'load' do: aString! !

!HVBodyTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:50'!
onUnload: aString
	self onEvent: 'unload' do: aString! !

!HVBodyTag methodsFor: 'accessing' stamp: 'gc 7/31/2007 19:49'!
tag
	^ 'body'! !

HVCommonTag subclass: #HVClosingTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

HVClosingTag subclass: #HVAreaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVAreaTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 15:31'!
accessKey: aCharacter
	self attributeAt: 'accesskey' put: aCharacter asString! !

!HVAreaTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 12:55'!
alternativeText: aString
	self attributeAt: 'alt' put: aString! !

!HVAreaTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/31/2007 13:59'!
circularShape
	self shape: 'circle'! !

!HVAreaTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/31/2007 14:02'!
coords: aString
	self attributeAt: 'coords' put: aString! !

!HVAreaTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/25/2007 15:31'!
defaultShape
	self shape: 'default'! !

!HVAreaTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 13:13'!
href: aString
	self attributeAt: 'href' put: aString! !

!HVAreaTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 13:14'!
noHref
	self attributeAt: 'nohref' put: 'nohref'! !

!HVAreaTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:46'!
onBlur: aString
	self onEvent: 'blur' do: aString! !

!HVAreaTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:47'!
onFocus: aString
	self onEvent: 'focus' do: aString! !

!HVAreaTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/31/2007 13:58'!
polygonalShape
	self shape: 'poly'! !

!HVAreaTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/31/2007 13:55'!
rectangularShape
	self shape: 'rect'! !

!HVAreaTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/25/2007 15:31'!
shape: aString
	self attributeAt: 'shape' put: aString! !

!HVAreaTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 15:32'!
tabIndex: anInteger
	self attributeAt: 'tabindex' putNumber: anInteger! !

!HVAreaTag methodsFor: 'accessing' stamp: 'gc 7/25/2007 12:51'!
tag
	^ 'area'! !

HVClosingTag subclass: #HVBreakTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVBreakTag methodsFor: 'attributes - private' stamp: 'gc 7/30/2007 17:27'!
dir: aString
	self doesNotUnderstandAttribute: 'dir'! !

!HVBreakTag methodsFor: 'attributes - events' stamp: 'gc 2/12/2007 09:07'!
onEvent: event do: aString 
	self doesNotUnderstandAttribute: 'on', event! !

!HVBreakTag methodsFor: 'accessing' stamp: 'gc 2/9/2007 13:01'!
tag
	^ 'br'! !

!HVBreakTag methodsFor: 'attributes - i18n' stamp: 'gc 2/12/2007 09:13'!
xmlLang: aString
	self doesNotUnderstandAttribute: 'xml:lang'! !

!HVClosingTag methodsFor: 'private' stamp: 'gc 7/12/2007 00:16'!
tag: aString do: aBlock 
	self canvas
		nextPut: $<;
		nextPutAll: aString.
	self attributes keysAndValuesDo: [:key :value | self putAttribute: key value: value].
	self canvas nextPutAll: '/>'! !

HVClosingTag subclass: #HVImageTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVImageTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 11:32'!
alternativeText: aString
	self attributeAt: 'alt' put: aString! !

!HVImageTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 11:47'!
height: anInteger
	self attributeAt: 'height' putNumber: anInteger! !

!HVImageTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 12:16'!
isMap
	self attributeAt: 'ismap' put: 'ismap'! !

!HVImageTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 11:38'!
longDescription: aString
	self attributeAt: 'longdesc' put: aString! !

!HVImageTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 11:29'!
source: aString
	self attributeAt: 'src' put: aString! !

!HVImageTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 12:40'!
source: src alternativeText: alt
	self
		source: src;
		alternativeText: alt;
		with: []! !

!HVImageTag methodsFor: 'accessing' stamp: 'gc 7/25/2007 00:21'!
tag
	^ 'img'! !

!HVImageTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 12:31'!
useMap: aString
	self attributeAt: 'usemap' put: aString! !

!HVImageTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 12:05'!
width: anInteger
	self attributeAt: 'width' putNumber: anInteger! !

!HVImageTag methodsFor: 'printing' stamp: 'gc 7/31/2007 12:25'!
with: aBlock
	self attributeAt: 'src' ifAbsent: [self attributeError: 'src not set'].
	self attributeAt: 'alt' ifAbsent: [self attributeError: 'alt not set'].
	^ super with: aBlock! !

HVClosingTag subclass: #HVMetaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVMetaTag methodsFor: 'attributes - core' stamp: 'gc 7/25/2007 13:26'!
class: aString
	self doesNotUnderstandAttribute: 'class'! !

!HVMetaTag methodsFor: 'attributes - core' stamp: 'gc 7/25/2007 13:27'!
classes: aCollection
	self doesNotUnderstandAttribute: 'class'! !

!HVMetaTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 20:07'!
content: aString
	self attributeAt: 'content' put: aString.
	self with: []! !

!HVMetaTag methodsFor: 'attributes - http-equiv' stamp: 'gc 7/25/2007 13:56'!
contentType
	self httpEquiv: 'content-type'! !

!HVMetaTag methodsFor: 'attributes - http-equiv' stamp: 'gc 7/25/2007 13:57'!
expires
	self httpEquiv: 'expires'! !

!HVMetaTag methodsFor: 'attributes - http-equiv' stamp: 'gc 7/25/2007 13:55'!
httpEquiv: aString
	self attributeAt: 'http-equiv' put: aString! !

!HVMetaTag methodsFor: 'attributes - http-equiv' stamp: 'gc 7/31/2007 20:01'!
httpEquivalent: aString
	self attributeAt: 'http-equiv' put: aString! !

!HVMetaTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 13:31'!
name: aString
	self attributeAt: 'name' put: aString! !

!HVMetaTag methodsFor: 'attributes - events' stamp: 'gc 7/25/2007 13:28'!
onEvent: event do: aString
	self doesNotUnderstandAttribute: 'on', event! !

!HVMetaTag methodsFor: 'attributes - http-equiv' stamp: 'gc 7/25/2007 13:57'!
refresh
	self httpEquiv: 'refresh'! !

!HVMetaTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 14:32'!
scheme: aString
	self attributeAt: 'scheme' put: aString! !

!HVMetaTag methodsFor: 'attributes - http-equiv' stamp: 'gc 7/25/2007 13:58'!
setCookie
	self httpEquiv: 'set-cookie'! !

!HVMetaTag methodsFor: 'accessing' stamp: 'gc 7/25/2007 13:25'!
tag
	^ 'meta'! !

!HVMetaTag methodsFor: 'attributes - core' stamp: 'gc 7/25/2007 13:28'!
title: aString
	self doesNotUnderstandAttribute: 'title'! !

!HVMetaTag methodsFor: 'printing' stamp: 'gc 7/31/2007 20:03'!
with: aBlock
	self attributeAt: 'content' ifAbsent: [self attributeError: 'content not set'].
	^ super with: aBlock! !

!HVCommonTag methodsFor: 'attributes - core' stamp: 'gc 7/23/2007 15:06'!
class: aString
	self attributeAt: 'class' put: aString ! !

!HVCommonTag methodsFor: 'attributes - core' stamp: 'gc 7/23/2007 15:06'!
classes: aCollection
	| classes |
	classes := WriteStream on: String new.
	aCollection do: [:each | classes nextPutAll: each] separatedBy: [classes nextPutAll: ' '].
	self attributeAt: 'class' put: classes contents! !

!HVCommonTag methodsFor: 'attributes - core' stamp: 'gc 7/30/2007 15:00'!
defaultSpace
	self xmlSpace: 'default'! !

!HVCommonTag methodsFor: 'attributes - events' stamp: 'gc 2/10/2007 15:07'!
onClick: aString
	self onEvent: 'click' do: aString! !

!HVCommonTag methodsFor: 'attributes - events' stamp: 'gc 2/10/2007 15:07'!
onDoubleClick: aString
	self onEvent: 'dblclick' do: aString! !

!HVCommonTag methodsFor: 'attributes - private' stamp: 'gc 7/23/2007 15:07'!
onEvent: event do: aString
	self attributeAt: ('on', event) put: aString! !

!HVCommonTag methodsFor: 'attributes - events' stamp: 'gc 2/10/2007 15:07'!
onKeyDown: aString
	self onEvent: 'keydown' do: aString! !

!HVCommonTag methodsFor: 'attributes - events' stamp: 'gc 2/10/2007 15:07'!
onKeyPress: aString
	self onEvent: 'keypress' do: aString! !

!HVCommonTag methodsFor: 'attributes - events' stamp: 'gc 2/10/2007 15:07'!
onKeyUp: aString
	self onEvent: 'keyup' do: aString! !

!HVCommonTag methodsFor: 'attributes - events' stamp: 'gc 2/10/2007 15:07'!
onMouseDown: aString
	self onEvent: 'mousedown' do: aString! !

!HVCommonTag methodsFor: 'attributes - events' stamp: 'gc 2/10/2007 15:07'!
onMouseMove: aString
	self onEvent: 'mousemove' do: aString! !

!HVCommonTag methodsFor: 'attributes - events' stamp: 'gc 2/10/2007 15:07'!
onMouseOut: aString
	self onEvent: 'mouseout' do: aString! !

!HVCommonTag methodsFor: 'attributes - events' stamp: 'gc 2/10/2007 15:07'!
onMouseOver: aString
	self onEvent: 'mouseover' do: aString! !

!HVCommonTag methodsFor: 'attributes - events' stamp: 'gc 2/10/2007 15:07'!
onMouseUp: aString
	self onEvent: 'mouseup' do: aString! !

!HVCommonTag methodsFor: 'attributes - core' stamp: 'gc 7/30/2007 15:00'!
preserveSpace
	self xmlSpace: 'preserve'! !

!HVCommonTag methodsFor: 'attributes - core' stamp: 'gc 7/23/2007 15:07'!
title: aString
	self attributeAt: 'title' put: aString! !

!HVCommonTag methodsFor: 'attributes - private' stamp: 'gc 7/30/2007 15:00'!
xmlSpace: space 
	self attributeAt: 'xml:space' put: space! !

HVCommonTag subclass: #HVDirectionTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVDirectionTag methodsFor: 'attributes - private' stamp: 'gc 7/30/2007 17:14'!
onEvent: event do: aString
	self doesNotUnderstandAttribute: 'on', event! !

!HVDirectionTag methodsFor: 'accessing' stamp: 'gc 7/24/2007 17:34'!
tag
	^ 'bdo'! !

!HVDirectionTag methodsFor: 'printing' stamp: 'gc 7/31/2007 11:19'!
with: aBlock
	self attributeAt: 'dir' ifAbsent: [self attributeError: '''dir'' not set'].
	^ super with: aBlock! !

!HVDirectionTag methodsFor: 'attributes - i18n' stamp: 'gc 7/30/2007 17:15'!
xmlLang: aString
	self doesNotUnderstandAttribute: 'xml:lang'! !

HVCommonTag subclass: #HVFormElementTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

HVFormElementTag subclass: #HVButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVButtonTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:16'!
accessKey: aCharacter
	self attributeAt: 'accesskey' put: aCharacter asString! !

!HVButtonTag methodsFor: 'attributes - type' stamp: 'gc 7/24/2007 18:02'!
beButton
	self type: 'button'! !

!HVButtonTag methodsFor: 'attributes - type' stamp: 'gc 7/24/2007 18:02'!
beReset
	self type: 'reset'! !

!HVButtonTag methodsFor: 'attributes - type' stamp: 'gc 7/24/2007 18:07'!
beSubmit
	self type: 'submit'! !

!HVButtonTag methodsFor: 'attributes - type' stamp: 'gc 7/31/2007 12:17'!
disabled
	self attributeAt: 'disabled' put: 'disabled'! !

!HVButtonTag methodsFor: 'callbacks' stamp: 'gc 11/3/2007 22:53'!
ifNotPressed: aBlock
	self isPressed ifFalse: aBlock! !

!HVButtonTag methodsFor: 'callbacks' stamp: 'gc 11/3/2007 22:59'!
ifNotPressed: aBlock ifPressed: anotherBlock
	self isPressed ifFalse: aBlock ifTrue: anotherBlock! !

!HVButtonTag methodsFor: 'callbacks' stamp: 'gc 11/3/2007 22:52'!
ifPressed: aBlock
	self isPressed ifTrue: aBlock! !

!HVButtonTag methodsFor: 'callbacks' stamp: 'gc 11/3/2007 22:57'!
ifPressed: aBlock ifNotPressed: anotherBlock
	self isPressed ifTrue: aBlock ifFalse: anotherBlock! !

!HVButtonTag methodsFor: 'callbacks' stamp: 'gc 11/3/2007 22:56'!
isPressed
	| request |
	request := canvas request.
	^ (request isSubmitRequest)
		and: [request fields includesKey: self name]
		and: [(request fields at: self name) = (self attributeAt: 'value')]! !

!HVButtonTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 20:00'!
onBlur: aString
	self onEvent: 'blur' do: aString! !

!HVButtonTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 20:00'!
onFocus: aString
	self onEvent: 'focus' do: aString! !

!HVButtonTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:19'!
tabIndex: anInteger
	self attributeAt: 'tabindex' putNumber: anInteger! !

!HVButtonTag methodsFor: 'accessing' stamp: 'gc 7/24/2007 17:53'!
tag
	^ 'button'! !

!HVButtonTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:01'!
type: aString
	self attributeAt: 'type' put: aString! !

!HVButtonTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:08'!
value: aString
	self attributeAt: 'value' put: aString! !

!HVButtonTag methodsFor: 'printing' stamp: 'gc 7/24/2007 18:17'!
with: aBlock
	self attributeAt: 'type' ifAbsentPut: 'submit'.
	^ super with: aBlock! !

!HVFormElementTag methodsFor: 'attributes' stamp: 'gc 11/3/2007 22:03'!
name
	^ self attributeAt: 'name'! !

!HVFormElementTag methodsFor: 'attributes' stamp: 'gc 11/3/2007 21:35'!
name: aString
	self attributeAt: 'name' put: aString! !

!HVFormElementTag methodsFor: 'attributes' stamp: 'gc 11/3/2007 22:18'!
value
	^ canvas request isPostRequest
		ifTrue: [canvas request postFields at: self name]
		ifFalse: [self]! !

HVFormElementTag subclass: #HVInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 11:58'!
accept: aString
	self attributeAt: 'accept' put: aString! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 11:58'!
accepts: aCollection
	| contentTypes |
	contentTypes := WriteStream on: String new.
	aCollection
		do: [:each | contentTypes nextPutAll: each]
		separatedBy: [contentTypes nextPutAll: ' '].
	self attributeAt: 'accept' put: contentTypes contents! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:16'!
accessKey: aCharacter
	self attributeAt: 'accesskey' put: aCharacter asString! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/11/2007 20:05'!
alt: aString
	self alternativeText: aString! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:02'!
alternativeText: aString
	self attributeAt: 'alt' put: aString! !

!HVInputTag methodsFor: 'attributes - types' stamp: 'gc 7/31/2007 12:07'!
beCheckbox
	self type: 'checkbox'! !

!HVInputTag methodsFor: 'attributes - types' stamp: 'gc 7/31/2007 12:09'!
beFile
	self type: 'file'! !

!HVInputTag methodsFor: 'attributes - types' stamp: 'gc 7/31/2007 12:10'!
beHidden
	self type: 'hidden'! !

!HVInputTag methodsFor: 'attributes - types' stamp: 'gc 7/31/2007 12:11'!
beImage
	self type: 'image'! !

!HVInputTag methodsFor: 'attributes - types' stamp: 'gc 7/31/2007 12:12'!
bePassword
	self type: 'password'! !

!HVInputTag methodsFor: 'attributes - types' stamp: 'gc 7/31/2007 12:13'!
beRadio
	self type: 'radio'! !

!HVInputTag methodsFor: 'attributes - types' stamp: 'gc 7/31/2007 12:14'!
beReset
	self type: 'reset'! !

!HVInputTag methodsFor: 'attributes - types' stamp: 'gc 7/31/2007 12:15'!
beSubmit
	self type: 'submit'! !

!HVInputTag methodsFor: 'attributes - types' stamp: 'gc 7/31/2007 12:22'!
beText
	self type: 'text'! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:04'!
checked
	self attributeAt: 'checked' put: 'checked'! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:17'!
disabled
	self attributeAt: 'disabled' put: 'disabled'! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 14:58'!
isMap
	self attributeAt: 'ismap' put: 'ismap'! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 20:55'!
maxLength: anInteger
	self attributeAt: 'maxlength' putNumber: anInteger! !

!HVInputTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:55'!
onBlur: aString
	self onEvent: 'blur' do: aString! !

!HVInputTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:55'!
onChange: aString
	self onEvent: 'change' do: aString! !

!HVInputTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:56'!
onFocus: aString
	self onEvent: 'focus' do: aString! !

!HVInputTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:56'!
onSelect: aString
	self onEvent: 'select' do: aString! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:03'!
readonly
	self attributeAt: 'readonly' put: 'readonly'! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 20:55'!
size: anInteger
	self attributeAt: 'size' putNumber: anInteger! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/11/2007 23:36'!
source: aString
	self doesNotUnderstandAttribute: 'src'! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:19'!
tabIndex: anInteger
	self attributeAt: 'tabindex' putNumber: anInteger! !

!HVInputTag methodsFor: 'accessing' stamp: 'gc 7/11/2007 20:00'!
tag
	^ 'input'! !

!HVInputTag methodsFor: 'private' stamp: 'gc 7/24/2007 16:22'!
tag: aString do: aBlock 
	self canvas
		nextPut: $<;
		nextPutAll: aString.
	self attributes keysAndValuesDo: [:key :value | self putAttribute: key value: value].
	self canvas nextPutAll: '/>'! !

!HVInputTag methodsFor: 'attributes - types' stamp: 'gc 7/23/2007 15:04'!
type: aString
	self attributeAt: 'type' put: aString! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:04'!
useMap: aString
	self attributeAt: 'usemap' put: aString! !

!HVInputTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:04'!
value: aString
	self attributeAt: 'value' put: aString.
	self with: [].! !

!HVInputTag methodsFor: 'printing' stamp: 'gc 7/24/2007 16:21'!
with: aBlock
	self attributeAt: 'type' ifAbsentPut: 'text'.
	^ super with: aBlock! !

HVFormElementTag subclass: #HVSelectTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVSelectTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:06'!
beMultiple
	self attributeAt: 'multiple' put: 'multiple'! !

!HVSelectTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:17'!
disabled
	self attributeAt: 'disabled' put: 'disabled'! !

!HVSelectTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:57'!
onBlur: aString
	self onEvent: 'blur' do: aString! !

!HVSelectTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:58'!
onChange: aString
	self onEvent: 'change' do: aString! !

!HVSelectTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:57'!
onFocus: aString
	self onEvent: 'focus' do: aString! !

!HVSelectTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:32'!
size: anInteger
	self attributeAt: 'size' putNumber: anInteger! !

!HVSelectTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:19'!
tabIndex: anInteger
	self attributeAt: 'tabindex' putNumber: anInteger! !

!HVSelectTag methodsFor: 'accessing' stamp: 'gc 7/17/2007 11:00'!
tag
	^ 'select'! !

HVFormElementTag subclass: #HVTextAreaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVTextAreaTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:16'!
accessKey: aCharacter
	self attributeAt: 'accesskey' put: aCharacter asString! !

!HVTextAreaTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 20:58'!
cols: anInteger
	self attributeAt: 'cols' putNumber: anInteger! !

!HVTextAreaTag methodsFor: 'attributes' stamp: 'gc 7/17/2007 17:19'!
columns: anInteger
	self cols: anInteger! !

!HVTextAreaTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:17'!
disabled
	self attributeAt: 'disabled' put: 'disabled'! !

!HVTextAreaTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 19:59'!
onBlur: aString
	self onEvent: 'blur' do: aString! !

!HVTextAreaTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 19:59'!
onChange: aString
	self onEvent: 'change' do: aString! !

!HVTextAreaTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 19:59'!
onFocus: aString
	self onEvent: 'focus' do: aString! !

!HVTextAreaTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 19:59'!
onSelect: aString
	self onEvent: 'select' do: aString! !

!HVTextAreaTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:08'!
readonly
	self attributeAt: 'readonly' put: 'readonly'! !

!HVTextAreaTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 20:59'!
rows: anInteger
	self attributeAt: 'rows' putNumber: anInteger! !

!HVTextAreaTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:19'!
tabIndex: anInteger
	self attributeAt: 'tabindex' putNumber: anInteger! !

!HVTextAreaTag methodsFor: 'accessing' stamp: 'gc 7/17/2007 17:09'!
tag
	^ 'textarea'! !

HVCommonTag subclass: #HVFormTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVFormTag class methodsFor: 'defaults' stamp: 'gc 7/11/2007 19:04'!
beMultipart
	^ 'multipart/form-data'! !

!HVFormTag class methodsFor: 'defaults' stamp: 'gc 7/11/2007 19:01'!
encodingType
	^ 'application/x-www-form-urlencoded'! !

!HVFormTag class methodsFor: 'defaults' stamp: 'gc 7/11/2007 19:05'!
multipartFormData
	^ 'multipart/form-data'! !

!HVFormTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 11:12'!
accept: aString
	self attributeAt: 'accept' put: aString! !

!HVFormTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 11:15'!
acceptCharset: aString
	self attributeAt: 'accept-charset' put: aString! !

!HVFormTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 11:13'!
acceptCharsets: aCollection
	| encodings |
	encodings := WriteStream on: String new.
	aCollection
		do: [:each | encodings nextPutAll: each]
		separatedBy: [encodings nextPutAll: ' '].
	self attributeAt: 'accept-charset' put: encodings contents! !

!HVFormTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 11:12'!
accepts: aCollection
	| contentTypes |
	contentTypes := WriteStream on: String new.
	aCollection
		do: [:each | contentTypes nextPutAll: each]
		separatedBy: [contentTypes nextPutAll: ' '].
	self attributeAt: 'accept' put: contentTypes contents! !

!HVFormTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 13:14'!
action: aString
	self attributeAt: 'action' put: aString ! !

!HVFormTag methodsFor: 'attributes' stamp: 'gc 7/11/2007 19:05'!
beMultipart
	self encodingType: self class multipartFormData! !

!HVFormTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 13:14'!
encodingType: aString
	self attributeAt: 'enctype' put: aString! !

!HVFormTag methodsFor: 'attributes - autonaming' stamp: 'gc 11/3/2007 15:12'!
name: aString
	self id: aString! !

!HVFormTag methodsFor: 'attributes - events' stamp: 'gc 7/11/2007 19:10'!
onReset: aString
	self onEvent: 'reset' do: aString! !

!HVFormTag methodsFor: 'attributes - events' stamp: 'gc 7/11/2007 19:11'!
onSubmit: aString
	self onEvent: 'submit' do: aString! !

!HVFormTag methodsFor: 'accessing' stamp: 'gc 7/11/2007 18:40'!
tag
	^ 'form'! !

!HVFormTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 13:14'!
useGet
	self attributeAt: 'method' put: 'get'! !

!HVFormTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 13:14'!
usePost
	self attributeAt: 'method' put: 'post'! !

!HVFormTag methodsFor: 'printing' stamp: 'gc 7/31/2007 11:56'!
with: aBlock
	self attributeAt: 'action' ifAbsent: [self attributeError: '''action'' not set'].
	self attributeAt: 'method' ifAbsentPut: 'get'.
	^ super with: aBlock! !

HVCommonTag subclass: #HVHeadingTag
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVHeadingTag class methodsFor: 'instance creation' stamp: 'gc 2/8/2007 15:35'!
level: anInteger canvas: aCanvas
	^ (super canvas: aCanvas) level: anInteger! !

!HVHeadingTag methodsFor: 'private' stamp: 'gc 2/8/2007 15:35'!
level
	^level! !

!HVHeadingTag methodsFor: 'private' stamp: 'gc 2/8/2007 15:35'!
level: anObject
	level := anObject! !

!HVHeadingTag methodsFor: 'accessing' stamp: 'gc 2/8/2007 15:35'!
tag
	^ 'h', self level asString! !

HVCommonTag subclass: #HVLabelTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVLabelTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:04'!
accessKey: aCharacter
	self attributeAt: 'accesskey' put: aCharacter asString! !

!HVLabelTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:05'!
for: aString
	self attributeAt: 'for' put: aString ! !

!HVLabelTag methodsFor: 'attributes - events' stamp: 'gc 7/31/2007 19:51'!
onBlur: aString
	self onEvent: 'blur' do: aString! !

!HVLabelTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 19:51'!
onFocus: aString
	self onEvent: 'focus' do: aString! !

!HVLabelTag methodsFor: 'accessing' stamp: 'gc 7/17/2007 10:27'!
tag
	^ 'label'! !

HVCommonTag subclass: #HVLegendTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVLegendTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:05'!
accessKey: aCharacter
	self attributeAt: 'accesskey' put: aCharacter asString! !

!HVLegendTag methodsFor: 'accessing' stamp: 'gc 7/17/2007 10:11'!
tag
	^ 'legend'! !

HVCommonTag subclass: #HVLinkableTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

HVLinkableTag subclass: #HVAnchorTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVAnchorTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 15:31'!
accessKey: aCharacter
	self attributeAt: 'accesskey' put: aCharacter asString! !

!HVAnchorTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/31/2007 13:59'!
circularShape
	self shape: 'circle'! !

!HVAnchorTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/31/2007 13:53'!
coords: aString
	self attributeAt: 'coords' put: aString! !

!HVAnchorTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/25/2007 15:31'!
defaultShape
	self shape: 'default'! !

!HVAnchorTag methodsFor: 'attributes - events' stamp: 'gc 2/18/2007 19:28'!
onBlur: aString
	self onEvent: 'blur' do: aString! !

!HVAnchorTag methodsFor: 'attributes - events' stamp: 'gc 2/18/2007 19:29'!
onFocus: aString
	self onEvent: 'focus' do: aString! !

!HVAnchorTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/31/2007 13:58'!
polygonalShape
	self shape: 'poly'! !

!HVAnchorTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/31/2007 13:55'!
rectangularShape
	self shape: 'rect'! !

!HVAnchorTag methodsFor: 'attributes - imagemap' stamp: 'gc 7/25/2007 15:31'!
shape: aString
	self attributeAt: 'shape' put: aString! !

!HVAnchorTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 15:32'!
tabIndex: anInteger
	self attributeAt: 'tabindex' putNumber: anInteger! !

!HVAnchorTag methodsFor: 'accessing' stamp: 'gc 7/25/2007 19:09'!
tag
	^ 'a'! !

!HVAnchorTag methodsFor: 'links' stamp: 'gc 11/4/2007 01:33'!
toDefault
	^ self href: (canvas view defaultUrl)! !

!HVAnchorTag methodsFor: 'links' stamp: 'gc 11/4/2007 01:19'!
toLocal: aString
	^ self href: (canvas view originalUrlFor: aString)! !

!HVAnchorTag methodsFor: 'links' stamp: 'gc 11/4/2007 01:35'!
toParent
	^ self href: (canvas view parent defaultUrl)! !

!HVAnchorTag methodsFor: 'links' stamp: 'gc 11/4/2007 01:29'!
toParent: aString
	^ self href: (canvas view parent originalUrlFor: aString)! !

!HVAnchorTag methodsFor: 'links' stamp: 'gc 11/4/2007 01:36'!
toTop
	^ self href: (canvas view topView defaultUrl)! !

!HVAnchorTag methodsFor: 'links' stamp: 'gc 11/4/2007 01:38'!
toTop: aString
	^ self href: (canvas view topView originalUrlFor: aString)! !

HVLinkableTag subclass: #HVLinkTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVLinkTag methodsFor: 'attributes - media' stamp: 'gc 7/31/2007 20:44'!
allMedia
	self media: 'all'! !

!HVLinkTag methodsFor: 'attributes - media' stamp: 'gc 7/31/2007 20:44'!
auralMedia
	self media: 'aural'! !

!HVLinkTag methodsFor: 'attributes - media' stamp: 'gc 7/31/2007 20:44'!
brailleMedia
	self media: 'braille'! !

!HVLinkTag methodsFor: 'attributes - media' stamp: 'gc 7/31/2007 20:44'!
handheldMedia
	self media: 'handheld'! !

!HVLinkTag methodsFor: 'attributes - media' stamp: 'gc 7/31/2007 20:43'!
media: aString
	self attributeAt: 'media' put: aString! !

!HVLinkTag methodsFor: 'attributes - media' stamp: 'gc 7/31/2007 20:44'!
printMedia
	self media: 'print'! !

!HVLinkTag methodsFor: 'attributes - media' stamp: 'gc 7/31/2007 20:44'!
projectionMedia
	self media: 'projection'! !

!HVLinkTag methodsFor: 'attributes - media' stamp: 'gc 7/31/2007 20:45'!
screenMedia
	self media: 'screen'! !

!HVLinkTag methodsFor: 'accessing' stamp: 'gc 7/25/2007 19:09'!
tag
	^ 'link'! !

!HVLinkTag methodsFor: 'attributes - media' stamp: 'gc 7/31/2007 20:45'!
ttyMedia
	self media: 'tty'! !

!HVLinkTag methodsFor: 'attributes - media' stamp: 'gc 7/31/2007 20:45'!
tvMedia
	self media: 'tv'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beAlternate
	self rel: 'Alternate'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beAppendix
	self rel: 'Appendix'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beBookmark
	self rel: 'Bookmark'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beChapter
	self rel: 'Chapter'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beContents
	self rel: 'Contents'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beCopyright
	self rel: 'Copyright'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beGlossary
	self rel: 'Glossary'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beHelp
	self rel: 'Help'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beIndex
	self rel: 'Index'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beNext
	self rel: 'Next'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
bePrev
	self rel: 'Prev'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
bePrevious
	self rel: 'Prev'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beSection
	self rel: 'Section'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beStart
	self rel: 'Start'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beStylesheet
	self rel: 'Stylesheet'! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:31'!
beSubsection
	self rel: 'Subsection'! !

!HVLinkableTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 20:31'!
charSet: aString
	self attributeAt: 'charset' put: aString! !

!HVLinkableTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 20:32'!
contentType: aString
	self type: aString! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromAlternate
	self rev: 'Alternate'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromAppendix
	self rev: 'Appendix'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromBookmark
	self rev: 'Bookmark'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromChapter
	self rev: 'Chapter'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromContents
	self rev: 'Contents'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromCopyright
	self rev: 'Copyright'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromGlossary
	self rev: 'Glossary'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromHelp
	self rev: 'Help'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromIndex
	self rev: 'Index'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromNext
	self rev: 'Next'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromPrev
	self rev: 'Prev'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromPrevious
	self rev: 'Prev'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromSection
	self rev: 'Section'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromStart
	self rev: 'Start'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromStylesheet
	self rev: 'Stylesheet'! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
fromSubsection
	self rev: 'Subsection'! !

!HVLinkableTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 20:32'!
href: aString
	self attributeAt: 'href' put: aString! !

!HVLinkableTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 20:32'!
hrefLang: aString
	self attributeAt: 'hreflang' put: aString! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:32'!
rel: aString
	self attributeAt: 'rel' put: aString! !

!HVLinkableTag methodsFor: 'attributes - relationships' stamp: 'gc 7/31/2007 20:32'!
relationship: aString
	self rel: aString! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
rev: aString
	self attributeAt: 'rev' put: aString! !

!HVLinkableTag methodsFor: 'attributes - reverse links' stamp: 'gc 7/31/2007 20:32'!
reverseLink: aString
	self rev: aString! !

!HVLinkableTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 20:33'!
type: aString
	self attributeAt: 'type' put: aString! !

HVCommonTag subclass: #HVMapTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVMapTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 14:52'!
classes: aCollection
	HVAttributeError signal: 'map tag can have one class only'! !

!HVMapTag methodsFor: 'accessing' stamp: 'gc 7/31/2007 14:04'!
tag
	^ 'map'! !

HVCommonTag subclass: #HVObjectTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 15:39'!
archive: aString
	self attributeAt: 'archive' put: aString! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 15:41'!
archives: aCollection
	| archives |
	archives := WriteStream on: String new.
	aCollection
		do: [:each | archives nextPutAll: each]
		separatedBy: [archives nextPutAll: ' '].
	self attributeAt: 'archive' put: archives contents! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 15:30'!
classId: aString
	self attributeAt: 'classid' put: aString! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 15:31'!
codeBase: aString
	self attributeAt: 'codebase' put: aString! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 15:31'!
codeType: aString
	self attributeAt: 'codetype' put: aString! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 15:34'!
data: aString
	self attributeAt: 'data' put: aString! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 15:44'!
declare
	self attributeAt: 'declare' put: 'declare'! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/30/2007 18:36'!
declareOnly
	self declare! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 20:54'!
height: anInteger
	self attributeAt: 'height' putNumber: anInteger ! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 15:54'!
name: aString
	self attributeAt: 'name' put: aString! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 15:46'!
standby: aString
	self attributeAt: 'standby' put: aString! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 20:56'!
tabIndex: anInteger
	self attributeAt: 'tabindex' putNumber: anInteger! !

!HVObjectTag methodsFor: 'accessing' stamp: 'gc 7/24/2007 15:28'!
tag
	^ 'object'! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 15:36'!
type: aString
	self attributeAt: 'type' put: aString! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 14:57'!
useMap: aString
	self attributeAt: 'usemap' put: aString! !

!HVObjectTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 20:56'!
width: anInteger
	self attributeAt: 'width' putNumber: anInteger! !

HVCommonTag subclass: #HVOptionGroupTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVOptionGroupTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:25'!
disabled
	self attributeAt: 'disabled' put: 'disabled'! !

!HVOptionGroupTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:26'!
label: aString
	self attributeAt: 'label' put: aString! !

!HVOptionGroupTag methodsFor: 'accessing' stamp: 'gc 7/24/2007 18:22'!
tag
	^ 'optgroup'! !

HVCommonTag subclass: #HVOptionTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVOptionTag methodsFor: 'attributes' stamp: 'gc 7/31/2007 12:17'!
disabled
	self attributeAt: 'disabled' put: 'disabled'! !

!HVOptionTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:05'!
label: aString
	self attributeAt: 'label' put: aString.! !

!HVOptionTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:05'!
selected
	self attributeAt: 'selected' put: 'selected'! !

!HVOptionTag methodsFor: 'accessing' stamp: 'gc 7/17/2007 11:34'!
tag
	^ 'option'! !

!HVOptionTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 15:05'!
value: aString
	self attributeAt: 'value' put: aString.! !

HVCommonTag subclass: #HVRubyTextTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVRubyTextTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 16:07'!
rubyBaseSpan: anInteger
	self attributeAt: 'rbspan' putNumber: anInteger! !

!HVRubyTextTag methodsFor: 'accessing' stamp: 'gc 7/25/2007 16:06'!
tag
	^ 'rt'! !

HVCommonTag subclass: #HVScriptTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVScriptTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 15:08'!
charSet: aString
	self attributeAt: 'charset' put: aString! !

!HVScriptTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 15:09'!
deferred
	self attributeAt: 'defer' put: 'defer'! !

!HVScriptTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 15:10'!
source: aString
	self attributeAt: 'src' put: aString! !

!HVScriptTag methodsFor: 'accessing' stamp: 'gc 7/25/2007 14:59'!
tag
	^ 'script'! !

!HVScriptTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 15:10'!
type: aString
	self attributeAt: 'type' put: aString! !

!HVScriptTag methodsFor: 'printing' stamp: 'gc 7/31/2007 20:20'!
with: aBlock
	self attributeAt: 'type' ifAbsent: [self attributeError: 'type not set'].
	^ super with: aBlock! !

HVCommonTag subclass: #HVTableElementTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

HVTableElementTag subclass: #HVTableCellTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVTableCellTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:32'!
abbreviation: aString
	self attributeAt: 'abbr' put: aString! !

!HVTableCellTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:35'!
axis: aString
	self attributeAt: 'axis' put: aString! !

!HVTableCellTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 21:07'!
columnGroupScope
	self scope: 'colgroup'! !

!HVTableCellTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 21:06'!
columnScope
	self scope: 'col'! !

!HVTableCellTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:56'!
columnSpan: anInteger
	self attributeAt: 'colspan' putNumber: anInteger! !

!HVTableCellTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 21:02'!
headers: aCollection
	| headers |
	headers := WriteStream on: String new.
	aCollection do: [:each | headers nextPutAll: each] separatedBy: [headers nextPutAll: ','].
	self attributeAt: 'headers' put: headers contents! !

!HVTableCellTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 21:06'!
rowGroupScope
	self scope: 'rowgroup'! !

!HVTableCellTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 21:05'!
rowScope
	self scope: 'row'! !

!HVTableCellTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 21:03'!
rowSpan: anInteger
	self attributeAt: 'rowspan' putNumber: anInteger! !

!HVTableCellTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 21:05'!
scope: aString
	self attributeAt: 'scope' put: aString! !

HVTableElementTag subclass: #HVTableColumnElementTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVTableColumnElementTag methodsFor: 'attributes - table' stamp: 'gc 7/31/2007 13:35'!
relativeWidth: aString
	self attributeAt: 'width' put: aString! !

!HVTableColumnElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 23:29'!
span: anInteger
	self attributeAt: 'span' putNumber: anInteger ! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:33'!
alignment: aString
	self attributeAt: 'align' put: aString! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:34'!
baselineAlignment
	self verticalAlignment: 'baseline'! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:34'!
bottomAlignment
	self verticalAlignment: 'bottom'! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:33'!
centerAlignment
	self alignment: 'center'! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/31/2007 12:30'!
character: aCharacter
	| alignment |
	alignment := self attributeAt: 'align' ifAbsent: ['left'].
	(alignment = 'char') ifFalse: [self attributeError: 'Alignment must be "char"'].
	self attributeAt: 'char' put: aCharacter asString! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:33'!
characterAlignment
	self alignment: 'char'! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/31/2007 12:31'!
characterOffset: anInteger 
	self attributeAt: 'char'
		ifAbsent: [self attributeError: 'Must specify alignment character'].
	self attributeAt: 'charoff' putNumber: anInteger! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:33'!
justifiedAlignment
	self alignment: 'justify'! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:33'!
leftAlignment
	self alignment: 'left'! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:34'!
middleAlignment
	self verticalAlignment: 'middle'! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:33'!
rightAlignment
	self alignment: 'right'! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:34'!
topAlignment
	self verticalAlignment: 'top'! !

!HVTableElementTag methodsFor: 'attributes - table' stamp: 'gc 7/24/2007 20:34'!
verticalAlignment: aString
	self attributeAt: 'valign' put: aString! !

HVCommonTag subclass: #HVTableTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:44'!
aboveFrame
	self frame: 'above'! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:58'!
allRules
	self rules: 'all'
	! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:45'!
belowFrame
	self frame: 'below'! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 20:57'!
border: anInteger
	self attributeAt: 'border' putNumber: anInteger
	! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:45'!
borderFrame
	self frame: 'border'! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:46'!
boxFrame
	self frame: 'box'! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 20:58'!
cellPadding: anInteger
	self attributeAt: 'cellpadding' putNumber: anInteger 
	! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:41'!
cellSpacing: anInteger
	self attributeAt: 'cellspacing' put: anInteger asString
	! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:57'!
columnRules
	self rules: 'cols'
	! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:43'!
frame: aString
	self attributeAt: 'frame' put: aString
	! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:57'!
groupRules
	self rules: 'groups'
	! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:49'!
horizontalFrame
	self frame: 'hsides'! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:51'!
leftSideFrame
	self frame: 'lhs'! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:58'!
noRules
	self rules: 'none'
	! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:51'!
rightSideFrame
	self frame: 'rhs'! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:56'!
rowRules
	self rules: 'rows'
	! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:54'!
rules: aString
	self attributeAt: 'rules' put: aString
	! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 19:01'!
summary: aString
	self attributeAt: 'summary' put: aString! !

!HVTableTag methodsFor: 'accessing' stamp: 'gc 7/24/2007 18:37'!
tag
	^ 'table'! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:53'!
verticalFrame
	self frame: 'vsides'! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 18:52'!
voidFrame
	self frame: 'void'! !

!HVTableTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 20:58'!
width: anInteger
	self attributeAt: 'width' putNumber: anInteger
	! !

HVCommonTag subclass: #HVTextTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

HVTextTag subclass: #HVEditTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVEditTag methodsFor: 'attributes' stamp: 'gc 7/24/2007 17:12'!
dateTime: aString
	self attributeAt: 'datetime' put: aString! !

!HVTextTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 23:13'!
cite: aString
	^ self attributeAt: 'cite' put: aString! !

HVBasicTag subclass: #HVHeadTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVHeadTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 14:55'!
profile: aString
	self attributeAt: 'profile' put: aString! !

!HVHeadTag methodsFor: 'attributes' stamp: 'gc 7/30/2007 15:04'!
profiles: aCollection
	| profiles |
	profiles := WriteStream on: String new.
	aCollection
		do: [:each | profiles nextPutAll: each]
		separatedBy: [profiles nextPutAll: ' '].
	self attributeAt: 'profile' put: profiles contents! !

!HVHeadTag methodsFor: 'accessing' stamp: 'gc 2/8/2007 11:27'!
tag
	^ 'head'! !

HVBasicTag subclass: #HVHtmlTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVHtmlTag class methodsFor: 'constants' stamp: 'gc 2/8/2007 21:36'!
xmlns
	^ 'http://www.w3.org/1999/xhtml'! !

!HVHtmlTag methodsFor: 'accessing' stamp: 'gc 2/7/2007 20:11'!
tag
	^ 'html'! !

!HVHtmlTag methodsFor: 'attributes' stamp: 'gc 7/30/2007 15:09'!
version: aString
	self attributeAt: 'version' put: aString! !

!HVHtmlTag methodsFor: 'printing' stamp: 'gc 7/30/2007 15:05'!
with: aBlock
	self attributeAt: 'xmlns' ifAbsentPut: self class xmlns.
	^ super with: aBlock ! !

!HVHtmlTag methodsFor: 'attributes' stamp: 'gc 7/23/2007 14:55'!
xmlns: aString
	self attributeAt: 'xmlns' put: aString! !

HVBasicTag subclass: #HVStyleTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVStyleTag methodsFor: 'attributes - media' stamp: 'gc 7/25/2007 15:22'!
allMedia
	self media: 'all'! !

!HVStyleTag methodsFor: 'attributes - media' stamp: 'gc 7/25/2007 15:27'!
auralMedia
	self media: 'aural'! !

!HVStyleTag methodsFor: 'attributes - media' stamp: 'gc 7/25/2007 15:27'!
brailleMedia
	self media: 'braille'! !

!HVStyleTag methodsFor: 'attributes - media' stamp: 'gc 7/25/2007 15:26'!
handheldMedia
	self media: 'handheld'! !

!HVStyleTag methodsFor: 'attributes - media' stamp: 'gc 7/25/2007 15:21'!
media: aString
	self attributeAt: 'media' put: aString! !

!HVStyleTag methodsFor: 'attributes - events' stamp: 'gc 7/25/2007 15:19'!
onEvent: event do: aString
	self doesNotUnderstandAttribute: 'on', event! !

!HVStyleTag methodsFor: 'attributes - media' stamp: 'gc 7/25/2007 15:26'!
printMedia
	self media: 'print'! !

!HVStyleTag methodsFor: 'attributes - media' stamp: 'gc 7/25/2007 15:25'!
projectionMedia
	self media: 'projection'! !

!HVStyleTag methodsFor: 'attributes - media' stamp: 'gc 7/25/2007 15:22'!
screenMedia
	self media: 'screen'! !

!HVStyleTag methodsFor: 'accessing' stamp: 'gc 7/25/2007 15:16'!
tag
	^ 'style'! !

!HVStyleTag methodsFor: 'attributes - media' stamp: 'gc 7/25/2007 15:22'!
ttyMedia
	self media: 'tty'! !

!HVStyleTag methodsFor: 'attributes - media' stamp: 'gc 7/25/2007 15:23'!
tvMedia
	self media: 'tv'! !

!HVStyleTag methodsFor: 'attributes' stamp: 'gc 7/25/2007 15:28'!
type: aString
	self attributeAt: 'type' put: aString! !

HVTag subclass: #HVParameterTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas'!

!HVParameterTag methodsFor: 'attributes - object' stamp: 'gc 7/24/2007 16:30'!
beData
	self valueType: 'data'! !

!HVParameterTag methodsFor: 'attributes - object' stamp: 'gc 7/24/2007 16:31'!
beObject
	self valueType: 'object'! !

!HVParameterTag methodsFor: 'attributes - object' stamp: 'gc 7/24/2007 16:32'!
beReference
	self valueType: 'ref'! !

!HVParameterTag methodsFor: 'attributes - object' stamp: 'gc 7/30/2007 18:47'!
id: aString
	self attributeAt: 'id' put: aString! !

!HVParameterTag methodsFor: 'attributes - object' stamp: 'gc 7/24/2007 16:25'!
name: aString
	self attributeAt: 'name' put: aString! !

!HVParameterTag methodsFor: 'accessing' stamp: 'gc 7/24/2007 16:05'!
tag
	^ 'param'! !

!HVParameterTag methodsFor: 'attributes - object' stamp: 'gc 7/24/2007 16:32'!
type: aString
	self attributeAt: 'type' put: aString! !

!HVParameterTag methodsFor: 'attributes - object' stamp: 'gc 7/24/2007 16:27'!
value: aString
	self attributeAt: 'value' put: aString! !

!HVParameterTag methodsFor: 'attributes - object' stamp: 'gc 7/24/2007 16:30'!
valueType: aString
	self attributeAt: 'valuetype' put: aString! !

!HVParameterTag methodsFor: 'printing' stamp: 'gc 7/31/2007 12:27'!
with: aBlock
	self
		attributeAt: 'name'
		ifAbsent: [self attributeError: 'name can''t be null'].
	self canvas
		nextPut: $<;
		nextPutAll: self tag.
	self attributes keysAndValuesDo: [:key :value | self putAttribute: key value: value].
	self canvas nextPutAll: '/>'! !

!HVTag class methodsFor: 'instance creation' stamp: 'gc 7/26/2007 13:30'!
canvas: aCanvas
	^ self new canvas: aCanvas ! !

!HVTag class methodsFor: 'instance creation' stamp: 'gc 7/26/2007 14:10'!
tag: aString
	^ self new initializeWith: aString! !

!HVTag methodsFor: 'attributes' stamp: 'gc 7/26/2007 13:30'!
attributeAt: key
	^ attributes at: key! !

!HVTag methodsFor: 'attributes' stamp: 'gc 7/26/2007 13:30'!
attributeAt: key ifAbsent: aBlock
	^ attributes at: key ifAbsent: aBlock! !

!HVTag methodsFor: 'attributes' stamp: 'gc 7/26/2007 13:30'!
attributeAt: key ifAbsentPut: aBlock
	^ attributes at: key ifAbsentPut: aBlock! !

!HVTag methodsFor: 'attributes' stamp: 'gc 7/26/2007 13:30'!
attributeAt: key put: value
	^ attributes at: key put: value! !

!HVTag methodsFor: 'error handling' stamp: 'gc 7/30/2007 14:00'!
attributeError: key 
	HVAttributeError signal: key! !

!HVTag methodsFor: 'private' stamp: 'gc 7/26/2007 13:30'!
attributes
	^ attributes ! !

!HVTag methodsFor: 'accessing' stamp: 'gc 7/26/2007 13:24'!
canvas
	^canvas! !

!HVTag methodsFor: 'accessing' stamp: 'gc 7/26/2007 13:24'!
canvas: anObject
	canvas := anObject! !

!HVTag methodsFor: 'private' stamp: 'gc 7/26/2007 14:09'!
closeTag
	self closeTag: self tag! !

!HVTag methodsFor: 'private' stamp: 'gc 7/26/2007 14:09'!
closeTag: tag 
	(self canvas)
		nextPutAll: '</';
		nextPutAll: tag;
		nextPut: $>! !

!HVTag methodsFor: 'error handling' stamp: 'gc 7/26/2007 14:08'!
doesNotUnderstandAttribute: aString
	^ (HVAttributeNotUnderstood
		tag: self
		attribute: aString) signal! !

!HVTag methodsFor: 'initialize-release' stamp: 'gc 7/26/2007 13:30'!
initialize
	attributes := Dictionary new.! !

!HVTag methodsFor: 'initialize-release' stamp: 'gc 7/26/2007 14:08'!
initializeWith: aString
	tag := aString! !

!HVTag methodsFor: 'private' stamp: 'gc 7/26/2007 14:09'!
openTag
	self openTag: self tag! !

!HVTag methodsFor: 'private' stamp: 'gc 7/26/2007 14:09'!
openTag: tag 
	(self canvas)
		nextPut: $<;
		nextPutAll: tag.
	self attributes 
		keysAndValuesDo: [:key :value | self putAttribute: key value: value].
	self canvas nextPut: $>! !

!HVTag methodsFor: 'private' stamp: 'gc 7/26/2007 14:09'!
putAttribute: key value: value 
	^ (self canvas)
		nextPut: Character space;
		nextPutAll: key;
		nextPut: $=;
		nextPut: $";
		nextPutAll: value;
		nextPut: $"! !

!HVTag methodsFor: 'accessing' stamp: 'gc 7/26/2007 14:08'!
tag
	^ tag! !

!HVTag methodsFor: 'accessing' stamp: 'gc 7/26/2007 14:08'!
tag: aString
	tag := aString! !

!HVTag methodsFor: 'private' stamp: 'gc 7/26/2007 14:09'!
tag: aTag do: aBlock 
	self openTag: aTag.
	aBlock value.
	self closeTag: aTag! !

!HVTag methodsFor: 'html' stamp: 'gc 7/30/2007 15:22'!
text: aString 
	self with: [self canvas nextPutAll: aString]! !

!HVTag methodsFor: 'printing' stamp: 'gc 7/26/2007 14:10'!
with: aBlock
	^ self tag: self tag do: aBlock! !

Object subclass: #HVTodoList
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Examples'!

!HVTodoList commentStamp: 'gk 10/24/2003 10:58' prior: 0!
This is a very simple domain object for a todolist. I only have an OrderedCollection holding the items and a few simple methods for adding and removing items from the collection.

This class contains no code whatsoever specific to HttpView.!

!HVTodoList class methodsFor: 'instance creation' stamp: 'gh 2/12/2002 10:36'!
new
	^super new initialize! !

!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
addItem: item

	^items add: item! !

!HVTodoList methodsFor: 'initialize-release' stamp: 'gh 2/12/2002 10:36'!
initialize
	items _ OrderedCollection new! !

!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
items

	^items! !

!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
removeItem: item

	^items remove: item! !

Object subclass: #HVUrlStream
	instanceVariableNames: 'url stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Base'!

!HVUrlStream commentStamp: 'gk 12/10/2003 10:12' prior: 0!
A HVUrlStream is a PositionableStream on a URL path.
We could just use a ReadStream on the path itself - but this way both the url and the stream on the path is kept together in one unit. We can also add some special behavior.
!

!HVUrlStream class methodsFor: 'instance creation' stamp: 'gk 12/9/2003 14:56'!
on: aUrl
	"Return a stream on the url."

	^self new url: aUrl! !

!HVUrlStream class methodsFor: 'instance creation' stamp: 'gk 4/2/2004 15:23'!
onString: aUrlString
	"Return a stream on the url."

	^self new url: (Url absoluteFromText: aUrlString)! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 4/5/2004 11:39'!
back
	"Back up one step in the stream."

	stream position: ((stream position - 1) max: 1)! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 4/7/2004 14:38'!
back: anInteger
	"Back up some steps in the stream."

	stream position: ((stream position - anInteger) max: 1)! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 5/17/2005 14:35'!
back: x with: aStringOrSymbol
	"Return a absolute url of the rest of the path
	with <aStringOrSymbol> appended, separated
	with /-characters, like this:

	/dabba/<aStringOrSymbol>"

	| part here |	
	^String streamContents: [:s |
		here _ stream position.
		self back: x.
		[stream atEnd] whileFalse: [
			part _ stream next.
			part ifNotNil: [
				s nextPut: $/; nextPutAll: part]].
		stream position: here.
		s nextPut: $/; nextPutAll: aStringOrSymbol]! !

!HVUrlStream methodsFor: 'private' stamp: 'gk 4/6/2005 15:39'!
decode: aString
	^aString ifNotNil: [aString unescapePercents utf8ToIso isoToSqueak]! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 4/7/2004 14:31'!
fullPath
	"Return an absolute url of the full path
	separated with /-characters, like this:

	/aba/dabba"

	| path |
	path _ url path.	
	^String streamContents: [:s |
		path do: [:part |
			part isEmpty ifFalse: [
				s nextPut: $/; nextPutAll: part]]]! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 3/29/2004 11:46'!
last
	"Return the last path part.
	nil is used as a last element marker."

	^stream last! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 1/5/2005 13:24'!
next
	"Return the next path part.
	nil is used as a last element marker."

	^self decode: stream next! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 12/10/2003 01:00'!
path
	"Return an absolute url of the current path
	separated with /-characters, like this:

	/aba/dabba"

	| path part |
	path _ url path.	
	^String streamContents: [:s |
		1 to: stream position - 1 do: [:i |
			part _ path at: i.
			part isEmpty ifFalse: [
				s nextPut: $/; nextPutAll: part]]]! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 4/13/2005 14:00'!
pathElements
	^url path! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 10/12/2005 02:42'!
pathWith: aStringOrSymbol
	"Return a absolute url of the full path
	up to the current position
	with <aStringOrSymbol> appended, separated
	with /-characters, like this:

	/aba/dabba/<aStringOrSymbol>"

	| path part |
	path _ stream contents.	
	^String streamContents: [:s |
		1 to: stream position do: [:i |
			part _ path at: i.
			part isEmptyOrNil ifFalse: [
				s nextPut: $/; nextPutAll: part]].
		s nextPut: $/; nextPutAll: aStringOrSymbol]! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 3/29/2004 11:47'!
pathWithPrefix: aStringOrSymbol
	"Return a relative url of the current path
	with <aStringOrSymbol> prepended to the current last
	path part. Path parts are separated with /-characters,
	like this:

	/aba/dabba/<aStringOrSymbol>yabba"

	| path lastPart |
	lastPart _ self last.
	lastPart ifNotNil: [
		path _ url path.	
		^String streamContents: [:s |
			1 to: stream position - 1 do: [:i |
				s nextPut: $/; nextPutAll: (path at: i)].
			s nextPut: $/; nextPutAll: aStringOrSymbol, lastPart]]! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 1/5/2005 13:24'!
peek
	"Return the next path part without moving forward
	in the stream. nil is used as a last element marker."

	^self decode: stream peek! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/9/2003 14:57'!
position

	^stream position! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/9/2003 14:56'!
position: pos

	stream position: pos! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/9/2003 14:57'!
reset

	^stream reset! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 5/17/2005 14:29'!
restWith: aStringOrSymbol
	"Return a absolute url of the rest of the path
	with <aStringOrSymbol> appended, separated
	with /-characters, like this:

	/dabba/<aStringOrSymbol>"

	| part here |	
	^String streamContents: [:s |
		here _ stream position.
		[stream atEnd] whileFalse: [
			part _ stream next.
			part isEmpty ifFalse: [
				s nextPut: $/; nextPutAll: part]].
		stream position: here.
		s nextPut: $/; nextPutAll: aStringOrSymbol]! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 4/7/2004 14:37'!
setToEnd

	^stream setToEnd! !

!HVUrlStream methodsFor: 'initialize-release' stamp: 'gk 12/9/2003 15:00'!
url
	^url! !

!HVUrlStream methodsFor: 'initialize-release' stamp: 'gk 3/29/2004 11:48'!
url: aUrl

	url _ aUrl.
	stream _ ReadStream on: (aUrl path copyWith: nil)! !

Object subclass: #MacroProcessor
	instanceVariableNames: 'start end block deep recurse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Extras-Swiki'!

!MacroProcessor commentStamp: '<historical>' prior: 0!
MacroProcessor is a preprocessor that can process a String and given a startString and an endString it will call a given model (or a pluggable block) to expand the contents found between those markers. The content between one such pair of start/end markers is called a macro.

It can either do one level expansion (not further expanding macros possibly produced by the expansions) or do deep expansion which means it will immediately try to further expand produced expansions. It can also be configured to not recurse, which means it will not process the macro itself before expanding it. If recursing it will do left to right, inner first expansion.

Default is to do both deep and recursive processing, see MacroProcessorTest for more details.

Trivial example just numbering the marked sections recursively showing left to right, inner first:
| proc i |
i _ 0.
proc _ MacroProcessor block: [:x |  i _ i + 1. x, '(', i asString, ')'] between: '[' and: ']'.
proc process: 'Some sections I want numbered: [banana] and ["First [apple] then [orange]"]'

Typical ASP-ish expansion:
| proc |
proc _ MacroProcessor block: [:x | (Compiler evaluate: '3+4') asString] between: '<%' and: '%>'.
proc process: 'This code: 3+4 evaluates to: <% 3+4 %>'

!

!MacroProcessor class methodsFor: 'instance creation' stamp: 'gk 1/11/2005 16:20'!
block: aBlock between: startString and: endString
	^self new block: aBlock startString: startString endString: endString ! !

!MacroProcessor class methodsFor: 'instance creation' stamp: 'gk 1/11/2005 16:20'!
model: aModel between: startString and: endString
	^self new
		block: [:value | aModel expandMacro: value]
		startString: startString
		endString: endString! !

!MacroProcessor methodsFor: 'initialize-release' stamp: 'gk 1/12/2005 15:10'!
block: aPluggableBlock startString: startString endString: endString
	block _ aPluggableBlock.
	start _ startString.
	end _ endString.
	deep _ true.
	recurse _ true! !

!MacroProcessor methodsFor: 'accessing' stamp: 'gk 7/8/2006 14:40'!
deep: aBoolean
	"Set if expanded macros should also be processed in turn."

	deep := aBoolean! !

!MacroProcessor methodsFor: 'accessing' stamp: 'gk 1/10/2005 10:59'!
endString: aString
	end _ aString! !

!MacroProcessor methodsFor: 'private' stamp: 'gk 1/11/2005 16:21'!
expandMacro: macro
	"Just let the pluggable block do it."

	^block value: macro! !

!MacroProcessor methodsFor: 'processing' stamp: 'gk 7/8/2006 12:54'!
findCorrespondingEndIn: template startingAt: lastPos
	"Since macros can nest - we need to find corresponding end."

	| endPos startPos pos nestLevel |
	endPos := template findString: end startingAt: lastPos.
	"Was there a start before it? If not we are done."
	startPos := template findString: start startingAt: lastPos.
	(startPos = 0 or: [startPos > endPos]) ifTrue: [^endPos].
	
	"Ok, it is nested, need to unwind enclosed pairs"
	pos := lastPos+1.
	nestLevel := 1.
	[ pos <= template size ] whileTrue: [
		(template findString: start startingAt: pos) = pos ifTrue: [ nestLevel := nestLevel + 1 ].
		(template findString: end startingAt: pos) = pos ifTrue: [ nestLevel := nestLevel - 1 ].
		nestLevel = 0 ifTrue: [ ^pos ].
		pos := pos + 1].
	self error: 'Corresponding end marker not found when processing macros'! !

!MacroProcessor methodsFor: 'initialize-release' stamp: 'gk 1/11/2005 16:18'!
model: aModel startString: startString endString: endString
	self block: [:value | aModel expandMacro: value] startString: startString endString: endString
! !

!MacroProcessor methodsFor: 'processing' stamp: 'gk 7/8/2006 12:50'!
process: template
	"For all substrings enclosed within the end/start markers,
	send #macro: with the enclosed string to the model for expansion.
	When #recurse is true we recursively process the enclosed strings
	before expanding them using #macro:. This leads to an inner first
	expansion, meaning that:
	
	   ....[some macro with [an inner macro]]...

	would lead to:

		model macro: 'an inner macro'; macro: 'some macro with xxx'

	(xxx is the presumed result of expanding the first inner macro)"

	| lastPos pos result content continue |
	(template includesSubString: start) ifFalse:[^template].
	continue := true.
	^String streamContents: [:stream |
		lastPos := 1.
		[continue and: [
			pos := template findString: start startingAt: lastPos.
			pos ~= 0]] whileTrue: [
			stream nextPutAll: (template copyFrom: lastPos to: pos - 1).
			lastPos := pos + start size.
			pos := self findCorrespondingEndIn: template startingAt: lastPos.
			pos = 0 ifTrue: [
				lastPos := pos.
				continue := false
			] ifFalse: [
				content := template copyFrom: lastPos to: pos - 1.
				result := (self expandMacro: (recurse ifTrue: [self process: content] ifFalse: [content])).
				stream nextPutAll: (deep ifTrue: [self process: result] ifFalse: [result]).
				lastPos := pos + end size]].
		stream nextPutAll: (template copyFrom: lastPos to: template size)]! !

!MacroProcessor methodsFor: 'processing' stamp: 'gk 7/8/2006 12:52'!
quote: aString
	"The model can call this method in its #expandMacro: method
	if it does not want the macro to be expanded like this:
	
	expandMacro: aString
		^macroProcessor quote: aString
	"

	^start, aString, end! !

!MacroProcessor methodsFor: 'accessing' stamp: 'gk 7/8/2006 14:40'!
recurse: aBoolean
	"Set if macros inside macros should be expanded
	left to right, inner first - before the macro itself
	is expanded."

	recurse := aBoolean! !

!MacroProcessor methodsFor: 'accessing' stamp: 'gk 1/10/2005 10:58'!
startString: aString
	start _ aString! !

Object subclass: #SwikiFormatter
	instanceVariableNames: 'model base inParagraph targetStream lastWasCR consumeCR ulLevel olLevel renderParagraphs macroProcessor builder'
	classVariableNames: 'SpecialCharacterString SpecialCharacter EmCharacter AngleBrackets EmCharacterString'
	poolDictionaries: ''
	category: 'HV-Extras-Swiki'!

!SwikiFormatter commentStamp: 'gk 7/8/2006 16:57' prior: 0!
This class is a reimplementation of the swikification (very similar syntax as used in the original Swiki) parser/HTML generator. It is very direct (and hackishly written) but small.

The instvar #model is used for resolving links and the model must implement #urlForLink:.

Swikification rules are:

- Headings are done with starting the line with !! (!! -> h1, !!!! -> h2, !!!!!! -> h3)
- An empty line ends current paragraph if a paragraph is in progress, otherwise it generates a <br />.
- Ordered lists are done using '#' and can nest.
- Unordered lists are done using '-' and can nest.
- Bold can be done using underscores: _something bold_
- Regular markup is untouched: <b>something</b> or <i>italic</i>
- Text between <html>....</thml> is totally untouched.
- A line starting with | produces a <hr>
- Links are done using *something*:
	*textOrImage|something* : Link to something but showing text or image for link (this is different from regular Swiki which uses '>'). 
- Also map:
	'**'		-> '*'
	'__'		-> '_' (unless inside a *-pair)
	'<<'		-> '&lt;'
	'>>'		-> '&gt;'
	'&&'	-> '&amp;'
- Images can be placed using *[x]animage.jpg* where x = l, r or c (left, right, center). This adds a CSS class, see #resolveLink:
- Flash animations can be embedded and given extent in pixels using: *100x250|flash.swf*.
- Also does some ASPish macro expansion using syntax <%macro%>, see #expandMacro:
!

!SwikiFormatter class methodsFor: 'instance creation' stamp: 'gk 7/8/2006 15:14'!
base: anUrl model: aModel

	| formatter |
	formatter _ self new.
	formatter base: anUrl model: aModel.
	^formatter! !

!SwikiFormatter class methodsFor: 'initialize-release' stamp: 'gk 7/8/2006 15:14'!
initialize
	"self initialize"

	AngleBrackets _ CharacterSet newFrom: #($< $>).
	SpecialCharacter _ $*.
	SpecialCharacterString _ SpecialCharacter asString.
	EmCharacter _ $_.
	EmCharacterString _ EmCharacter asString! !

!SwikiFormatter methodsFor: 'accessing' stamp: 'gk 7/8/2006 15:14'!
base: anUrl model: aModel

	renderParagraphs _ true.
	base _ anUrl.
	model _ aModel.
	macroProcessor _ MacroProcessor model: self between: '<%' and: '%>'.
	macroProcessor deep: false! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
countLevel: char in: aLine
	"Start the paragraph."

	| count |
	count _ 0.
	aLine do: [:c | c = char ifTrue:[count _ count + 1] ifFalse: [^count]]! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
endParagraph
	"End the paragraph."

"	targetStream cr; nextPutAll: '</p>';cr"
	builder close! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
endPossibleLi
	"Ok, close the lis."

	(olLevel > 0 or: [ulLevel > 0]) ifTrue:[builder close]! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
endPossibleOl
	"Ok, close the uls."

	olLevel > 0 ifTrue:[
		builder close.
		olLevel timesRepeat: [builder close].
		olLevel _ 0.
		^true].
	^false! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
endPossibleParagraph
	"End the paragraph if we are in it."

"	inParagraph ifTrue: [targetStream cr; nextPutAll: '</p>';cr. inParagraph _ false]"
	inParagraph ifTrue: [builder close. inParagraph _ false]! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
endPossibleUl
	"Ok, close the uls."

	ulLevel > 0 ifTrue:[
		builder close.
		ulLevel timesRepeat: [builder close].
		ulLevel _ 0.
		^true].
	^false! !

!SwikiFormatter methodsFor: 'macros' stamp: 'gk 7/8/2006 16:36'!
expandMacro: macro
	"Handles some smart macros. If macro expansion fails we
	return it prefixed with Exception message."

	| upper |
	upper := macro asUppercase.

	[upper = 'BASE' ifTrue: [^base].
	upper = 'DATE' ifTrue: [^Date today asString]]
		on: Exception do: [:ex |
			^'Exception: ', ex printString, ', when expanding macro: ', macro].

	"Otherwise include it untouched"
	^macroProcessor quote: macro! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
externalURL: url string: string
	"Make a non-local link."

	^'<a href="', url, '">', string,'</a>'! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 16:51'!
extractCodeFrom: string block: ablock
	"Extract any code inside [] in the string."
	

	| nextIsClass class str |
	nextIsClass := false.
	str := ''.
	class := ''.
	(string findTokens: '[]' keep: '[]') do: [:tok |
		tok = ']' ifFalse: [
			tok = '['
				ifTrue: [nextIsClass := true]
				ifFalse: [
					nextIsClass
						ifTrue: [class := tok. nextIsClass := false]
						ifFalse: [
							str := str, tok]]]].
	class = 'l' ifTrue: [class := 'left-float'] ifFalse: [
	class = 'r' ifTrue: [class := 'right-float'] ifFalse: [
	class = 'c' ifTrue: [class := 'center']]].
	^ablock value: str value: class! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
fixEms: aString
	"Resolve all the emphasizes. Double __ are turned into a single _.
	We ignore underscores within *-pairs."

	| start aLine end tokens inside zero |
	start _ 1.
	zero _ String with: (Character value: 0).
	tokens _ aString findTokens: '*' keep: '*'.
	"We temporarily escape underscores within *-pairs as Character 0."
	inside _ false.
	aLine _ String streamContents: [:stream |
		tokens do: [:token |
			token = '*' ifTrue: [inside _ inside not].
			stream nextPutAll: (
				inside
					ifFalse: [token]
					ifTrue: [token copyReplaceAll: '_' with: zero])]].
	[(start _ aLine indexOfSubCollection: '_' startingAt: start ifAbsent: [0]) ~= 0
			and: [start < aLine size]]
		whileTrue:
			[(aLine at: start+1) = $_
				ifTrue: [aLine _ aLine copyReplaceFrom: start 
								to: start+1 with: '_'.
						start_start + 1]
				ifFalse: [
					(end _ aLine indexOfSubCollection: '_'
						startingAt: (start+1) ifAbsent: [0]) ~= 0
							ifTrue: [aLine _ aLine copyReplaceFrom: start to: end
										with: ('<b>', (aLine copyFrom: start+1 to: end-1), '</b>')]
							ifFalse: [start _ start + 1]]].
	"Revert escape of underscores within *-pairs."
	^aLine copyReplaceAll: zero with: '_'! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
fixLinks: aString
	"Resolve all the links. Double ** are turned into a single *."

	| start aLine end |
	start _ 1.
	aLine _ aString.
	[(start _ aLine indexOfSubCollection: SpecialCharacterString startingAt: start ifAbsent: [0]) ~= 0
		and: [start < aLine size]]
	whileTrue:
		[(aLine at: start+1) = SpecialCharacter "Is it two asterisks in a row?"
			ifTrue: [aLine _ aLine copyReplaceFrom: start 
								to: start+1 with: SpecialCharacterString.
					start_start + 1]
			ifFalse: [
				(end _ aLine indexOfSubCollection: SpecialCharacterString
						startingAt: (start+1) ifAbsent: [0]) ~= 0
					ifTrue: [aLine _ aLine copyReplaceFrom: start to: end
							with: (self resolveLink: (aLine copyFrom: start+1 to: end-1))]
					ifFalse: [start _ start + 1]]].
	^aLine! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
imageURL: url string: string class: class
	"Make a non-local image link."

	string ifNil: [^self img: url class: class]
		ifNotNil: [^self url: string string: (self img: url class: class)]! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
img: url class: class
	"Make an image."

	^'<img src="', url, '" class="', class, '">'! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
isStringAnImage: anUpperCasedString
	"check the string to see if it end with something that makes it likely to be an image URL"
	^(anUpperCasedString endsWith: '.GIF') or:
		[(anUpperCasedString endsWith: '.JPEG') or:
		[(anUpperCasedString endsWith: '.JPG') or:
		[anUpperCasedString endsWith: '.PNG']]]! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
isStringFlash: anUpperCasedString
	"check the string to see if it is a flash file."
	^anUpperCasedString endsWith: '.SWF'! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
isStringRooted: anUpperCasedString
	"check the string to see if it starts with something that makes it
lkely to be a rooted URL"

	^(anUpperCasedString indexOfSubCollection: 'HTTP' startingAt: 1) = 1 or:
	[(anUpperCasedString indexOfSubCollection: 'FTP' startingAt: 1) = 1 or:
	[(anUpperCasedString indexOfSubCollection: 'MAILTO' startingAt: 1) = 1]]! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
localFlashURL: url string: string
	"Make a local flash file embedded, string defines:
		<width>x<height> in pixels."

	| w h path |
	string ifNil: [^''].
	w := string copyUpTo: $x.
	h := string copyFrom: w size + 2 to: string size.
	path := base, '/', url.
	^'<object type="application/x-shockwave-flash" data="', path, '" width="',
		w asString, '" height="', h asString, '"><param name="movie" value="',
		path, '"></param></object>'! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
localURL: url string: string
	"Make a local URL."

	^'<a href="', base, '/', url, '">', string, '</a>'! !

!SwikiFormatter methodsFor: 'macros' stamp: 'gk 7/8/2006 15:14'!
macroProcess: aString
	"Run the string through the MacroProcessor."

	^macroProcessor process: aString! !

!SwikiFormatter methodsFor: 'accessing' stamp: 'gk 7/8/2006 15:14'!
renderParagraphs: aBoolean

	renderParagraphs _ aBoolean! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
resolveLink: aString
	"Resolve the link. Text before an optional '|' is used as the visible string.
	If it is an image url which is then embedded the text before '|' is
	resolved to a link for the image."

	|  parts uurl rooted u string |
	parts := aString findTokens: '|'.
	parts size = 1
		ifTrue:[u := string := aString]
		ifFalse: [u := parts at: 2. string := parts at: 1].
	self extractCodeFrom: u block: [:url :class |
		url := model urlForLink: url.
		uurl := url asUppercase.
		rooted _ self isStringRooted: uurl.
		url _ rooted ifFalse: [base, '/', url] ifTrue: [url].
		(rooted not and: [self isStringFlash: uurl])
			ifTrue: [(parts size = 1)
						ifFalse:[^self localFlashURL: url string: string]
						ifTrue: [^self localFlashURL: url string: nil]].
		(self isStringAnImage: uurl) ifTrue: ["Looks like an image URL"
			(parts size = 1)
				ifFalse:[^self imageURL: url string: (self urlForString: string) class: class]
				ifTrue: [^self imageURL: url string: nil class: class]]
		ifFalse: [^self url: url string: string]]! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
startParagraph
	"Start the paragraph."

	renderParagraphs ifTrue: [
		inParagraph _ true.
		builder p]! !

!SwikiFormatter methodsFor: 'accessing' stamp: 'gk 7/8/2006 15:14'!
swikify: aString builder: aBuilder
	"Swikify the String. This code only handles cutting up
	the String into pieces based on angle brackets and calling
	#swikifyPiece: for each piece outside of a tag.
	&lt; and &gt; are escaped as >> and <<, &amp; with &&.
	Some special tags are also handled."

	| pos index piece tagLevel finished size ignore string |
	aString isEmptyOrNil ifTrue:[^''].
	"Fix escaped characters"
	string _ ((aString copyReplaceAll: '&&' with: '&amp;')
				copyReplaceAll: '>>' with: '&gt;')
					copyReplaceAll: '<<' with: '&lt;'.
	"First we macroprocess separately."
	string _ macroProcessor process: string.
	builder _ aBuilder.
	inParagraph _ finished _ ignore _ false.
	lastWasCR _ true.
	consumeCR _ false.
	ulLevel _ olLevel _ tagLevel _ index _ 0.
	pos _ 1.
	size _ string size.
	[finished ifFalse: [index _ string indexOfAnyOf: AngleBrackets startingAt: pos].
	finished]
		whileFalse: [
			index = 0
				ifTrue:[index _ size. piece _ string copyFrom: pos to: index]
				ifFalse:[piece _ string copyFrom: pos to: index - 1].
			pos _ index + 1.
			(ignore or: [tagLevel > 0])
				ifTrue:["Check special tags"
					(piece = 'nopara') ifTrue:[renderParagraphs _ false] ifFalse:[
					(piece = '/nopara') ifTrue:[renderParagraphs _ true] ifFalse:[
					(piece = 'html') ifTrue:[ignore _ true] ifFalse:[
					(piece = '/html') ifTrue:[ignore _ false] ifFalse:[
					(aBuilder resolveTag: piece) ifFalse:[
						tagLevel = 0
							ifTrue:[builder text: piece]
							ifFalse: [builder text: '<', piece, '>'].
						]]]]]]
				ifFalse:[self swikifyPiece: piece].
			((string at: index) = $<)
				ifTrue: [tagLevel _ tagLevel + 1]
				ifFalse: [tagLevel _ tagLevel - 1].
			finished _ index = size.
		].
	"End any lists"
	self endPossibleUl; endPossibleOl.

	"If we are still in a paragraph we end it."
	self endPossibleParagraph.

	"If we have a hanging CR we add a break."
	consumeCR ifFalse: [lastWasCR ifTrue:[builder break. lastWasCR _ false]].
	^builder! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 16:33'!
swikifyPiece: aString
	"Swikify the String. The string contains CRs as lineendings but may
	end in a middle of a line, that is why we keep state in instance variables.
	An empty line ends current paragraph if a paragraph is in progress,
	otherwise it generates a <br />. See class comment for details."
	 
	| string newLevel |
	string := aString.
	(string findTokens: (String with: Character cr with: Character lf) keep: (String with: Character cr)) do: [:aLine |
		(aLine = (String with: Character cr))
			ifFalse: [ "Not a CR"
				"Convert any links in the line"
				aLine := self fixEms: aLine.
				aLine := self fixLinks: aLine.

				"Check for special line beginnings"
				consumeCR := true.
				lastWasCR ifTrue:[
					(aLine beginsWith: '-')
						ifTrue: [self endPossibleParagraph.
								self endPossibleOl; endPossibleLi.
								newLevel := self countLevel: $- in: aLine.
								newLevel > ulLevel
									ifTrue:[(newLevel - ulLevel) timesRepeat: [builder openTag: 'ul']]
									ifFalse: [(ulLevel - newLevel) timesRepeat: [builder close]].
								builder openTag: 'li'; text: (aLine copyFrom: newLevel + 1 to: aLine size).
								ulLevel := newLevel] ifFalse: [

					(aLine beginsWith: '#')
						ifTrue: [self endPossibleParagraph.
								self endPossibleUl; endPossibleLi.
								newLevel := self countLevel: $# in: aLine.
								newLevel > olLevel
									ifTrue:[(newLevel - olLevel) timesRepeat: [builder openTag: 'ol']]
									ifFalse: [(olLevel - newLevel) timesRepeat: [builder close]].
								builder openTag: 'li'; text: (aLine copyFrom: newLevel + 1 to: aLine size).
								olLevel := newLevel.] ifFalse: [
					self endPossibleOl; endPossibleUl.
					(aLine beginsWith: '|')
						ifTrue: [self endPossibleParagraph.
								builder hr] ifFalse: [
					(aLine beginsWith: '!!!!!!')
						ifTrue: [self endPossibleParagraph.
								builder h3: (aLine copyFrom: 4 to: aLine size)] ifFalse: [
					(aLine beginsWith: '!!!!')
						ifTrue: [self endPossibleParagraph.
								builder h2: (aLine copyFrom: 3 to: aLine size)] ifFalse: [
					(aLine beginsWith: '!!')
						ifTrue: [self endPossibleParagraph.
								builder h1: (aLine copyFrom: 2 to: aLine size)]
						ifFalse: [
							consumeCR := false.
							"Ok, then this is text. If we are not in a paragraph we start one."
							inParagraph
								ifTrue: ["If last was CR we add a break for that until we continue."
										lastWasCR ifTrue:[builder break]]
								ifFalse: [(ulLevel + olLevel = 0) ifTrue:[self startParagraph]].
							builder text: aLine]]]]]]]
				ifFalse: [
					consumeCR := false.
					"Ok, then this is text. If we are not in a paragraph we start one."
					inParagraph
						ifTrue: ["If last was CR we add a break for that until we continue."
								lastWasCR ifTrue:[builder break]]
						ifFalse: [(ulLevel + olLevel = 0) ifTrue:[self startParagraph]].
					builder text: aLine].
				lastWasCR := false]

			 ifTrue: ["A CR"
				"If we are in a paragraph and last was a CR we end it, otherwise we remember this CR."
				consumeCR
					ifTrue: [consumeCR := false. lastWasCR := true]
					ifFalse: [
							lastWasCR
								ifTrue:[(self endPossibleUl | self endPossibleOl)
											ifFalse:[
												inParagraph
													ifTrue:[self endPossibleParagraph]
													ifFalse: [builder break]]]
								ifFalse:[lastWasCR := true]]]]! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
url: url string: string
	"Make a link."

	^'<a href="', url, '">', string,'</a>'! !

!SwikiFormatter methodsFor: 'private' stamp: 'gk 7/8/2006 15:14'!
urlForString: string
	"Turn smart string into a URL."

	(self isStringRooted: string asUppercase)
		ifTrue: [^string]
		ifFalse: [^base, '/', (model urlForLink: string)]
! !

!HttpRequest methodsFor: '*HV-testing' stamp: 'gc 7/13/2007 14:36'!
isSubmitRequest
	self isPostRequest ifTrue: [^ true].
	self isGetRequest ifTrue: [^ self getFields notEmpty ]! !

WVHtmlBuilder subclass: #HVHtmlBuilder
	instanceVariableNames: 'request view fields variables maxCol currentCol lastRadio lastForm response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlBuilder commentStamp: '<historical>' prior: 0!
HVHtmlBuilder builds HTML pages and handles HTML Forms. It has a reference to the HVHttpView that created it (for various services) and to the request of that view.

Typical use is to instantiate it (HVHttpView has a method #builder which creates one), feed it "build messages" and then finally calling #render which will stream out the resulting HTML page. This is an example:

builder _ self builder.
builder start; h1: 'A heading'; postForm; inputText: #name; submit; endForm; end.
builder render

During the build some of the "build messages" return objects that can be used for input and output - typically objects representing Forms, Inputfields, Submit buttons etc. The messages #postForm, #inputText: and #submit all returned objects in the code above but the code chose to ignore them.

The contents message causes the builder to assemble the finished HTML document and return it as a String, but normally you just return the builder itself since HVHtmlBuilder also implements #asHttpResponseTo: which means that it can be returned as a result to Comanche from an 'url' method in a HVHttpView class. So you do not need to call #render and actually, in order to compose pages from multiple methods it is better if you do not call #render.

...

elements - An OrderedCollection holding all elements that constitute the page.
elementStack - An OrderedCollection acting as a stack for certain elements like for example forms.

!

!HVHtmlBuilder class methodsFor: 'instance creation' stamp: 'gh 1/31/2002 14:41'!
request: aRequest view: aView
	^self new request: aRequest view: aView; yourself! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/16/2003 17:54'!
addForm: aForm
	"Add the form to the document.
	The form is also given an id for this page."

	| id |
	id _ lastForm ifNil: [1] ifNotNil: [lastForm id + 1].
	aForm id: id.
	lastForm _ aForm.
	^document pushElement: aForm

! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gk 12/17/2003 11:46'!
addHtmlInput: aVar
	"Add the input variable in the correct Form and
	also add it to the page."

	lastForm addInput: aVar.
	^document addElement: aVar

! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gk 12/17/2003 11:47'!
addVar: aVar
	"Add the variable in the correct Form and
	add it to the document."

	lastForm addInput: aVar. "???"
	^document addElement: aVar

! !

!HVHtmlBuilder methodsFor: 'comanche' stamp: 'gk 3/3/2004 14:38'!
asHttpResponseTo: req
	"We implement this so that a builder can be returned as a
	result from a method rather than a HTML String.
	This also enables nestling of builders in order to compose
	pages by calling other 'submethods'."

	response ifNil: [
		response _ (HttpResponse fromString: self render)
			fieldAt: 'Pragma' put: 'no-cache';
			fieldAt: 'Cache-Control' put: 'no-cache'].
	^response
		! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 2/15/2002 14:11'!
asString
	^self render! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 6/12/2002 10:36'!
at: var ifAbsent: block
	"Low level access to fields - parameters to GET or POST."

	^fields at: var ifAbsent: [^block value]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/16/2003 16:08'!
b: anObject
	self tag: 'b' do: anObject! !

!HVHtmlBuilder methodsFor: 'html-color' stamp: 'edc 10/19/2009 09:59'!
backgroundColor: aHtmlColor 
	self tag: 'BODY BGCOLOR=' , aHtmlColor! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:40'!
blockquote
	^self openTag: 'blockquote'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:38'!
blockquote: anObject
	^self tag: 'blockquote' do: anObject! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 6/12/2002 10:35'!
bodytag
	"This is a way to be able to customize the body.
	Perhaps there are much better ways but this was simple."
	
	^variables at: #bodytag ifAbsent: [nil]

! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 6/12/2002 10:36'!
booleanAt: var ifAbsent: block
	"Customized version for checkboxes."

	^(fields at: var ifAbsent: [^block value]) = 'on'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/16/2003 18:06'!
br
	^self break! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'edc 2/15/2010 09:34'!
buttonImage: url linkTo: link 
	"Embed an image."
	| s |
	s := '<a id="pictureMap"
	href= "' , link , '">' , '<img alt="" ismap="ismap" src="' , url , '">'.
	^ s! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'edc 11/10/2003 10:48'!
buttonImage: url linkTo: link description: desc 
	

	"Embed an image."
	
^ ' <a href= "' , link , '">' , '<img src="' , url , '" alt="' , desc , '" />', '</a>'.
! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:15'!
cell
	^self openTag: 'td'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:15'!
cell: anObject
	^self tag: 'td' do: anObject! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:15'!
cellCenter
	self halt! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'edc 10/14/2009 17:07'!
center: text .
	^ self text: '<h1>' , '<CENTER>' , text , '</CENTER>' , '</h1>'! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 11:42'!
colTab
	currentCol = maxCol
		ifTrue:[self close; close; tr; td.
				currentCol _ 1]
		ifFalse:[self close; td.
				currentCol _ currentCol + 1]! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 12:04'!
colTabTop
	currentCol = maxCol
		ifTrue:[self close; close; attributeAt: 'valign' put: 'top'; tr; td.
				currentCol _ 1]
		ifFalse:[self close; td.
				currentCol _ currentCol + 1]! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 5/12/2004 12:09'!
columns: cols
	self attributeAt: 'border' put: '0';
		 attributeAt: 'cellpadding' put: '2';
		attributeAt: 'cellspacing' put: '0'.
	self table; tr; td.
	maxCol _ cols.
	currentCol _ 1! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 5/18/2004 14:17'!
columnsHeads: heads do: aBlock
	self attributeAt: 'cellpadding' put: '2';
		 attributeAt: 'cellspacing' put: '3'.
	self table; heads: heads; tableBody; tr; td.
	maxCol _ heads size.
	currentCol _ 1.
	aBlock value.
	self close; close; close; close! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 12:02'!
columnsWide: cols
	self attributeAt: 'border' put: '0';
		attributeAt: 'cellpadding' put: '0';
		attributeAt: 'cellspacing' put: '3';
		attributeAt: 'width' put: '100%'.
	self table; tr; td.
	maxCol _ cols.
	currentCol _ 1! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 12:03'!
columnsWideTop: cols
	self attributeAt: 'border' put: '0';
		attributeAt: 'cellpadding' put: '0';
		attributeAt: 'cellspacing' put: '3';
		attributeAt: 'width' put: '100%'.
	self table; attributeAt: 'valign' put: 'top'; tr; td.
	maxCol _ cols.
	currentCol _ 1! !

!HVHtmlBuilder methodsFor: 'buttons' stamp: 'gk 5/18/2004 15:29'!
cssButton

	self text: '<div class="w3cbutton1"><a class="w3c1" href="http://www.w3.org/">W3C</a><a class="spec1" href="http://jigsaw.w3.org/css-validator/check/referer">CSS</a></div>'! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gk 12/16/2003 17:54'!
currentForm
	"Find current form by looking in the stack."

	^lastForm

! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 11:40'!
data
	self halt! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/16/2003 17:15'!
divClass: aString
	"Start a div with a class."

	^document pushElement: (HVHtmlDiv class: aString)! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 4/11/2007 11:57'!
divId: anId
	"Start a div with an id."

	^document pushElement: (HVHtmlDiv id: anId)! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 1/7/2005 11:50'!
end
	"Do nothing, the web page will end properly."! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:04'!
endBlockquote
	^self close! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:14'!
endCell
	^self close! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 10:31'!
endColumns
	"Cell, row, table."
	self close; close; close! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:14'!
endData
	^self close! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/18/2002 13:28'!
endDiv
	^self endTag! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/15/2002 14:52'!
endForm
	^self endTag! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:14'!
endP
	^self close! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 13:39'!
endRadio
	"Close the last radio if we find one."

	lastRadio ifNotNil: [lastRadio close]! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:14'!
endRow
	^self close! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:13'!
endTable
	^self close! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gk 12/16/2003 17:04'!
endTag
	"We assume that the last element on the stack is the correct one."

	^document popElement

	"^elements add: (HVHtmlEndtag for: elementStack removeLast)"! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 9/12/2002 13:23'!
findVar: aName
	"Find a named variable."

	^variables at: aName ifAbsent: [nil]! !

!HVHtmlBuilder methodsFor: 'html-color' stamp: 'edc 10/19/2009 09:59'!
fontColor: aHtmlColor 
	self tag: 'font color="'  , aHtmlColor ! !

!HVHtmlBuilder methodsFor: 'html-color' stamp: 'edc 10/14/2009 16:55'!
fontColorforText: aText isHtmlColor: htmlColor 
	
	
	^self attributeAt: 'color' put: htmlColor; tag: 'font' do: aText! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:16'!
getForm
	"Start a GET form that will return to the same url as this request."

	^self addForm: (HVHtmlForm getAction: request url)! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 9/12/2002 16:06'!
getImage: url
	"Embed an image."

	^'<img src="', url, '" alt="no description" />'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/16/2002 16:03'!
getImage: url description: desc
	"Embed an image."

	^'<img src="', url, '" alt="', desc, '" />'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/10/2003 10:33'!
getLink: url
	"Return a HTML link with the url shown as the text."

	^self getLink: url text: url! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/10/2003 10:33'!
getLink: url text: text
	"Return a HTML link."

	^'<a href="', url, '">', text, '</a>'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 10/12/2005 12:19'!
getLink: relativeUrl text: text view: aView
	"Return a local HTML link to the given view."

	^self getLink: (aView originalUrlFor: relativeUrl) text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 10/12/2005 11:38'!
getLinkLocal: relativeUrl text: text
	"Return a local HTML link to the view."

	^self getLink: (view originalUrlFor: relativeUrl) text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 10/12/2005 00:54'!
getLinkParent: relativeUrl text: text
	"Return a local HTML link to the parent view."

	^self getLink: (view parent originalUrlFor: relativeUrl) text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'edc 10/16/2009 08:22'!
getLinkTop: relativeUrl text: text
	"Return a local HTML link to the top view."

	^self getLink: (view originalUrlFor: relativeUrl) text: text! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:25'!
green: anObject
	^self attributeAt: 'color' put: 'red'; tag: 'font' do: anObject! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:15'!
greyRow
	self halt! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:11'!
h1: anObject
	^self tag: 'h1' do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:55'!
h2: anObject
	^self tag: 'h2' do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:55'!
h3: anObject
	^self tag: 'h3' do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:55'!
h4: anObject
	^self tag: 'h4' do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:55'!
h5: anObject
	^self tag: 'h5' do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:55'!
h6: anObject
	^self tag: 'h6' do: anObject! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 5/18/2004 15:35'!
heads: heads
	"Add heads to a table that has already been started."

	self tableHead: [
		self tableRow: [
			heads do: [:head |
				self attributeAt: 'align' put: 'left'.
				self tableHeading: head]]]
! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 10:04'!
hr
	^self tag: 'hr'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:12'!
html: anObject
	"No encoding made, we just use #asString on anObject."

	^self text: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:40'!
i: anObject
	^self italic: anObject! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gk 12/10/2003 10:42'!
ifPost: aBlock
	"If it is a POST we run the block.
	Better to use #ifPressed: on the submit button." 

	^self isPost ifTrue:[aBlock value]! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gk 12/10/2003 10:42'!
ifSubmit: aBlock
	"If it is a POST or a GET with fields we run the block."

	request isPostRequest ifTrue:[^aBlock value].
	request isGetRequest ifTrue:[request getFields isEmpty ifFalse:[^aBlock value]]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:35'!
image: url description: altString
	"Embed an image."

	^self image: url altText: altString

	"^elements add: (HVHtmlImage url: url alt: desc)"! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:18'!
inputCheckbox
	"Add a checkbox, name is autogenerated and default value is false (unchecked)."

	^self inputCheckbox: self nextVarName value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:18'!
inputCheckbox: name
	"Add a checkbox, use if you need to supply your own name.
	Default value is false (unchecked)."

	^self inputCheckbox: name value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 1/13/2005 13:51'!
inputCheckbox: name value: default
	"Add a checkbox named <name> with default value <default>.
	The value should be false or true. If the current request has
	posted this field then the value is picked from there."

	| val |
	val _ default.
	self ifSubmit: [
		val _ (fields includesKey: name)
			ifTrue:[ (fields at: name) = 'on' ]
			ifFalse: [ false ]].
	^self addHtmlInput: (
		(HVHtmlInputCheckbox named: name attributes: self attributes)
			value: val)! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:20'!
inputCheckboxValue: default
	"Add a checkbox, name is autogenerated and default value is <default>.
	false is unchecked and true is checked."

	^self inputCheckbox: self nextVarName value: default

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 13:15'!
inputFile
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self inputFile: self nextVarName value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 13:16'!
inputFile: name
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self inputFile: name value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 1/13/2005 13:50'!
inputFile: name value: default 
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self addHtmlInput: (
		(HVHtmlInputFile named: name attributes: self attributes)
			value: (fields at: name ifAbsent:[default]))


! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 13:16'!
inputFileValue: default
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self inputFile: self nextVarName value: default

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:22'!
inputHidden
	"Add a hidden field, name is autogenerated and default value is ''."

	^self inputHidden: self nextVarName value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:23'!
inputHidden: name
	"Add a hidden field, use if you need to supply your own name.
	Default value is ''."

	^self inputHidden: name value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 1/13/2005 13:50'!
inputHidden: var value: default 
	"Add a hidden field named <name> with default value <default>.
	The value should be a String. If the current request has
	posted this field then the value is picked from there."

	^self addHtmlInput: (
		(HVHtmlInputHidden named: var attributes: self attributes)
			value: (fields at: var ifAbsent:[default]))

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:24'!
inputHiddenValue: default
	"Add a hidden field, name is autogenerated and default value is <default>.
	The value should be a String."

	^self inputHidden: self nextVarName value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:57'!
inputNumber
	"Add a number field, name is autogenerated and default value is 0."

	^self inputNumber: self nextVarName value: 0

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:58'!
inputNumber: name
	"Add a number field, use if you need to supply your own name.
	Default value is 0."

	^self inputNumber: name value: 0

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:58'!
inputNumber: name size: size
	"Add a number field, use if you need to supply
	your own name and size of field. Default value is 0."

	^self inputNumber: name size: size value: 0
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:00'!
inputNumber: name size: size value: default 
	"Add a number field named <name> with default value <default>
	and length of field to be <size>.
	The value should be a Number. If the current request has
	posted this field then the value is picked from there."

	^self addHtmlInput: (HVHtmlInputNumber name: name value:
		(fields at: name ifAbsent:[default ifNil: [0]]) size: size)

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:01'!
inputNumber: name value: value
	"Add a number field, use if you need to supply your own name
	and default value, which should be a Number. Size defaults to 20."

	^self inputNumber: name size: 20 value: value

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:02'!
inputNumberSize: size
	"Add a number field with size <size>, name is autogenerated and default value is 0."

	^self inputNumber: self nextVarName size: size value: 0
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:02'!
inputNumberSize: size value: default
	"Add a number field with size <size> and default value <default>
	which should be a Number. Name is autogenerated."

	^self inputNumber: self nextVarName size: size value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:03'!
inputNumberValue: default
	"Add a number field with default value <default> which should
	be a Number. Size defaults to 20 and name is autogenerated."

	^self inputNumber: self nextVarName size: 20 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:04'!
inputPassword
	"Add a password field which is like a text field that does not
	show the entered characters. Name is autogenerated and default value is ''."

	^self inputPassword: self nextVarName value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:01'!
inputPassword: name

	^self inputPassword: name value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:01'!
inputPassword: name size: size

	^self inputPassword: name size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/4/2002 17:38'!
inputPassword: name size: size value: default 

	^self addHtmlInput: (HVHtmlInputPassword name: name value: (fields at: name ifAbsent:[default]) size: size)


! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:02'!
inputPassword: name value: default

	^self inputPassword: name size: 30 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/4/2002 17:38'!
inputPasswordSize: size

	^self inputPassword: self nextVarName size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/17/2003 13:33'!
inputRadio
	"Add a radio button, name is picked from previous
	radio button unless it has been explicitly closed with #endRadio.
	In that case we generate a new name."

	^self inputRadioValue: false! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/17/2003 13:42'!
inputRadio: name value: default id: id
	"Add a radio button named <name> with id <id>.
	The id should be a unique String. If the current request has
	posted this field then the value is calculated from
	there, otherwise we use the supplied Boolean <default>.
	If one of the radio buttons in the current group already is
	set then we ignore <default> and use false."

	| val radio |
	val _ default.
	self ifSubmit: [
		val _ (fields includesKey: name)
			ifTrue:[ (fields at: name) = id asString ]
			ifFalse: [ false ]].
	"If there was a radio button before us, make sure we only use
	true if noone has been true so far:"
	val _ lastRadio ifNotNil: [lastRadio nooneSet and: [val]] ifNil: [val].
	radio _ HVHtmlInputRadio name: name value: val id: id.
	radio previous: lastRadio.
	lastRadio _ radio.
	^self addHtmlInput: radio! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/16/2003 17:51'!
inputRadioValue: default
	"Add a radio button, name is picked from previous
	radio button unless it has been explicitly closed with #endRadio.
	In that case we generate a new name. Default value is <default>."

	| name id |
	(lastRadio isNil or: [lastRadio isClosed])
		ifTrue: [name _ self nextVarName. id _ 1]
		ifFalse: [name _ lastRadio name. id _ lastRadio id + 1].
	^self inputRadio: name value: default id: id
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 00:10'!
inputText

	^self inputText: self nextVarName value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 1/31/2002 15:55'!
inputText: var

	^self inputText: var value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/5/2002 09:20'!
inputText: var size: size

	^self inputText: var size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/22/2002 13:58'!
inputText: name size: size value: default 

	^self addHtmlInput: (HVHtmlInputText name: name value: (fields at: name ifAbsent:[default]) size: size)


! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:37'!
inputText: var value: default

	^self inputText: var size: 30 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/15/2002 14:00'!
inputTextSize: size

	^self inputText: self nextVarName size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'JO 3/4/2002 14:13'!
inputTextSize: size value: default

	^self inputText: self nextVarName size: size value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/21/2002 15:58'!
inputTextValue: default

	^self inputText: self nextVarName value: default

! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gh 9/16/2002 14:44'!
isPost
	"Is it a POST?"

	^request isPostRequest! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:15'!
lightGreyRow
	self halt! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/17/2003 11:03'!
link: url text: anObject
	"Add a HTML link."

	^self anchorWithUrl: url do: anObject! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 10/11/2005 23:22'!
link: url text: anObject alt: alt
	"Add a HTML link, but use the alternative
	if url is nil or empty."

	^url isEmptyOrNil
		ifTrue: [alt]
		ifFalse: [self anchorWithUrl: url do: anObject]! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 10/12/2005 01:18'!
linkBack
	"Add a back link to the default page of this view."

	self deprecated: 'Use #linkDefault instead.'.
	^self linkDefault! !

!HVHtmlBuilder methodsFor: 'deprecated' stamp: 'gk 10/11/2005 21:21'!
linkBack: text
	"Add a link to the default page of this view."

	self deprecated: 'Use linkDefault: instead'.
	^self link: view defaultUrl text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/10/2003 10:38'!
linkBackParent
	"Add a link to the default page of the parent view."

	^self linkBackParent: 'Back'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 10/12/2005 11:55'!
linkBackParent: text
	"Add a back link to the default page of the parent view."

	^self link: view parent defaultUrl text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 10/12/2005 01:18'!
linkDefault
	"Add a back link to the default page of this view."

	^self link: view defaultUrl text: 'Back'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 3/2/2004 16:15'!
linkDefault: text
	"Add a link to the default page of this view."

	^self link: view defaultUrl text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'edc 10/14/2009 10:00'!
linkLocal: relativeUrl text: text
	"Add a local link to the view."

	^self link: (view originalUrlFor: relativeUrl) text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 10/12/2005 00:53'!
linkParent: relativeUrl text: text
	"Add a local link to the parent view."

	^self link: (view parent originalUrlFor: relativeUrl) text: text! !

!HVHtmlBuilder methodsFor: 'deprecated' stamp: 'gk 10/11/2005 23:48'!
linkPrefix: prefix text: text
	"Embed a link to the view with that prefix."

	| target |
	self deprecated: 'Method deprecated since it breaks the principle of having the views unknowledgeable about the url paths. Use #parentsDo: or something instead.'.

	target _ view.
	[target prefix = prefix ifTrue:[ ^self link: target prefix text: text ].
	target _ target parent.
	target notNil] whileTrue.
	^self link: prefix text: 'No view found for this link'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 10/11/2005 03:11'!
mailto: nameAndEmail
	"Add a mailto: anchor link given a nameAndEmail like:
		'Robert Robertson <rob@here.com>' ->
		'<a href='mailto:rob@here.com'>Robert Robertson</a>'
	If <aString> does not conform it will be inserted without an anchor."

	| lessThan moreThan |
	lessThan _ nameAndEmail indexOf: $<.
	moreThan _ nameAndEmail indexOf: $>.
	(lessThan * moreThan = 0) ifTrue:[^self text: nameAndEmail].
	^self link: 'mailto:', (nameAndEmail copyFrom: lessThan + 1 to: moreThan - 1)
		text: (nameAndEmail copyFrom: 1 to: lessThan - 2)! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 10/11/2005 03:08'!
mailto: address text: anObject
	"Add a mailto: anchor link given the address
	and the text to show."

	^self link: 'mailto:', address text: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:25'!
nbsp
	^self space! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 5/14/2002 10:24'!
nextVarName
	"The current Form enumerates it's own variables."

	^self currentForm nextVarName
! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 6/12/2002 10:40'!
numberAt: var ifAbsent: block
	"Customized version to get an expected number."

	^(fields at: var ifAbsent: [^block value]) asNumber! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/24/2002 14:11'!
ol: items
	"Make an ordered list by using asString on the elements."
	
	^self ol: items do: [:i | self html: i asString ]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:31'!
ol: items do: aBlock
	"Make an ordered list."
	
	^self tag: 'ol' do: [
		items do: [:i |
			self tag: 'li' doValue: [aBlock value: i]]]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:31'!
ol: items extract: aBlock
	"Make an ordered list with the value of the block
	rendered as the item, use #ol:do: for stuff where
	the block can not return something to be rendered."
	
	^self tag: 'ol' do: [
		items do: [:i |
			self tag: 'li' do: [aBlock value: i]]]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/11/2003 09:10'!
olDo: items
	"Make an ordered list by using value on each element."
	
	^self ol: items do: [:bl | bl value ]! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:16'!
p
	^self openTag: 'p'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:00'!
p: anObject
	^self paragraph: anObject! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/16/2003 16:56'!
postForm
	"Start a POST form with an action url that is the same as this request."

	^self addForm: (HVHtmlForm postAction: request url)! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 1/10/2005 14:41'!
postForm: action
	"Start a POST form with an action url."

	^self addForm: (HVHtmlForm postAction: action)! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 4/5/2004 11:32'!
postFormLocal: aString
	"Start a POST form with an action url based on the local view."

	^self postFormLocal: aString forView: view! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/12/2005 15:54'!
postFormLocal: aString forView: aView
	"Start a POST form with an action url based on the local view."

	^self addForm: (HVHtmlForm postAction: (aView originalUrlFor: aString))! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 10/3/2002 17:32'!
postFormMultiPart
	"Start a POST form with an action url that is
	the same as this request and with encoding as multi part."

	^self addForm: (HVHtmlForm postAction: request url enctype: 'multipart/form-data')! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 4/5/2004 11:31'!
postFormMultiPartLocal: aString
	"Start a POST form with an action url that is
	based on the view and with encoding as multi part."

	^self postFormMultiPartLocal: aString forView: view! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/12/2005 15:53'!
postFormMultiPartLocal: aString forView: aView
	"Start a POST form with an action url that is
	based on the view and with encoding as multi part."

	^self addForm: (HVHtmlForm postAction: (aView originalUrlFor: aString) enctype: 'multipart/form-data')! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 10:12'!
pre: anObject
	^self tag: 'pre' do: anObject! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/11/2003 11:33'!
radio: aName objects: objects value: default
	^self radio: aName objects: objects values: nil nilLabel: #None selector: nil value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/11/2003 11:39'!
radio: aName objects: objects values: values nilLabel: label selector: sel value: default
	"Radio groups always have values that are integers from 1.
	If there is a value submitted we find the object at that
	position, otherwise we use the supplied default value."

	| val submitted v |
	submitted _ fields at: aName ifAbsent:[nil].
	submitted
		ifNotNil: [
			values
				ifNil: [
					(submitted isString not)
						ifTrue:[val _ OrderedCollection new.
							submitted isString ifTrue: [
								submitted _ submitted findTokens: Character space].
							submitted
								do: [:subm |
									v _ objects at: subm asNumber ifAbsent: [nil].
									v ifNotNil: [val add: v]]]
						ifFalse:[val _ objects at: submitted asNumber ifAbsent: [nil]]]
				ifNotNil: [
					val _ submitted.
					(val = 'nil') ifTrue:[val _ nil].
					]]
		ifNil: [val _ default].
	^self addHtmlInput: (HVHtmlRadioGroup name: aName objects: objects values: values nilLabel: label selector: sel value: val)
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/11/2003 11:40'!
radioGroup: objects

	^self radio: self nextVarName objects: objects value: (objects first)! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:24'!
red: anObject
	^self attributeAt: 'color' put: 'red'; tag: 'font' do: anObject! !

!HVHtmlBuilder methodsFor: 'redirection' stamp: 'gk 3/4/2004 14:31'!
redirectTo: url
	"Make a redirection to another url."

	^view redirectTo: url! !

!HVHtmlBuilder methodsFor: 'redirection' stamp: 'gk 3/4/2004 14:31'!
redirectToDefault
	"Make a redirection to the default url of the view."

	^view redirectToDefault! !

!HVHtmlBuilder methodsFor: 'redirection' stamp: 'gk 3/4/2004 14:32'!
redirectToLocal: page
	"Make a redirection to another page in the view,
	equaling another method in the view class."

	^view redirectToLocal: page! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gk 12/17/2003 11:22'!
render
	"Concatenate everything together and substituting variables
	in the progress. First we check if we are timing this page.
	If we are then we need to calculate the stop time and incorporate
	the time at the bottom of the page."

	^document contents contents

"	| start stream |
	start _ request propertyAt: #startTime ifAbsent: [nil].
	start ifNotNil: [elements removeLast ].
	stream _ WriteStream on: (String new: 50000).
	elements do: [:element |
		(element isKindOf: String)
			ifTrue:[ stream nextPutAll: element ]
			ifFalse:[ element renderFullOn: stream ]].
	start ifNotNil: [
		stream nextPutAll: '<br><font size=-1>Time in ms: ', (Time millisecondClockValue - start) asString, '</font>', String crlf.
		^stream contents
	].
	^stream contents"

! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gk 1/25/2005 11:15'!
renderUtf8
	"Conversion."

	^self render squeakToIso isoToUtf8! !

!HVHtmlBuilder methodsFor: 'accessing' stamp: 'gh 9/12/2002 16:02'!
request
	^request! !

!HVHtmlBuilder methodsFor: 'initialize-release' stamp: 'gk 12/17/2003 13:13'!
request: aRequest view: aView

	view _ aView.
	request _ aRequest.
	request isPostRequest
		ifTrue: [fields _ request postFields]
		ifFalse: [fields _ request getFields].
	document _ WVHtmlDocument new.
	variables _ Dictionary new! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:12'!
reset

	^self reset: 'Reset'
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/17/2003 12:23'!
reset: text

	^self attributeAt: 'value' put: text;
		attributeAt: 'type' put: 'reset';
		tag: 'input'! !

!HVHtmlBuilder methodsFor: 'swikification' stamp: 'gk 7/8/2006 15:46'!
resolveTag: aTag
	"Translate the String <aTag> to something, like a link.
	We delegate to the view."

	^view resolveTag: aTag builder: self! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:16'!
row
	^self openTag: 'tr'! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/22/2002 17:46'!
select: aName objects: objects nilLabel: label value: default

	^self select: aName objects: objects size: 1 nilLabel: label value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:11'!
select: aName objects: objects size: size nilLabel: label value: default
	"Selects always have values that are integers from 1.
	If there is a value submitted we find the object at that
	position, otherwise we use the supplied default value."

	^self select: aName objects: objects values: nil size: size multiple: false nilLabel: label selector: nil value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:14'!
select: aName objects: objects size: size value: default
	^self select: aName objects: objects values: nil size: size multiple: false nilLabel: #None selector: nil value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:46'!
select: aName objects: objects value: default

	^self select: aName objects: objects size: 1 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/4/2003 21:32'!
select: aName objects: objects values: values size: size multiple: multi nilLabel: label selector: sel value: default
	"Selects always have values that are integers from 1.
	If there is a value submitted we find the object at that
	position, otherwise we use the supplied default value."

	| val submitted v |
	submitted _ fields at: aName ifAbsent:[nil].
	submitted
		ifNotNil: [
			values
				ifNil: [
					(submitted isString not | multi)
						ifTrue:[val _ OrderedCollection new.
							submitted isString ifTrue: [
								submitted _ submitted findTokens: Character space].
							submitted
								do: [:subm |
									v _ objects at: subm asNumber ifAbsent: [nil].
									v ifNotNil: [val add: v]]]
						ifFalse:[val _ objects at: submitted asNumber ifAbsent: [nil]]]
				ifNotNil: [
					multi
						ifTrue: [submitted isString ifTrue: [
									submitted _ submitted findTokens: Character space].
								val _ submitted]
						ifFalse: [val _ submitted].
					(val = 'nil') ifTrue:[val _ nil].
					]]
		ifNil: [val _ default].
	^self addHtmlInput: (HVHtmlSelect name: aName objects: objects values: values size: size multiple: multi nilLabel: label selector: sel value: val)
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/4/2003 21:29'!
selectMulti: aName objects: objects size: size value: default
	^self select: aName objects: objects values: nil size: size multiple: true nilLabel: #None selector: nil value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/10/2003 14:39'!
selectMultiObjects: objects

	^self selectMulti: self nextVarName objects: objects size: 10 value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/10/2003 14:39'!
selectMultiObjects: objects selector: aSymbol

	^self select: self nextVarName objects: objects values: nil size: 10 multiple: true nilLabel: #None selector: aSymbol value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/10/2003 23:58'!
selectMultiObjects: objects size: sz

	^self selectMulti: self nextVarName objects: objects size: sz value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 5/6/2004 16:02'!
selectMultiObjects: objects size: sz value: default

	^self selectMulti: self nextVarName objects: objects size: sz value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/10/2003 14:40'!
selectMultiObjects: objects value: default

	^self selectMulti: self nextVarName objects: objects size: 10 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:49'!
selectObjects: objects

	^self select: self nextVarName objects: objects size: 1 value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:14'!
selectObjects: objects selector: aSymbol

	^self select: self nextVarName objects: objects values: nil size: 1 multiple: false nilLabel: #None selector: aSymbol value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 5/11/2004 14:24'!
selectObjects: objects selector: aSymbol value: default

	^self select: self nextVarName objects: objects values: nil size: 1 multiple: false nilLabel: #None selector: aSymbol value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/11/2003 15:38'!
selectObjects: objects size: sz

	^self select: self nextVarName objects: objects size: sz value: nil
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:46'!
selectObjects: objects value: default

	^self select: self nextVarName objects: objects size: 1 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/3/2004 11:15'!
selectObjects: objects values: values size: size value: default
	^self select: self nextVarName objects: objects values: values size: size multiple: false nilLabel: #None selector: nil value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:57'!
selectObjectsFirstSelected: objects

	^self select: self nextVarName objects: objects size: 1 value: (objects isEmpty ifTrue:[nil] ifFalse:[objects first])! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:15'!
selectObjectsFirstSelected: objects selector: sel

	^self select: self nextVarName objects: objects values: nil size: 1 multiple: false nilLabel: #None selector: sel value: (objects isEmpty ifTrue:[nil] ifFalse:[objects first])! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 1/7/2005 11:47'!
selectObjectsFirstSelected: objects selector: sel value: default

	^self select: self nextVarName objects: objects values: nil size: 1 multiple: false nilLabel: #None selector: sel value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:15'!
selectObjectsFirstSelected: objects values: values

	^self select: self nextVarName objects: objects values: values size: 1 multiple: false nilLabel: #None selector: nil value: (objects isEmpty ifTrue:[nil] ifFalse:[values first])! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/7/2003 14:03'!
selectObjectsNilFirst: objects

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) size: 1 value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/7/2003 14:03'!
selectObjectsNilFirst: objects nilLabel: label

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) size: 1 nilLabel: label value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 1/4/2005 13:40'!
selectObjectsNilFirst: objects nilLabel: label selector: sel

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) values: nil size: 1 multiple: false nilLabel: label selector: sel value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:15'!
selectObjectsNilFirst: objects nilLabel: label selector: sel value: default

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) values: nil size: 1 multiple: false nilLabel: label selector: sel value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/21/2002 16:15'!
selectObjectsNilFirst: objects nilLabel: label value: default

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) size: 1 nilLabel: label value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 14:39'!
selectObjectsNilFirst: objects value: default

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) size: 1 value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/7/2003 14:03'!
selectObjectsNilFirst: objects values: values nilLabel: label

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) values: (values asOrderedCollection addFirst: nil; yourself) size: 1 multiple: false nilLabel: label selector: nil value: nil! !

!HVHtmlBuilder methodsFor: 'hacks' stamp: 'gk 12/17/2003 11:01'!
srcLink
	"Adds a link showing the source code of the current method.
	Used for examples etc."

	| url |
	url _ view urlStream pathWithPrefix: #src.
	url = '/src' ifTrue: [url _ '/srcdefault'].
	^self attributeAt: 'size' put: '-1';
		tag: 'font' do: [
			self link: url text: 'See source for this page']! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 5/18/2004 11:46'!
start
	"Start the HTML page, by default we just add the title
	and make it XHTML etc."

	document headDo: [ self tag: 'title' do: view title]! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:12'!
submit

	^self submit: 'Submit'
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 15:08'!
submit: text

	^self submit: self nextVarName value: text
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 15:47'!
submit: name value: text

	| val |
	val _ false.
	self ifSubmit: [
		val _ (fields includesKey: name)
			ifTrue:[ (fields at: name) = text ]
			ifFalse: [ false ]].
	^self addHtmlInput: (HVHtmlInputSubmit name: name value: text pressed: val)! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gk 11/7/2003 12:45'!
submitted: aString
	"Low level access - is a certain field available?
	To check for button presses, keep the button and
	use #ifPressed: or #pressed."

	^(fields detect: [:oc | oc includes: aString] ifNone: [nil]) notNil! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:16'!
tab
	self halt! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:18'!
table
	self attributeAt: 'border' put: '0'.
	self openTag: 'table'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 5/18/2004 15:36'!
table: objects heads: heads block: aBlock
	"Add a table. Efficient implementation but the extraction
	block <aBlock> can not use the builder."

	self table: [
		self heads: heads.
		self tableBody: [
			objects do: [:obj |
				self tableRow: [
					(aBlock value: obj) do: [:val |
						self tableData: val asString ]
				]
			]
		]
	]! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 13:12'!
table: objects heads: heads cellBlock: aBlock
	"Add a table. This version takes a 2-argument (object and builder)
	block which feeds the cell values into the builder using #cell:."

self halt.! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 5/18/2004 14:12'!
tableBody
	self openTag: 'tbody'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 5/18/2004 15:35'!
tableHead
	self openTag: 'thead'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 13:12'!
tableHeads: heads
	"Add a table. Use #row, #cell, #endRow, #endCell, #endTable."

	self table; heads: heads! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:05'!
tag: tag around: anObject
	self tag: tag do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:42'!
td
	^self openTag: 'td'! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 11:37'!
textArea

	^self textArea: self nextVarName rows: 5 cols: 40 value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:07'!
textArea: name

	^self textArea: name rows: 5 cols: 40 value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:32'!
textArea: var rows: rows cols: cols

	^self textArea: var rows: rows cols: cols value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/19/2002 21:01'!
textArea: name rows: rows cols: cols value: default

	^self addHtmlInput: (HVHtmlTextArea name: name rows: rows cols: cols value: (fields at: name ifAbsent:[default]))
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 5/12/2004 12:06'!
textArea: var value: default

	^self textArea: var rows: 5 cols: 40 value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/19/2002 21:06'!
textAreaRows: rows cols: cols

	^self textArea: self nextVarName rows: rows cols: cols value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 7/31/2002 09:33'!
textAreaRows: rows cols: cols value: default

	^self textArea: self nextVarName rows: rows cols: cols value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 5/12/2004 12:06'!
textAreaValue: default

	^self textArea: self nextVarName rows: 5 cols: 40 value: default! !

!HVHtmlBuilder methodsFor: 'special-toc' stamp: 'gh 9/12/2002 13:17'!
toc
	"Return an empty table of contents."

	^self tocValue: nil
! !

!HVHtmlBuilder methodsFor: 'special-toc' stamp: 'gk 4/2/2004 14:43'!
toc: aName value: aValue
	"Return a table of contents renderer with a given name and value."

	^self toc: aName value: aValue class: view tocRenderClass! !

!HVHtmlBuilder methodsFor: 'special-toc' stamp: 'gk 4/2/2004 14:42'!
toc: aName value: aValue class: aRenderClass
	"Return a table of contents renderer with a given name and value."

	| var |
	var _ aRenderClass name: aName value: aValue builder: self.
	variables at: aName put: var.
	^document addElement: var

! !

!HVHtmlBuilder methodsFor: 'special-toc' stamp: 'gh 9/12/2002 13:21'!
tocValue: aValue
	"Return a table of contents with a given value."

	^self toc: variables size fullPrintString value: aValue

! !

!HVHtmlBuilder methodsFor: 'accessing' stamp: 'gk 10/12/2005 12:03'!
topView
	^view topView! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 11:42'!
tr
	^self openTag: 'tr'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/24/2002 14:11'!
ul: items
	"Make an unordered list by using asString on the elements."
	
	^self ul: items do: [:i | self html: i asString ]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:32'!
ul: items do: aBlock
	"Make an unordered list but we let the block
	add the item to the builder itself."

	^self tag: 'ul' do: [
		items do: [:i |
			self tag: 'li' doValue: [aBlock value: i]]]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/11/2003 09:10'!
ulDo: items
	"Make an unordered list by using value on each element."
	
	^self ul: items do: [:bl | bl value ]! !

!HVHtmlBuilder methodsFor: 'accessing' stamp: 'gk 4/22/2005 12:34'!
url
	^request url unescapePercents utf8ToIso isoToSqueak! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 3/15/2002 21:35'!
var
	"Return a variable node. The name will be a single number.
	A variable node can be given content using #value:
	later on after the page has been built but before it is rendered."

	^self var: (variables size fullPrintString) value: ''
! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 2/22/2002 13:07'!
var: aName
	"Return a variable node.
	A variable node can be given content using #value:
	later on after the page has been built."

	^self var: aName value: ''
! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gk 1/13/2005 13:49'!
var: aName value: aValue
	"Return a variable node.
	A variable node can be given content using #value:
	later on after the page has been built."

	| var |
	var _ HVSimpleVariable named: aName attributes: self attributes.
	var value: aValue.
	variables at: aName put: var.
	^document addElement: var

! !

!HVHtmlBuilder methodsFor: 'accessing' stamp: 'gh 10/18/2002 15:30'!
view
	^view! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gk 1/12/2005 16:47'!
withVar: varName do: aBlock
	"Temporarily work with a named variable.
	Return the variable or nil if it is not found."

	| elem |
	elem _ self findVar: varName.
	elem ifNotNil: [^self withElement: elem do: aBlock].
	^nil! !

!HVHtmlBuilder methodsFor: 'buttons' stamp: 'gk 5/18/2004 15:28'!
xhtmlButton

	self text: '<div class="w3cbutton1"><a class="w3c1" href="http://www.w3.org/">W3C</a><a class="spec1" href="http://validator.w3.org/check/referer">XHTML 1.0</a></div>'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 12:10'!
zebraTable: objects heads: heads block: aBlock
	"Add a table. Efficient implementation but the extraction
	block <aBlock> can not use the builder."

self halt! !

!TimeStamp class methodsFor: '*HV-SBlog-RSS' stamp: 'mas 10/25/2003 13:18'!
fromRfc822String: aString 
	| dateTimeString tokens dateString timeString date time |
	dateTimeString _ (aString includes: $,)
		ifTrue: [aString copyAfter: $,]
		ifFalse: [aString].
	tokens _ dateTimeString findTokens: ' '.
	dateString _ tokens first, ' ', tokens second, ' ', tokens third.
	timeString _ tokens fourth, ' ', tokens fifth.
	date _ Date readFrom: (ReadStream on: dateString).
	time _ Time readFrom: (ReadStream on: timeString).
	^ self date: date time: time! !

WVHtmlElement subclass: #HVHtmlElement
	instanceVariableNames: 'prefix suffix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlElement commentStamp: 'gk 12/16/2003 16:54' prior: 0!
Base class for all HV elements, adds a few noncrucial facilities.!

HVHtmlElement subclass: #HVHtmlDiv
	instanceVariableNames: 'class id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlDiv class methodsFor: 'instance creation' stamp: 'gh 10/18/2002 13:34'!
class: aString
	^self new class: aString! !

!HVHtmlDiv class methodsFor: 'instance creation' stamp: 'gh 10/18/2002 13:34'!
id: anId
	^self new id: anId! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:34'!
class
	^class! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:34'!
class: aString
	class _ aString! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:33'!
id
	^id! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:33'!
id: anId
	id _ anId! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gk 4/11/2007 11:58'!
name
	^ 'div'! !

!HVHtmlElement methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:25'!
doPrintHtmlOn: aStream
	"Default is the implementation in super."

	super printHtmlOn: aStream! !

!HVHtmlElement methodsFor: 'decorations' stamp: 'gk 10/31/2003 11:24'!
error: aString
	"Add <aString> formatted as an error in bold red as suffix."

	self suffix: '&nbsp;<b><font color="red">', aString, '</font></b>'! !

!HVHtmlElement methodsFor: 'testing' stamp: 'gh 2/15/2002 14:41'!
isForm
	^false! !

!HVHtmlElement methodsFor: 'testing' stamp: 'gk 12/16/2003 17:24'!
isRadio
	^false! !

!HVHtmlElement methodsFor: 'accessing' stamp: 'gh 8/3/2002 02:22'!
prefix: aString
	prefix _ aString! !

!HVHtmlElement methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:25'!
printHtmlOn: aStream
	"Any prefix/suffix is added if they are not nil."

	prefix ifNotNil: [aStream nextPutAll: prefix].
	self doPrintHtmlOn: aStream.
	suffix ifNotNil: [aStream nextPutAll: suffix]! !

!HVHtmlElement methodsFor: 'decorations' stamp: 'gh 8/3/2002 02:23'!
success: aString
	"Add <aString> formatted as a message in bold green as suffix."

	suffix _ '&nbsp;<b><font color="green">', aString, '</font></b>'! !

!HVHtmlElement methodsFor: 'accessing' stamp: 'gh 8/3/2002 02:22'!
suffix: aString
	suffix _ aString! !

HVHtmlElement subclass: #HVHtmlForm
	instanceVariableNames: 'action enctype method elements id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlForm commentStamp: 'gk 10/31/2003 13:12' prior: 0!
A Form.This object has a method for rendering and it keeps track of the ids of the fields in the form. Typically only used internally in HttpView.!

!HVHtmlForm class methodsFor: 'instance creation' stamp: 'gk 12/16/2003 16:40'!
getAction: action

	^self new action: action method: 'get'! !

!HVHtmlForm class methodsFor: 'instance creation' stamp: 'gk 12/16/2003 16:39'!
postAction: action

	^self new action: action method: 'post'! !

!HVHtmlForm class methodsFor: 'instance creation' stamp: 'gk 12/16/2003 16:39'!
postAction: action enctype: type

	^self new action: action method: 'post'; enctype: type! !

!HVHtmlForm methodsFor: 'initialize-release' stamp: 'gk 12/16/2003 16:39'!
action: anAction method: aMethod

	action _ anAction.
	method _ aMethod.
	elements _ OrderedCollection new! !

!HVHtmlForm methodsFor: 'elements' stamp: 'gk 12/17/2003 11:46'!
addInput: anHtmlElement
	^elements add: anHtmlElement! !

!HVHtmlForm methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:26'!
doPrintHtmlOn: stream

	"Change this to printOpenTagOn: later"
	stream
		nextPutAll: '<form action="';
		nextPutAll: action;
		nextPutAll: '" method="', method, '"'.
	enctype ifNotNil: [stream nextPutAll: ' enctype="', enctype, '"'].
	stream nextPut: $>.
	self childrenDo: [:ea | ea printHtmlOn: stream].
	stream nextPutAll: '</form>'

"	self printCloseTagOn: stream"! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 10/3/2002 17:29'!
enctype
	^enctype! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 10/3/2002 17:29'!
enctype: type
	enctype _ type! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 5/14/2002 10:28'!
id
	^id! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 5/14/2002 10:28'!
id: anId
	id _ anId! !

!HVHtmlForm methodsFor: 'testing' stamp: 'gk 10/31/2003 13:14'!
ifSubmit: aBlock
	"Should not be used."

	0 halt.! !

!HVHtmlForm methodsFor: 'testing' stamp: 'gh 2/15/2002 14:41'!
isForm
	^true! !

!HVHtmlForm methodsFor: 'elements' stamp: 'gk 10/31/2003 13:13'!
nextVarName
	"We take our own numeric id and tack on a numeric id for our elements."

	^(id fullPrintString, '-',  (elements size + 1) fullPrintString) asSymbol! !

HVHtmlElement subclass: #HVHtmlImage
	instanceVariableNames: 'url alt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlImage class methodsFor: 'instance creation' stamp: 'gk 11/7/2003 11:41'!
url: imageUrl alt: description

	^self new url: imageUrl alt: description! !

!HVHtmlImage methodsFor: 'accessing' stamp: 'gk 11/7/2003 11:44'!
alt
	^alt! !

!HVHtmlImage methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:26'!
doPrintHtmlOn: stream
	"Render the image in valid XHTML. The alt tag is mandatory
	in XHTML and the tag needs to end with a slash."

	stream nextPutAll: '<img'.
	stream nextPutAll: ' src="', url, '" alt="', (self alt ifNil: ['no description']), '"'.
	self renderAttributesOn: stream.
	stream nextPutAll: ' />'! !

!HVHtmlImage methodsFor: 'rendering' stamp: 'gk 11/7/2003 11:50'!
renderAttributesOn: stream
	"Render attributes. More?"! !

!HVHtmlImage methodsFor: 'accessing' stamp: 'gk 11/7/2003 11:49'!
url
	^url! !

!HVHtmlImage methodsFor: 'initialize-release' stamp: 'gk 11/7/2003 11:49'!
url: aURL alt: aString

	url _ aURL.
	alt _ aString! !

HVHtmlElement subclass: #HVHtmlVariable
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlVariable commentStamp: 'gh 6/12/2002 10:54' prior: 0!
An abstract base class for elements that has a name and carry a value.

Can be used to embed dynamic values in HTML pages (subclass HVSimpleVariable) but it is also the base class for all Form elements like input fields etc.!

HVHtmlVariable subclass: #HVHtmlFormElement
	instanceVariableNames: 'readonly disabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 17:20'!
clearDisabled
	disabled _ nil! !

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 17:21'!
clearReadonly
	readonly _ nil! !

!HVHtmlFormElement methodsFor: 'rendering' stamp: 'gk 8/8/2003 16:55'!
renderAttributesOn: stream
	"Render attributes."

	readonly ifNotNil: [stream nextPutAll: ' readonly'].
	disabled ifNotNil: [stream nextPutAll: ' disabled']! !

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 16:57'!
setDisabled
	disabled _ true! !

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 16:57'!
setReadonly
	readonly _ true! !

HVHtmlFormElement subclass: #HVHtmlInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlInput commentStamp: 'gh 6/12/2002 10:48' prior: 0!
Base class for all input elements, inherits the ability to carry a "value" and a "name" from HVHtmlVariable. Basic rendering.!

!HVHtmlInput methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:25'!
doPrintHtmlOn: stream

	stream nextPutAll: '<input'.
	stream nextPutAll: ' type="', self renderType, '" name="', name, '"'.
	self renderAttributesOn: stream.
	self renderValueOn: stream.
	stream nextPutAll: ' />'! !

!HVHtmlInput methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:22'!
readonly
	^readonly! !

!HVHtmlInput methodsFor: 'rendering' stamp: 'gk 3/31/2005 14:39'!
renderValueOn: stream
	"We need to escape double quotes in the value,
	other markup should be fine (?)."

	stream nextPutAll: ' value="', (value asString copyReplaceAll: '"' with: '&quot;'), '"'.! !

!HVHtmlInput methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:22'!
setReadonly
	readonly _ true! !

HVHtmlInput subclass: #HVHtmlInputCheckbox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlInputCheckbox commentStamp: 'gh 6/12/2002 10:47' prior: 0!
A Form checkbox. Simply a method for rendering.!

!HVHtmlInputCheckbox methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:43'!
renderType
	^'checkbox'! !

!HVHtmlInputCheckbox methodsFor: 'rendering' stamp: 'gk 5/18/2004 14:34'!
renderValueOn: stream
	value ifTrue:[stream nextPutAll: ' checked="checked"']! !

HVHtmlInputCheckbox subclass: #HVHtmlInputRadio
	instanceVariableNames: 'id closed previous'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlInputRadio commentStamp: 'gk 11/11/2003 11:00' prior: 0!
A Form radio button. Like a check box but several sharing the same name are enforced to be mutually exclusive. One is always checked.!

!HVHtmlInputRadio class methodsFor: 'instance-creation' stamp: 'gk 11/11/2003 12:44'!
name: aName value: aValue id: anId
	^super new name: aName value: aValue id: anId; yourself! !

!HVHtmlInputRadio methodsFor: 'accessing' stamp: 'gk 12/16/2003 17:25'!
close
	closed _ true! !

!HVHtmlInputRadio methodsFor: 'accessing' stamp: 'gk 12/17/2003 13:30'!
id
	^id! !

!HVHtmlInputRadio methodsFor: 'testing' stamp: 'gk 12/16/2003 17:25'!
isClosed
	^closed! !

!HVHtmlInputRadio methodsFor: 'testing' stamp: 'gk 12/16/2003 17:24'!
isRadio
	^true! !

!HVHtmlInputRadio methodsFor: 'initialize-release' stamp: 'gk 1/13/2005 13:47'!
name: aName value: aValue id: anId
	super name: aName.
	super value: aValue.
	closed _ false.
	id _ anId! !

!HVHtmlInputRadio methodsFor: 'testing' stamp: 'gk 12/17/2003 13:32'!
nooneSet
	"Is none of the previous radios set to true including me?"

	^previous ifNil: [value not]
		ifNotNil: [previous nooneSet and: [value not]]! !

!HVHtmlInputRadio methodsFor: 'accessing' stamp: 'gk 12/16/2003 17:28'!
previous
	^previous! !

!HVHtmlInputRadio methodsFor: 'accessing' stamp: 'gk 12/16/2003 17:28'!
previous: aRadio
	previous _ aRadio! !

!HVHtmlInputRadio methodsFor: 'rendering' stamp: 'gk 11/11/2003 11:00'!
renderType
	^'radio'! !

!HVHtmlInputRadio methodsFor: 'rendering' stamp: 'gk 12/16/2003 17:36'!
renderValueOn: stream
	"We use the id as the value instead."

	stream nextPutAll: ' value="', id asString, '" '.
	super renderValueOn: stream! !

HVHtmlInput subclass: #HVHtmlInputFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlInputFile methodsFor: 'rendering' stamp: 'gh 10/3/2002 17:49'!
renderType

	^'file'! !

HVHtmlInput subclass: #HVHtmlInputHidden
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlInputHidden commentStamp: 'gh 6/12/2002 10:49' prior: 0!
Simply a hidden field.!

!HVHtmlInputHidden methodsFor: 'as yet unclassified' stamp: 'gh 3/16/2002 00:27'!
renderType

	^'hidden'! !

HVHtmlInput subclass: #HVHtmlInputSubmit
	instanceVariableNames: 'pressed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlInputSubmit commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A submit button for a Form.!

!HVHtmlInputSubmit class methodsFor: 'instance creation' stamp: 'gk 10/29/2003 15:19'!
name: aName value: val pressed: pressed
	^(super name: aName value: val) pressed: pressed! !

!HVHtmlInputSubmit methodsFor: 'control' stamp: 'gk 10/29/2003 15:37'!
ifPressed: aBlock
	"Evaluate <aBlock> if this button was pressed -
	if the name of the button was submitted."

	^pressed ifTrue: [aBlock value]! !

!HVHtmlInputSubmit methodsFor: 'control' stamp: 'gk 10/31/2003 10:09'!
ifPressed: aBlock ifNot: anotherBlock
	"Evaluate <aBlock> if this button was pressed -
	if the name of the button was submitted.
	If not we evaluate <anotherBlock>."

	^pressed ifTrue: [aBlock value] ifFalse: [anotherBlock value]! !

!HVHtmlInputSubmit methodsFor: 'control' stamp: 'gk 5/5/2004 15:01'!
isPressed
	"Was this button pressed?"

	^pressed! !

!HVHtmlInputSubmit methodsFor: 'accessing' stamp: 'gk 10/29/2003 15:37'!
pressed
	^pressed! !

!HVHtmlInputSubmit methodsFor: 'accessing' stamp: 'gk 10/29/2003 15:36'!
pressed: aBoolean
	pressed _ aBoolean! !

!HVHtmlInputSubmit methodsFor: 'rendering' stamp: 'gh 5/14/2002 10:40'!
renderType
	^'submit'! !

HVHtmlInput subclass: #HVHtmlInputText
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlInputText commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A text input field for Forms.!

HVHtmlInputText subclass: #HVHtmlInputNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlInputNumber commentStamp: 'gh 6/12/2002 10:49' prior: 0!
A special variant of HVHtmlInputText that returns a number.!

!HVHtmlInputNumber methodsFor: 'accessing' stamp: 'gh 3/16/2002 00:58'!
value
	^super value asNumber! !

!HVHtmlInputNumber methodsFor: 'accessing' stamp: 'gk 1/18/2005 14:36'!
value: aValue
	^super value: aValue asString! !

HVHtmlInputText subclass: #HVHtmlInputPassword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlInputPassword commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A password field for a Form.!

!HVHtmlInputPassword methodsFor: 'rendering' stamp: 'gh 3/4/2002 17:37'!
renderType

	^'password'! !

!HVHtmlInputText class methodsFor: 'instance creation' stamp: 'gk 1/13/2005 13:46'!
name: aName value: aValue size: aSize
	^(super named: aName) value: (aValue ifNil: ['']); size: aSize; yourself! !

!HVHtmlInputText methodsFor: 'rendering' stamp: 'gk 8/8/2003 16:56'!
renderAttributesOn: stream
	"Add the size attribute."

	super renderAttributesOn: stream.
	stream nextPutAll: ' size="'.
	size printOn: stream.
	stream nextPut: $"! !

!HVHtmlInputText methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:43'!
renderType

	^'text'! !

!HVHtmlInputText methodsFor: 'accessing' stamp: 'gh 2/22/2002 13:15'!
size
	^size! !

!HVHtmlInputText methodsFor: 'accessing' stamp: 'gh 2/22/2002 13:15'!
size: aSize
	size _ aSize! !

HVHtmlFormElement subclass: #HVHtmlSelection
	instanceVariableNames: 'objects values labels nilLabel labelSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

HVHtmlSelection subclass: #HVHtmlRadioGroup
	instanceVariableNames: 'vertical'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlRadioGroup class methodsFor: 'instance creation' stamp: 'gk 1/13/2005 13:46'!
name: aName objects: objects values: values nilLabel: label selector: sel value: aValue 
	^(super named: aName) value: aValue;
		objects: objects values: values nilLabel: label selector: sel; yourself! !

!HVHtmlRadioGroup class methodsFor: 'instance creation' stamp: 'gk 1/13/2005 13:46'!
name: aName objects: objects values: values size: size multiple: multi nilLabel: label selector: sel value: aValue 
	^(super named: aName) value: aValue;
		objects: objects values: values size: size multiple: multi nilLabel: label selector: sel; yourself! !

!HVHtmlRadioGroup methodsFor: 'accessing' stamp: 'gk 12/17/2003 13:26'!
doPrintHtmlOn: stream
	"Render the radio group as HTML."

	| current |
	labels _ objects
				collect: [:obj |
					obj
						ifNil: [nilLabel]
						ifNotNil: [
							(obj isKindOf: String)
								ifTrue:[obj]
								ifFalse:[obj perform: labelSelector]]].
	1 to: objects size do: [:n |
		current _ values ifNil: [objects at: n] ifNotNil: [values at: n].
		(vertical & (n>1)) ifTrue: [stream nextPutAll: '<br />'].
		stream nextPutAll: '<input type="radio" name="', name, '" value="'.
		values
			ifNil: [n printOn: stream]
			ifNotNil: [stream nextPutAll: (values at: n) asString].
		(current = value)
			ifTrue: [stream nextPutAll: '" checked>']
			ifFalse: [stream nextPutAll: '" >' ].
		stream nextPutAll: (labels at: n).
		stream nextPutAll: '</input>'.
	]! !

!HVHtmlRadioGroup methodsFor: 'accessing' stamp: 'gk 11/11/2003 11:43'!
objects: objs values: vals nilLabel: label selector: sel
	super objects: objs values: vals nilLabel: label selector: sel.
	vertical _ false! !

!HVHtmlRadioGroup methodsFor: 'accessing' stamp: 'gk 11/11/2003 11:41'!
vertical
	^vertical! !

!HVHtmlRadioGroup methodsFor: 'accessing' stamp: 'gk 11/11/2003 11:42'!
vertical: aBoolean
	vertical _ aBoolean! !

HVHtmlSelection subclass: #HVHtmlSelect
	instanceVariableNames: 'size multiple autoSubmit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlSelect commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A drop down menu.!

!HVHtmlSelect class methodsFor: 'instance creation' stamp: 'gk 1/13/2005 13:45'!
name: aName objects: objects values: values size: size multiple: multi nilLabel: label selector: sel value: aValue 
	^(super named: aName) value: aValue;
		objects: objects values: values size: size multiple: multi nilLabel: label selector: sel; yourself! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 2/19/2004 15:49'!
autoSubmit: aBoolean
	autoSubmit _ aBoolean! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 12/3/2004 11:36'!
doPrintHtmlOn: stream
	"Render the select as HTML."

	| current |
	stream nextPutAll: '<select name="', name, '" size="', size printString, '"'.
	autoSubmit ifTrue: [stream nextPutAll: ' onchange="this.form.submit();"'].
	stream nextPutAll: (multiple ifTrue: [' multiple>'] ifFalse: ['>']).
	labels _ objects
				collect: [:obj |
					obj
						ifNil: [nilLabel]
						ifNotNil: [
							(obj isKindOf: String)
								ifTrue:[obj]
								ifFalse:[obj perform: labelSelector]]].
	1 to: objects size do: [:n |
		current _ values ifNil: [objects at: n] ifNotNil: [values at: n].
		((multiple and: [value notNil])
			ifTrue: [value includes: current]
			ifFalse: [current = value])
				ifTrue: [stream nextPutAll: '<option selected="selected"']
				ifFalse: [stream nextPutAll: '<option' ].
		stream nextPutAll: ' value="'.
		values ifNil: [n printOn: stream] ifNotNil: [stream nextPutAll: (values at: n) asString].
		stream nextPutAll: '">'.
		stream nextPutAll: (labels at: n).
		stream nextPutAll: '</option>'.
	].
	stream nextPutAll: '</select>'! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 8/15/2003 12:38'!
multiple
	^multiple! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 8/15/2003 12:39'!
multiple: aBoolean
	multiple _ aBoolean! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 2/19/2004 15:51'!
objects: objs values: vals size: s multiple: multi nilLabel: label selector: sel
	super objects: objs values: vals nilLabel: label selector: sel.
	size _ s.
	multiple _ multi.
	autoSubmit _ false! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 3/21/2002 14:55'!
size
	^size! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 3/21/2002 14:56'!
size: aSize
	size _ aSize! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 11/11/2003 15:57'!
addObject: anObject
	^objects add: anObject! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 12/3/2004 11:25'!
objectValue
	"Return the selected object instead of the value."
	
	^objects at: (values indexOf: value)! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 11/11/2003 11:20'!
objects
	^objects! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 3/31/2005 15:57'!
objects: aCollection
	objects := aCollection ! !

!HVHtmlSelection methodsFor: 'initialize-release' stamp: 'gk 11/11/2003 11:21'!
objects: objs values: vals nilLabel: label selector: sel
	objects _ objs.
	values _ vals.
	nilLabel _ label.
	sel ifNil: [labelSelector _ #name] ifNotNil: [labelSelector _ sel]! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 11/11/2003 15:57'!
removeObject: anObject
	^objects remove: anObject ifAbsent: [nil]! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 11/11/2003 16:00'!
removeSelected
	^self removeObject: self value! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 11/11/2003 11:19'!
selector: aSymbol
	labelSelector _ aSymbol! !

HVHtmlFormElement subclass: #HVHtmlTextArea
	instanceVariableNames: 'rows cols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVHtmlTextArea commentStamp: 'gh 6/12/2002 10:51' prior: 0!
A textarea for Forms.!

!HVHtmlTextArea class methodsFor: 'instance creation' stamp: 'gk 1/13/2005 13:45'!
name: aName rows: rows cols: cols value: aValue
	^(super named: aName) value: aValue; rows: rows cols: cols; yourself! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gh 3/19/2002 21:01'!
cols
	^cols! !

!HVHtmlTextArea methodsFor: 'rendering' stamp: 'gk 3/31/2005 14:41'!
doPrintHtmlOn: stream
	"The value should have the basic ($< $> $&) entities escaped."

	stream nextPutAll: '<textarea name="', name, '" rows="', rows asString, '" cols="', cols asString, '"'.
	self renderAttributesOn: stream.
	stream nextPut: $>; nextPutAll: (value ifNil: [''] ifNotNil: [value asString escapeEntities]); nextPutAll: '</textarea>'
! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:21'!
readonly
	^readonly! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gh 3/19/2002 21:00'!
rows
	^rows! !

!HVHtmlTextArea methodsFor: 'private' stamp: 'gh 3/19/2002 21:00'!
rows: r cols: c
	rows _ r.
	cols _ c! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:21'!
setReadonly
	readonly _ true! !

!HVHtmlVariable class methodsFor: 'instance creation' stamp: 'gk 1/13/2005 13:43'!
name: aName value: aValue
	^(super named: aName) value: aValue; yourself! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
name
	^name! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:54'!
name: aName
	name _ aName! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
value
	^value! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
value: aVal
	value _ aVal! !

HVHtmlVariable subclass: #HVSimpleVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Builder'!

!HVSimpleVariable commentStamp: 'gh 6/12/2002 10:55' prior: 0!
The concrete subclass of HVHtmlVariable that is used for embedding simple variables in HTML pages.!

!HVSimpleVariable methodsFor: 'rendering' stamp: 'gk 1/14/2005 12:12'!
doPrintHtmlOn: stream
	"Try printing it."

	self childrenDo: [:ea | ea printHtmlOn: stream].
	value ifNotNil: [value printHtmlOn: stream]! !

HVSimpleVariable subclass: #HVTOCTopRenderer
	instanceVariableNames: 'toc builder baseUrl rootEntry vertical'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Extras-TOCs'!

!HVTOCTopRenderer commentStamp: 'gk 4/1/2004 16:42' prior: 0!
Renders only the top labels of a HVTOC in a vertic<al or horisontal row in HTML.!

!HVTOCTopRenderer class methodsFor: 'instance creation' stamp: 'gk 1/14/2005 12:07'!
name: aName value: aValue builder: aBuilder
	^(super named: aName) name: aName value: aValue builder: aBuilder; yourself! !

!HVTOCTopRenderer methodsFor: 'accessing' stamp: 'gk 4/2/2004 14:50'!
baseUrl
	^baseUrl! !

!HVTOCTopRenderer methodsFor: 'accessing' stamp: 'gk 4/1/2004 16:39'!
baseUrl: url
	baseUrl _ url! !

!HVTOCTopRenderer methodsFor: 'rendering' stamp: 'gk 4/22/2005 12:32'!
builder
	^builder! !

!HVTOCTopRenderer methodsFor: 'rendering' stamp: 'gk 4/2/2004 15:43'!
doPrintHtmlOn: stream
	"Render the TOC. If we have no toc to render,
	we act as a simple variable instead."

	| entries |
	toc ifNil:[ ^super doPrintHtmlOn: stream ]. "no items to render, take the value instead"
	entries _ (rootEntry ifNil: [toc] ifNotNil: [rootEntry]) entries.
	entries do: [:entry |
		(HVTOCEntryRenderer on: entry parent: self)
			printHtmlOn: stream builder: builder vertical: vertical]
! !

!HVTOCTopRenderer methodsFor: 'rendering' stamp: 'gk 4/2/2004 14:29'!
fullName
	^baseUrl! !

!HVTOCTopRenderer methodsFor: 'initialize-release' stamp: 'gk 4/2/2004 15:43'!
name: aName value: aValue builder: aBuilder
	builder _ aBuilder.
	name _ aName.
	value _ aValue.
	vertical _ false! !

!HVTOCTopRenderer methodsFor: 'accessing' stamp: 'gk 4/2/2004 15:26'!
rootEntry: anEntry
	rootEntry _ anEntry! !

!HVTOCTopRenderer methodsFor: 'accessing' stamp: 'gk 4/1/2004 16:38'!
toc
	^toc! !

!HVTOCTopRenderer methodsFor: 'accessing' stamp: 'gk 4/1/2004 16:38'!
toc: aToc
	toc _ aToc! !

!HVTOCTopRenderer methodsFor: 'accessing' stamp: 'gk 4/2/2004 15:42'!
vertical: aBoolean
	vertical _ aBoolean! !

HVTOCTopRenderer subclass: #HVTOCTreeRenderer
	instanceVariableNames: 'openImageUrl closedImageUrl leafImageUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Extras-TOCs'!

!HVTOCTreeRenderer commentStamp: 'gk 3/31/2004 16:27' prior: 0!
Renders a HVTOC as an expandable/collapsable tree view in HTML. It only uses HTML (no Javascript) but does rely on a cookie for knowing which of the entries that are expanded.!

!HVTOCTreeRenderer methodsFor: 'initialize-release' stamp: 'gh 10/29/2002 09:52'!
baseUrl: base open: openDoc closed: closedDoc leaf: leafDoc
	openDoc ifNotNil: [openImageUrl _ base, openDoc fileName].
	closedDoc ifNotNil: [closedImageUrl _ base, closedDoc fileName].
	leafDoc ifNotNil: [leafImageUrl _ base, leafDoc fileName]! !

!HVTOCTreeRenderer methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:25'!
closedImageUrl
	^closedImageUrl! !

!HVTOCTreeRenderer methodsFor: 'rendering' stamp: 'gk 4/21/2005 10:26'!
doPrintHtmlOn: stream
	"Render the TOC. If we have no toc to render,
	we act as a simple variable instead. After rendering
	we clean up any temporarily closed entries from the
	cookie."

	| expanded |
	toc ifNil:[ ^super doPrintHtmlOn: stream ]. "no items to render, take the value instead"
	expanded _ self expanded.
	toc entries do: [:entry |
		(HVTOCEntryTreeRenderer on: entry parent: self)
			printHtmlOn: stream expanded: expanded level: 0 builder: builder].
	builder view clearJustClosed
! !

!HVTOCTreeRenderer methodsFor: 'rendering' stamp: 'gk 4/7/2004 15:19'!
expanded
	"Return all names that should be expanded.
	We retrieve the cookie and convert it to a Set of Symbols."

	| attrs tocSym tc |
	tocSym _ builder view tocSymbol.
	attrs _ KomSession current attributes.
	tc _ attrs at: tocSym ifAbsent:[attrs at: tocSym put: ''].
	tc ifNil: [tc _ attrs at: tocSym put: ''].
	^((tc findTokens: $,) collect: [:s | s asSymbol]) asSet
! !

!HVTOCTreeRenderer methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:25'!
leafImageUrl
	^leafImageUrl! !

!HVTOCTreeRenderer methodsFor: 'initialize-release' stamp: 'gk 4/1/2004 16:41'!
name: aName value: aValue builder: aBuilder
	super name: aName value: aValue builder: aBuilder.
	openImageUrl _ '/static/open.gif'.
	closedImageUrl _ '/static/closed.gif'.
	leafImageUrl _ '/static/leaf.gif'! !

!HVTOCTreeRenderer methodsFor: 'initialize-release' stamp: 'gh 10/17/2002 15:26'!
open: oUrl closed: cUrl leaf: lUrl
	openImageUrl _ oUrl.
	closedImageUrl _ cUrl.
	leafImageUrl _ lUrl! !

!HVTOCTreeRenderer methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:24'!
openImageUrl
	^openImageUrl! !

TestCase subclass: #CanvasTestCase
	instanceVariableNames: 'canvas dom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Canvas-Tests'!

!CanvasTestCase class methodsFor: 'testing' stamp: 'gc 8/6/2007 19:23'!
isAbstract
	^ self name = #CanvasTestCase! !

!CanvasTestCase methodsFor: 'accessing' stamp: 'gc 11/3/2007 17:37'!
assertAttribute: attribute isEqualTo: value 
	self 
		assertAttribute: attribute
		ofTag: self firstElement
		isEqualTo: value! !

!CanvasTestCase methodsFor: 'accessing' stamp: 'gc 11/3/2007 17:34'!
assertAttribute: attribute ofTag: element isEqualTo: value 
	self assert: (element attributeAt: attribute) = value! !

!CanvasTestCase methodsFor: 'accessing' stamp: 'gc 11/3/2007 17:37'!
assertTagName: name
	self assert: self firstElement name = name! !

!CanvasTestCase methodsFor: 'accessing' stamp: 'gc 8/6/2007 19:24'!
dom
	^ dom ifNil:
		[dom := XMLDOMParser parseDocumentFrom: canvas render readStream]! !

!CanvasTestCase methodsFor: 'accessing' stamp: 'gc 11/3/2007 17:36'!
elements
	^ self dom elements! !

!CanvasTestCase methodsFor: 'accessing' stamp: 'gc 11/3/2007 17:37'!
firstElement
	^ self elements first! !

CanvasTestCase subclass: #HVCanvasTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Canvas-Tests'!

!HVCanvasTest methodsFor: 'as yet unclassified' stamp: 'gc 11/3/2007 15:38'!
testRequestView
	canvas := HVXHTMLCanvas request: #request view: #view.
	self assert: canvas request = #request.
	self assert: canvas view = #view! !

CanvasTestCase subclass: #HVXHTMLCanvasTest
	instanceVariableNames: 'request view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVXHTMLCanvasTest methodsFor: 'accessing' stamp: 'gc 11/3/2007 15:48'!
assertInputTagType: type 
	self assertAttribute: 'type' isEqualTo: type! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:11'!
setUp
	request := HVMockHttpRequest new.
	request postFields:
		((Dictionary new)
			at: '1-1' put: 'test';
			yourself).
	request post: true.
	request url: 'http://localhost.localdomain/test/'.
	view := HVMockView new.
	view request: request.
	canvas := HVXHTMLCanvas
					request: request
					view: view! !

!HVXHTMLCanvasTest methodsFor: 'private' stamp: 'gc 2/8/2007 12:01'!
skipXmlTagAndDoctype: aStream 
	aStream next: canvas xmlTag size.
	aStream next: canvas doctype size! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/18/2007 20:44'!
testA
	canvas a
		href: 'test';
		with: [].
	self assertTagName: #a! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/17/2007 16:18'!
testAbbr
	canvas abbr
		with: [].
	self assertTagName: #abbr! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 11:32'!
testAbbreviation
	canvas abbreviation
		with: [].
	self assertTagName: #abbr! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:06'!
testAcronym
	canvas acronym
		with: [].
	self assertTagName: #acronym! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:08'!
testAddress
	canvas address
		with: [].
	self assertTagName: #address! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/18/2007 20:46'!
testAnchor
	canvas anchor
		with: [].
	self assertTagName: #a.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:19'!
testAnchorToDefault
	canvas anchor toDefault; with: [].
	self assertTagName: #a.
	self assertAttribute: 'href' isEqualTo: request url.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:19'!
testAnchorToLocal
	canvas anchor toLocal: 'test'; with: [].
	self assertTagName: #a.
	self assertAttribute: 'href' isEqualTo: request url, 'test'.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:19'!
testAnchorToParent
	canvas anchor toParent; with: [].
	self assertTagName: #a.
	self assertAttribute: 'href' isEqualTo: 'http://localhost.localdomain/'.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:20'!
testAnchorToParentCustomUrl
	canvas anchor toParent: 'test'; with: [].
	self assertTagName: #a.
	self assertAttribute: 'href' isEqualTo: 'http://localhost.localdomain/test'.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:20'!
testAnchorToTop
	canvas anchor toTop; with: [].
	self assertTagName: #a.
	self assertAttribute: 'href' isEqualTo: 'http://localhost.localdomain/'.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:20'!
testAnchorToTopCustomUrl
	canvas anchor toTop: 'foo'; with: [].
	self assertTagName: #a.
	self assertAttribute: 'href' isEqualTo: 'http://localhost.localdomain/foo'.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 13:21'!
testArea
	canvas area with: [].
	self assertTagName: #area! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:42'!
testB
	canvas b: [].
	self assertTagName: #b! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/17/2007 16:39'!
testBase
	canvas base: 'test'.
	self assertTagName: #base! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:30'!
testBdo
	canvas bdo leftToRight; with: [].
	self assertTagName: #bdo.
	self
		shouldnt: [canvas bdo class: 'test']
		raise: HVAttributeError! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:42'!
testBig
	canvas big: [].
	self assertTagName: #big! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:19'!
testBlockquote
	canvas blockquote: [].
	self assertTagName: #blockquote! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/17/2007 16:39'!
testBody
	canvas body: [].
	self assertTagName: #body! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/11/2007 15:55'!
testBold
	canvas bold: [].
	self assertTagName: #b! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/17/2007 17:22'!
testBr
	canvas br.
	self assertTagName: #br! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:44'!
testBreak
	canvas break.
	self assertTagName: #br! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:19'!
testButton
	canvas button: [].
	self assertTagName: #button! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:20'!
testButtonName
	| form |
	canvas form with: [canvas button with: []].
	form := self elements first.
	self
		assertAttribute: 'name'
		ofTag: form elements first
		isEqualTo: '1-1'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:07'!
testCaption
	canvas caption: [].
	self assertTagName: #caption! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:54'!
testCheckboxInput
	canvas checkboxInput  with: [].
	self assertTagName: #input.
	self assertInputTagType: 'checkbox'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:21'!
testCitation
	canvas citation: [].
	self assertTagName: #cite! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:22'!
testCite
	canvas cite: [].
	self assertTagName: #cite! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:25'!
testCode
	canvas code: [].
	self assertTagName: #code! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 23:31'!
testCol
	canvas col: [].
	self assertTagName: #col! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 00:01'!
testColGroup
	canvas colGroup: [].
	self assertTagName: #colgroup! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 23:30'!
testColumn
	canvas column: [].
	self assertTagName: #col! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 23:32'!
testColumnGroup
	canvas columnGroup: [].
	self assertTagName: #colgroup! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:11'!
testDd
	canvas dd: [].
	self assertTagName: #dd! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:30'!
testDefinition
	canvas definition: [].
	self assertTagName: #dfn! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:10'!
testDefinitionData
	canvas definitionData: [].
	self assertTagName: #dd! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:07'!
testDefinitionList
	canvas definitionList: [].
	self assertTagName: #dl! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:09'!
testDefinitionTerm
	canvas definitionTerm: [].
	self assertTagName: #dt! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 17:08'!
testDel
	canvas del: [].
	self assertTagName: #del! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 17:07'!
testDeletion
	canvas deletion: [].
	self assertTagName: #del! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:31'!
testDfn
	canvas dfn: [].
	self assertTagName: #dfn! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 17:37'!
testDirection
	canvas direction leftToRight; with: [].
	self assertTagName: #bdo! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/17/2007 16:08'!
testDiv
	canvas div
		with: [].
	self assertTagName: #div! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 22:48'!
testDivision
	canvas division
		with: [].
	self assertTagName: #div! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:08'!
testDl
	canvas dl: [].
	self assertTagName: #dl! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:09'!
testDt
	canvas dt: [].
	self assertTagName: #dt! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:33'!
testEm
	canvas em: [].
	self assertTagName: #em! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:32'!
testEmphasis
	canvas emphasis: [].
	self assertTagName: #em! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/16/2007 23:15'!
testFieldset
	canvas fieldset: [].
	self assertTagName: #fieldset! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:57'!
testFileInput
	canvas fileInput  with: [].
	self assertTagName: #input.
	self assertInputTagType: 'file'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/31/2007 11:52'!
testForm
	canvas form action: 'test'; with: [].
	self assertTagName: #form! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:20'!
testFormElementValue
	| input |
	canvas form with: [input := canvas input].
	self assert: input value = 'test'.
	request post: false.
	self assert: input value = input! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:20'!
testFormName
	canvas form with: [].
	self assertTagName: #form.
	self assertAttribute: 'action' isEqualTo: request url.
	self assertAttribute: 'id' isEqualTo: '1'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/17/2007 17:22'!
testH1
	canvas h1: [].
	self assertTagName: #h1! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/17/2007 17:22'!
testH2
	canvas h2: [].
	self assertTagName: #h2! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/17/2007 17:22'!
testH3
	canvas h3: [].
	self assertTagName: #h3! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/17/2007 17:23'!
testH4
	canvas h4: [].
	self assertTagName: #h4! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/17/2007 17:23'!
testH5
	canvas h5: [].
	self assertTagName: #h5! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/17/2007 17:23'!
testH6
	canvas h6: [].
	self assertTagName: #h6! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/17/2007 17:23'!
testHead
	canvas head: [].
	self assertTagName: #head! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:58'!
testHiddenInput
	canvas hiddenInput  with: [].
	self assertTagName: #input.
	self assertInputTagType: 'hidden'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:46'!
testHorizontalRule
	canvas horizontalRule.
	self assertTagName: #hr! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:49'!
testHr
	canvas hr.
	self assertTagName: #hr! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 11/3/2007 17:38'!
testHtml
	| html |
	canvas html: [].
	html := self firstElement.
	self assert: self dom version = '1.0'.
	self assert: self dom encoding = 'UTF-8'.
	self assert: html name = #html.
	self assert: (html attributes at: 'xmlns') = canvas xmlns! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:50'!
testI
	canvas i: [].
	self assertTagName: #i! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:20'!
testIfNotPressed
	| button wasNotPressed|
	canvas form with: [button := canvas button value: 'foo'].
	button ifNotPressed: [wasNotPressed := true].
	self assert: wasNotPressed! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:21'!
testIfNotPressedifPressed
	| button wasPressed wasNotPressed |
	wasPressed := false.
	canvas form with: [button := canvas button value: 'foo'.].
	button ifNotPressed: [wasNotPressed := true] ifPressed: [wasPressed := true].
	self assert: wasNotPressed.
	self deny: wasPressed! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:21'!
testIfPressed
	| button wasPressed|
	canvas form with: [button := canvas button value: 'test'.].
	button ifPressed: [wasPressed := true].
	self assert: wasPressed! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:21'!
testIfPressedifNotPressed
	| button wasPressed wasNotPressed |
	wasNotPressed := false.
	canvas form with: [button := canvas button value: 'test'.].
	button ifPressed: [wasPressed := true] ifNotPressed: [wasNotPressed := true].
	self assert: wasPressed.
	self deny: wasNotPressed! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 12:41'!
testImage
	canvas image source: 'test' alternativeText: 'test'.
	self assertTagName: #img! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:58'!
testImageInput
	canvas imageInput  with: [].
	self assertTagName: #input.
	self assertInputTagType: 'image'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:47'!
testInput
	canvas input
		with: [].
	self assertTagName: #input! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:21'!
testInputName
	| form |
	canvas form with: [canvas input with: []].
	form := self elements first.
	self
		assertAttribute: 'name'
		ofTag: form elements first
		isEqualTo: '1-1'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 17:30'!
testIns
	canvas ins: [].
	self assertTagName: #ins! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 17:29'!
testInsertion
	canvas insertion: [].
	self assertTagName: #ins! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 4/12/2007 19:22'!
testIsEmpty
	self assert: canvas isEmpty.
	canvas html: [].
	self deny: canvas isEmpty! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:21'!
testIsPressed
	| button |
	canvas form with: [button := canvas button value: 'test'.].
	self assert: button isPressed! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:21'!
testIsPressedWithWrongValue
	| button |
	canvas form with: [button := canvas button value: 'foo'.].
	self deny: button isPressed! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:49'!
testItalic
	canvas italic: [].
	self assertTagName: #i! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:39'!
testKbd
	canvas kbd: [].
	self assertTagName: #kbd! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:38'!
testKeyboard
	canvas keyboard: [].
	self assertTagName: #kbd! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/17/2007 10:30'!
testLabel
	canvas label with: [].
	self assertTagName: #label! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/17/2007 10:22'!
testLegend
	canvas legend: [].
	self assertTagName: #legend! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:18'!
testLi
	canvas li: [].
	self assertTagName: #li! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 15:54'!
testLink
	canvas link
		with: [].
	self assertTagName: #link! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:17'!
testListItem
	canvas listItem: [].
	self assertTagName: #li! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/31/2007 14:54'!
testMap
	canvas map: [].
	self assertTagName: #map.
	self
		should: [canvas map classes: {}]
		raise: HVAttributeError 
! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/31/2007 20:05'!
testMeta
	canvas meta content: 'test'.
	self assertTagName: #meta! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:21'!
testMultipleForms
	canvas form with: [].
	canvas form with: [].
	self assertAttribute: 'id' isEqualTo: '1'.
	self assertAttribute: 'id' ofTag: self elements second isEqualTo: '2'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:21'!
testMultipleFormsAndInputs
	| form |
	canvas form with: [canvas textInput with: []].
	canvas form with: [canvas textInput with: []].
	form := self elements first.
	self
		assertAttribute: 'name'
		ofTag: form elements first
		isEqualTo: '1-1'.
	form := self elements second.
	self
		assertAttribute: 'name'
		ofTag: form elements first
		isEqualTo: '2-1'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:21'!
testMultipleInputs
	| form |
	canvas form with:
		[canvas textInput with: [].
		canvas textInput with: []].
	form := self elements first.
	self
		assertAttribute: 'name'
		ofTag: form elements first
		isEqualTo: '1-1'.
	self
		assertAttribute: 'name'
		ofTag: form elements second
		isEqualTo: '1-2'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/6/2007 19:25'!
testNestedTags
	| result |
	canvas head: [canvas body: []].
	result := ReadStream on: canvas render.
	self assert: (result next: 6) = '<head>'.
	self assert: (result next: 6) = '<body>'.
	self assert: (result next: 7) = '</body>'.
	self assert: (result next: 7) = '</head>'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 14:45'!
testNoScript
	canvas noscript: [].
	self assertTagName: #noscript! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/10/2007 18:37'!
testNoTags
	self assert: canvas render = ''
! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:09'!
testObject
	canvas object
		with: [].
	self assertTagName: #object.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:14'!
testOl
	canvas ol: [].
	self assertTagName: #ol! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/17/2007 11:39'!
testOption
	canvas option
		with: [].
	self assertTagName: #option.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:27'!
testOptionGroup
	canvas optionGroup: [].
	self assertTagName: #optgroup.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:14'!
testOrderedList
	canvas orderedList: [].
	self assertTagName: #ol! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/19/2007 23:07'!
testP
	canvas p
		with: [].
	self assertTagName: #p.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 2/19/2007 23:06'!
testParagraph
	canvas paragraph
		with: [].
	self assertTagName: #p.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:34'!
testParam
	canvas param
		name: 'test';
		with: [].
	self assertTagName: #param! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:34'!
testParameter
	canvas parameter
		name: 'test';
		with: [].
	self assertTagName: #param! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:53'!
testPasswordInput
	canvas passwordInput with: [].
	self assertTagName: #input.
	self assertInputTagType: 'password'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:44'!
testPre
	canvas pre: [].
	self assertTagName: #pre! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:43'!
testPreformatted
	canvas preformatted: [].
	self assertTagName: #pre! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:47'!
testQ
	canvas q: [].
	self assertTagName: #q! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:46'!
testQuote
	canvas quote: [].
	self assertTagName: #q! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:54'!
testRadioInput
	canvas radioInput  with: [].
	self assertTagName: #input.
	self assertInputTagType: 'radio'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 16:03'!
testRb
	canvas rb: [].
	self assertTagName: #rb! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 16:01'!
testRbc
	canvas rbc: [].
	self assertTagName: #rbc! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:56'!
testResetInput
	canvas resetInput  with: [].
	self assertTagName: #input.
	self assertInputTagType: 'reset'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 16:09'!
testRp
	canvas rp: [].
	self assertTagName: #rp! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 16:08'!
testRt
	canvas rt: [].
	self assertTagName: #rt! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 16:02'!
testRtc
	canvas rtc: [].
	self assertTagName: #rtc! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 15:59'!
testRuby
	canvas ruby: [].
	self assertTagName: #ruby! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 16:03'!
testRubyBase
	canvas rubyBase: [].
	self assertTagName: #rb! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 16:00'!
testRubyBaseContainer
	canvas rubyBaseContainer: [].
	self assertTagName: #rbc! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 16:04'!
testRubyText
	canvas rubyText: [].
	self assertTagName: #rt! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 16:02'!
testRubyTextContainer
	canvas rubyTextContainer: [].
	self assertTagName: #rtc! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:51'!
testSamp
	canvas samp: [].
	self assertTagName: #samp! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:50'!
testSample
	canvas sample: [].
	self assertTagName: #samp! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/31/2007 20:20'!
testScript
	canvas script type: 'test'; with: [].
	self assertTagName: #script! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/17/2007 11:07'!
testSelect
	canvas select
		with: [].
	self assertTagName: #select.! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:22'!
testSelectName
	| form |
	canvas form with: [canvas select with: []].
	form := self elements first.
	self
		assertAttribute: 'name'
		ofTag: form elements first
		isEqualTo: '1-1'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:53'!
testSmall
	canvas small: [].
	self assertTagName: #small! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/17/2007 16:19'!
testSpan
	canvas span
		with: [].
	self assertTagName: #span! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:52'!
testStrong
	canvas strong: [].
	self assertTagName: #strong! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/25/2007 15:35'!
testStyle
	canvas style: [].
	self assertTagName: #style! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:55'!
testSub
	canvas sub: [].
	self assertTagName: #sub! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:55'!
testSubmitInput
	canvas submitInput  with: [].
	self assertTagName: #input.
	self assertInputTagType: 'submit'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:54'!
testSubscript
	canvas subscript: [].
	self assertTagName: #sub! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:57'!
testSup
	canvas sup: [].
	self assertTagName: #sup! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:56'!
testSuperscript
	canvas superscript: [].
	self assertTagName: #sup! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:05'!
testTable
	canvas table: [].
	self assertTagName: #table! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 23:12'!
testTableBody
	canvas tableBody: [].
	self assertTagName: #tbody! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 21:08'!
testTableData
	canvas tableData: [].
	self assertTagName: #td! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 23:10'!
testTableFoot
	canvas tableFoot: [].
	self assertTagName: #tfoot! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 23:09'!
testTableHead
	canvas tableHead: [].
	self assertTagName: #thead! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 22:11'!
testTableHeader
	canvas tableHeader: [].
	self assertTagName: #th! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:58'!
testTableRow
	canvas tableRow: [].
	self assertTagName: #tr! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:58'!
testTeletype
	canvas teletype: [].
	self assertTagName: #tt! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/17/2007 18:07'!
testTextArea
	canvas textArea
		with: [].
	self assertTagName: #textarea! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 8/25/2008 18:24'!
testTextAreaName
	| form |
	canvas form with: [canvas textArea with: []].
	form := self elements first.
	self
		assertAttribute: 'name'
		ofTag: form elements first
		isEqualTo: '1-1'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:52'!
testTextInput
	canvas textInput with: [].
	self assertTagName: #input.
	self assertInputTagType: 'text'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 22:12'!
testTh
	canvas th: [].
	self assertTagName: #th! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 11/3/2007 17:39'!
testTitle
	canvas title: 'test'.
	self assert: self firstElement name = #title.
	self assert: self firstElement contents first string = 'test'! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 20:01'!
testTr
	canvas tr: [].
	self assertTagName: #tr! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:59'!
testTt
	canvas tt: [].
	self assertTagName: #tt! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:16'!
testUl
	canvas ul: [].
	self assertTagName: #ul! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/24/2007 11:16'!
testUnorderedList
	canvas unorderedList: [].
	self assertTagName: #ul! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:55'!
testVar
	canvas var: [].
	self assertTagName: #var! !

!HVXHTMLCanvasTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:55'!
testVariable
	canvas variable: [].
	self assertTagName: #var! !

TestCase subclass: #HVAttributeNotUnderstoodTest
	instanceVariableNames: 'error tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVAttributeNotUnderstoodTest methodsFor: 'tests' stamp: 'gc 2/12/2007 11:39'!
setUp
	tag := HVHtmlTag canvas: nil.
	error := HVAttributeNotUnderstood tag: tag attribute: 'attribute'.! !

!HVAttributeNotUnderstoodTest methodsFor: 'tests' stamp: 'gc 2/12/2007 11:39'!
testConstructor
	self assert: error htmlTag = tag.
	self assert: error attribute = 'attribute'! !

!HVAttributeNotUnderstoodTest methodsFor: 'tests' stamp: 'gc 2/12/2007 11:46'!
testDefaultAction
	self assert: error defaultAction = error! !

!HVAttributeNotUnderstoodTest methodsFor: 'tests' stamp: 'gc 2/12/2007 11:45'!
testIsResumable
	self assert: error isResumable ! !

!HVAttributeNotUnderstoodTest methodsFor: 'tests' stamp: 'gc 2/12/2007 11:41'!
testMessageText
	self assert: error messageText = 'Tag ''html'' does not understand attribute ''attribute'''! !

TestCase subclass: #MacroProcessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Tests'!

!MacroProcessorTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 15:07'!
testDeepRecurse

	| processor result |
	"A processor that either just encloses in parentheses, or expands into a new
	macro that in turn will duplicate its contents."
	processor := MacroProcessor
					block: [:x | x size > 5
								ifTrue: ['(', x, ')']
								ifFalse: ['[', x, x, ']']]
					between: '[' and: ']'.

	"deep and recursive:
		Only the inner most is doubled (and doubled yet again) to be larger than 5." 	
	result := processor process: '[dab] [dooooo] [tiny[itsy]] [x[y[z]]]'.
	self assert: result = '(dabdab) (dooooo) (tiny(itsyitsy)) (x(y(zzzzzzzz)))'.

	"only recursive:
		The result of doubling is not processed in turn thus leaving unprocessed macros like [dabdab] in the result.
		In the last example the outer macro y also get a chance to double."
	processor deep: false.
	result := processor process: '[dab] [dooooo] [tiny[itsy]] [x[y[z]]]'.
	self assert: result = '[dabdab] (dooooo) (tiny[itsyitsy]) (x[y[zz]y[zz]])'.

	"not deep nor recursive:
		Only the outer most macros are processed, and not in turn."	
	processor recurse: false.
	result := processor process: '[dab] [dooooo] [tiny[itsy]] [x[y[z]]]'.
	self assert: result = '[dabdab] (dooooo) (tiny[itsy]) (x[y[z]])'.

	"only deep:
		Almost like deep and recursive but note the last example where the expansion goes like:
			[x[y[z]]] -> (x[y[z]]) -> (x[y[z]y[z]]) -> (x(y[z]y[z])) -> (x(y[zz]y[zz])) ->
			(x(y[zzzz]y[zzzz])) -> (x(y[zzzzzzzz]y[zzzzzzzz])) -> (x(y(zzzzzzzz)y(zzzzzzzz)))"	
	processor deep: true.
	result := processor process: '[dab] [dooooo] [tiny[itsy]] [x[y[z]]]'.
	self assert: result = '(dabdab) (dooooo) (tiny(itsyitsy)) (x(y(zzzzzzzz)y(zzzzzzzz)))'
! !

TestCase subclass: #SwikiFormatterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Tests'!

!SwikiFormatterTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 16:16'!
builder
	^WBHtmlBuilder request: (HVHttpRequestMock new) view: self! !

!SwikiFormatterTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 16:17'!
resolveTag: aTag builder: aBuilder
	^false! !

!SwikiFormatterTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 16:16'!
swikify: aString
	"Helper method, used for tests."

	^((SwikiFormatter base: 'http://www.garble.com' model: self) swikify: aString builder: self builder) render! !

!SwikiFormatterTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 16:23'!
test1

	self assert: ((self swikify: '!!Heading1
A line after that with cr.
A <b>bold</b> word.
Another _bold_ word.
!!!!Heading2
A paragraph.
With a line break in it.

|
And a horizontal ruler above this paragraph.

!!!!!!Heading3
Another paragraph. <html><pre>Don''t touch this.
No line breaking.</pre></html> End of paragraph.
') = '<html><head></head><body><h1>Heading1</h1><p>A line after that with cr.<br />A <b>bold</b> word.<br />Another <b>bold</b> word.</p><h2>Heading2</h2><p>A paragraph.<br />With a line break in it.</p><hr /><p>And a horizontal ruler above this paragraph.</p><h3>Heading3</h3><p>Another paragraph. <pre>Don''t touch this.
No line breaking.</pre> End of paragraph.</p><br /></body></html>')! !

!SwikiFormatterTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 16:23'!
test2

	self assert: ((self swikify: 'A paragraph
That has a <b>bold</b> word and
two linebreaks in it.


!!Before this heading 1 there should be one extra break
A paragraph after heading 1 and an & (ampersand).

Another paragraph after heading 1') = '<html><head></head><body><p>A paragraph<br />That has a <b>bold</b> word and<br />two linebreaks in it.</p><br /><h1>Before this heading 1 there should be one extra break</h1><p>A paragraph after heading 1 and an & (ampersand).</p><p>Another paragraph after heading 1</p></body></html>')! !

!SwikiFormatterTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 16:24'!
test3

	self assert: ((self swikify: 'A *link* and an aliased *This is the shown text|link*') = '<html><head></head><body><p>A <a href="http://www.garble.com/link">link</a> and an aliased <a href="http://www.garble.com/link">This is the shown text</a></p></body></html>') ! !

!SwikiFormatterTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 16:23'!
test4

	self assert: ((self swikify: 'An asterisk: **, an underscore: __, a less than: <<, a more than: >> and an amp: &&') = '<html><head></head><body><p>An asterisk: *, an underscore: _, a less than: &lt;, a more than: &gt; and an amp: &amp;</p></body></html>') ! !

!SwikiFormatterTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 16:23'!
test5

	self assert: ((self swikify: '_bold_ _*a_file_with_underscores*_') = '<html><head></head><body><p><b>bold</b> <b><a href="http://www.garble.com/a_file_with_underscores">a_file_with_underscores</a></b></p></body></html>') ! !

!SwikiFormatterTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 16:24'!
test6

	self assert: ((self swikify: '-One
-Two
--Nested one with a *link* and an && and a ** (star)
--Nested two with two <b>bold</b> _words_
---Deep down one
-Three

#Uno
#Dos
#Tres
') = '<html><head></head><body><ul><li>One</li><li>Two</li><ul><li>Nested one with a <a href="http://www.garble.com/link">link</a> and an &amp; and a * (star)</li><li>Nested two with two <b>bold</b> <b>words</b></li><ul><li>Deep down one</li></ul></ul><li>Three</li></ul><ol><li>Uno</li><li>Dos</li><li>Tres</li></ol><br /></body></html>') ! !

!SwikiFormatterTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 16:39'!
test7

	self assert: ((self swikify: 'The date today: <%DATE%> and base url: <%BASE%>') = ('<html><head></head><body><p>The date today: ', (Date today asString), ' and base url: http://www.garble.com</p></body></html>')) ! !

!SwikiFormatterTest methodsFor: 'as yet unclassified' stamp: 'gk 7/8/2006 16:17'!
urlForLink: aString
	"We just return the string.
	Below is a sample method from the HomepageBuilder app."

	^aString


"urlForLink: aString
	""Resolve aString into a relative url. Case insensitive.
	We check for products, employees, special pages,
	newslines and documents in that order. If nothing matches
	the string is returned as it is.""

	| hit string |
	string _ aString asLowercase.
	hit _ company productOrGroupNamed: string.
	hit ifNotNil: [^'produkter/', hit nameInGroup].
	hit _ company employees detect: [:e | e name asLowercase beginsWith: string] ifNone: [nil].
	hit ifNotNil: [^'personal/', hit name].
	hit _ specialPages detect: [:p | p title asLowercase = string] ifNone: [nil].
	hit ifNotNil: [^'sida/', hit id asString].
	hit _ newsItems detect: [:i | i title asLowercase = string] ifNone: [nil].
	hit ifNotNil: [^'nyheter/', hit title].
	hit _ documents detect: [:d | d alias asLowercase = string or: [d fileName asLowercase = string]] ifNone: [nil].
	hit ifNotNil: [^'dokument/', hit fileName].
	""no hit...""
	^aString"! !

TestCase subclass: #TagTestCase
	instanceVariableNames: 'canvas tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Canvas-Tests'!

TagTestCase subclass: #HVAnchorTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 22:21'!
testAccessKey
	self should: 
	[self tag
		accessKey: $a;
		with: []]
	addAttribute: 'accesskey'
	withValue: 'a'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:30'!
testBeAlternate
	self should:
		[self tag
			beAlternate;
			with: []]
	addAttribute: 'rel'
	withValue: 'Alternate'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:51'!
testBeAppendix
	self should:
		[self tag
			beAppendix;
			with: []]
	addAttribute: 'rel'
	withValue: 'Appendix'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:52'!
testBeBookmark
	self should:
		[self tag
			beBookmark;
			with: []]
	addAttribute: 'rel'
	withValue: 'Bookmark'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:49'!
testBeChapter
	self should:
		[self tag
			beChapter;
			with: []]
	addAttribute: 'rel'
	withValue: 'Chapter'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:47'!
testBeContents
	self should:
		[self tag
			beContents;
			with: []]
	addAttribute: 'rel'
	withValue: 'Contents'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:48'!
testBeCopyright
	self should:
		[self tag
			beCopyright;
			with: []]
	addAttribute: 'rel'
	withValue: 'Copyright'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:48'!
testBeGlossary
	self should:
		[self tag
			beGlossary;
			with: []]
	addAttribute: 'rel'
	withValue: 'Glossary'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:51'!
testBeHelp
	self should:
		[self tag
			beHelp;
			with: []]
	addAttribute: 'rel'
	withValue: 'Help'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:47'!
testBeIndex
	self should:
		[self tag
			beIndex;
			with: []]
	addAttribute: 'rel'
	withValue: 'Index'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:45'!
testBeNext
	self should:
		[self tag
			beNext;
			with: []]
	addAttribute: 'rel'
	withValue: 'Next'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:46'!
testBePrev
	self should:
		[self tag
			bePrev;
			with: []]
	addAttribute: 'rel'
	withValue: 'Prev'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:46'!
testBePrevious
	self should:
		[self tag
			bePrevious;
			with: []]
	addAttribute: 'rel'
	withValue: 'Prev'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:50'!
testBeSection
	self should:
		[self tag
			beSection;
			with: []]
	addAttribute: 'rel'
	withValue: 'Section'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:34'!
testBeStart
	self should:
		[self tag
			beStart;
			with: []]
	addAttribute: 'rel'
	withValue: 'Start'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:34'!
testBeStylesheet
	self should:
		[self tag
			beStylesheet;
			with: []]
	addAttribute: 'rel'
	withValue: 'Stylesheet'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:50'!
testBeSubsection
	self should:
		[self tag
			beSubsection;
			with: []]
	addAttribute: 'rel'
	withValue: 'Subsection'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 22:23'!
testCharSet
	self should: [self tag charSet: 'test'; with: []] addAttribute: 'charset' withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 13:59'!
testCircularShape
	self 
		should: 
			[(self tag)
				circularShape;
				with: []]
		addAttribute: 'shape'
		withValue: 'circle'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 16:32'!
testContentType
	self should:
		[self tag
			contentType: 'test';
			with: []]
	addAttribute: 'type'
	withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 13:53'!
testCoords
	self should:
		[self tag
			coords: 'test';
			with: []]
	addAttribute: 'coords'
	withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 17:31'!
testFromAlternate
	self should:
		[self tag
			fromAlternate;
			with: []]
	addAttribute: 'rev'
	withValue: 'Alternate'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:12'!
testFromAppendix
	self should:
		[self tag
			fromAppendix;
			with: []]
	addAttribute: 'rev'
	withValue: 'Appendix'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:12'!
testFromBookmark
	self should:
		[self tag
			fromBookmark;
			with: []]
	addAttribute: 'rev'
	withValue: 'Bookmark'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:13'!
testFromChapter
	self should:
		[self tag
			fromChapter;
			with: []]
	addAttribute: 'rev'
	withValue: 'Chapter'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:14'!
testFromContents
	self should:
		[self tag
			fromContents;
			with: []]
	addAttribute: 'rev'
	withValue: 'Contents'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:14'!
testFromCopyright
	self should:
		[self tag
			fromCopyright;
			with: []]
	addAttribute: 'rev'
	withValue: 'Copyright'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:16'!
testFromGlossary
	self should:
		[self tag
			fromGlossary;
			with: []]
	addAttribute: 'rev'
	withValue: 'Glossary'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:16'!
testFromHelp
	self should:
		[self tag
			fromHelp;
			with: []]
	addAttribute: 'rev'
	withValue: 'Help'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:17'!
testFromIndex
	self should:
		[self tag
			fromIndex;
			with: []]
	addAttribute: 'rev'
	withValue: 'Index'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:17'!
testFromNext
	self should:
		[self tag
			fromNext;
			with: []]
	addAttribute: 'rev'
	withValue: 'Next'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:18'!
testFromPrev
	self should:
		[self tag
			fromPrev;
			with: []]
	addAttribute: 'rev'
	withValue: 'Prev'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:21'!
testFromPrevious
	self should:
		[self tag
			fromPrevious;
			with: []]
	addAttribute: 'rev'
	withValue: 'Prev'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:21'!
testFromSection
	self should:
		[self tag
			fromSection;
			with: []]
	addAttribute: 'rev'
	withValue: 'Section'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:22'!
testFromStart
	self should:
		[self tag
			fromStart;
			with: []]
	addAttribute: 'rev'
	withValue: 'Start'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:24'!
testFromStylesheet
	self should:
		[self tag
			fromStylesheet;
			with: []]
	addAttribute: 'rev'
	withValue: 'Stylesheet'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:25'!
testFromSubsection
	self should:
		[self tag
			fromSubsection;
			with: []]
	addAttribute: 'rev'
	withValue: 'Subsection'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 22:24'!
testHref
	self should:
		[self tag
			href: 'test';
			with: []]
	addAttribute: 'href'
	withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 22:19'!
testHrefLang
	self should:
		[self tag
			hrefLang: 'test';
			with: []]
	addAttribute: 'hreflang'
	withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 19:45'!
testOnBlur
	self
		should:
			[self tag
				onBlur: 'test';
				with: []]
		addAttribute: 'onblur'
		withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 19:29'!
testOnFocus
	self should:
		[self tag
			onFocus: 'test';
			with: []]
	addAttribute: 'onfocus'
	withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 13:59'!
testPolygonalShape
	self 
		should: 
			[(self tag)
				polygonalShape;
				with: []]
		addAttribute: 'shape'
		withValue: 'poly'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 13:55'!
testRectangularShape
	self 
		should: 
			[(self tag)
				rectangularShape;
				with: []]
		addAttribute: 'shape'
		withValue: 'rect'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 23:05'!
testRel
	self should:
		[self tag
			rel: 'test';
			with: []]
	addAttribute: 'rel'
	withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 23:05'!
testRelationship
	self should:
		[self tag
			relationship: 'test';
			with: []]
	addAttribute: 'rel'
	withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 23:06'!
testRev
	self should:
		[self tag
			rev: 'test';
			with: []]
	addAttribute: 'rev'
	withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/18/2007 15:58'!
testReverseLink
	self should:
		[self tag
			reverseLink: 'test';
			with: []]
	addAttribute: 'rev'
	withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 7/23/2007 14:59'!
testShape
	self should:
		[self tag
			shape: 'default';
			with: []]
	addAttribute: 'shape'
	withValue: 'default'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:24'!
testTabIndex
	self
		should:
			[self tag
				tabIndex: 42;
				with: []]
		addAttribute: 'tabindex'
		withValue: '42'.
	
	self
		should: [self tag tabIndex: -42]
		raise: HVAttributeError! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 23:10'!
testType
	self should:
		[self tag
			type: 'test';
			with: []]
	addAttribute: 'type'
	withValue: 'test'! !

!HVAnchorTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 22:15'!
testWith
	self assertTagName: #a! !

TagTestCase subclass: #HVAreaTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 12:54'!
testAccessKey
	self
		should:
			[self tag
				accessKey: $t;
				with: []]
		addAttribute: 'accesskey'
		withValue: 't'! !

!HVAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 12:54'!
testAlternativeText
	self
		should:
			[self tag
				alternativeText: 'test';
				with: []]
		addAttribute: 'alt'
		withValue: 'test'! !

!HVAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 14:02'!
testCoords
	self
		should:
			[self tag
				coords: 'test';
				with: []]
		addAttribute: 'coords'
		withValue: 'test'! !

!HVAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 13:13'!
testHref
	self
		should:
			[self tag
				href: 'test';
				with: []]
		addAttribute: 'href'
		withValue: 'test'! !

!HVAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 13:13'!
testNoHref
	self
		should:
			[self tag
				noHref;
				with: []]
		addAttribute: 'nohref'
		withValue: 'nohref'! !

!HVAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 19:46'!
testOnBlur
	self
		should:
			[self tag
				onBlur: 'test';
				with: []]
		addAttribute: 'onblur'
		withValue: 'test'! !

!HVAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 19:47'!
testOnFocus
	self should:
		[self tag
			onFocus: 'test';
			with: []]
	addAttribute: 'onfocus'
	withValue: 'test'! !

!HVAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 13:15'!
testShape
	self should:
		[self tag
			shape: 'default';
			with: []]
	addAttribute: 'shape'
	withValue: 'default'! !

!HVAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 13:22'!
testWith
	self assertTagName: #area.
	self assert: self canvas contents = '<area/>'! !

TagTestCase subclass: #HVBaseTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVBaseTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 20:49'!
testClass
	self
		should: [self tag class: 'test']
		raise: MessageNotUnderstood! !

!HVBaseTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 20:47'!
testEvents
	self
		deny: (self tag class canUnderstand: #onEvent:do:)! !

!HVBaseTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 20:50'!
testHref
	self should:
		[(self tag)
			href: 'test']
	addAttribute: 'href'
	withValue: 'test'! !

!HVBaseTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 20:48'!
testId
	self should:
		[(self tag)
			id: 'test';
			with: []]
	addAttribute: 'id'
	withValue: 'test'! !

!HVBaseTagTest methodsFor: 'tests' stamp: 'gc 2/12/2007 11:55'!
testWith
	self assertTagName: #base.
	self assert: self canvas contents = '<base/>'! !

TagTestCase subclass: #HVBasicTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVBasicTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/30/2007 15:14'!
setUp
	super setUp.
	self tag tag: 'test'! !

!HVBasicTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 21:30'!
testAttributeAtPutNumber
	self tag attributeAt: 'id' putNumber: 42.
	self assert: (self tag attributeAt: 'id') = '42'.
	self
		should: [self tag attributeAt: 'id' putNumber: -42]
		raise: HVAttributeError
		description: 'id can''t be negative'! !

!HVBasicTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/30/2007 15:14'!
testId
	self should:
	[self tag
		id: 'test';
		with: [].]
	addAttribute: 'id'
	withValue: 'test'! !

!HVBasicTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/30/2007 15:15'!
testLeftToRight
	self should:
	[self tag
		leftToRight;
		with: []]
	addAttribute: 'dir'
	withValue: 'ltr'.! !

!HVBasicTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/30/2007 15:15'!
testRightToLeft
	self should:
	[self tag
		rightToLeft;
		with: []]
	addAttribute: 'dir'
	withValue: 'rtl'.! !

!HVBasicTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/30/2007 15:15'!
testXmlLang
	self should:
	[self tag
		xmlLang: 'it';
		with: []]
	addAttribute: 'xml:lang'
	withValue: 'it'! !

TagTestCase subclass: #HVBodyTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVBodyTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 19:49'!
testOnLoad
	self should:
		[self tag
			onLoad: 'test';
			with: []]
	addAttribute: 'onload'
	withValue: 'test'! !

!HVBodyTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 19:50'!
testOnUnload
	self should:
		[self tag
			onUnload: 'test';
			with: []]
	addAttribute: 'onunload'
	withValue: 'test'! !

!HVBodyTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 19:48'!
testWith
	self assertTagName: #body! !

TagTestCase subclass: #HVBreakTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVBreakTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:35'!
testEvents
	self
		shouldnt: [self tag onClick: 'test']
		understandAttribute: 'onclick'.! !

!HVBreakTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:35'!
testLeftToRight
	self shouldnt: [self tag leftToRight] understandAttribute: 'dir'! !

!HVBreakTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:36'!
testRightToLeft
	self shouldnt: [self tag rightToLeft] understandAttribute: 'dir'! !

!HVBreakTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:36'!
testWith
	self assertTagName: #br.
	self assert: self canvas contents = '<br/>'! !

!HVBreakTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:36'!
testXmlLang
	self
		shouldnt: [self tag xmlLang: 'test']
		understandAttribute: 'xml:lang'! !

TagTestCase subclass: #HVButtonTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVButtonTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 18:02'!
testBeButton
	self
		should:
			[self tag
				beButton;
				with: []]
		addAttribute: 'type'
		withValue: 'button'! !

!HVButtonTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 18:02'!
testBeReset
	self
		should:
			[self tag
				beReset;
				with: []]
		addAttribute: 'type'
		withValue: 'reset'! !

!HVButtonTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 18:07'!
testBeSubmit
	self
		should:
			[self tag
				beSubmit;
				with: []]
		addAttribute: 'type'
		withValue: 'submit'! !

!HVButtonTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:00'!
testOnBlur
	self should:
		[self tag
			onBlur: 'test';
			with: []]
	addAttribute: 'onblur'
	withValue: 'test'! !

!HVButtonTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:00'!
testOnFocus
	self should:
		[self tag
			onFocus: 'test';
			with: []]
	addAttribute: 'onfocus'
	withValue: 'test'! !

!HVButtonTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 18:01'!
testType
	self
		should:
			[self tag
				type: 'button';
				with: []]
		addAttribute: 'type'
		withValue: 'button'! !

!HVButtonTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 18:08'!
testValue
	self
		should:
			[self tag
				value: 'test';
				with: []]
		addAttribute: 'value'
		withValue: 'test'! !

!HVButtonTagTest methodsFor: 'as yet unclassified' stamp: 'gc 11/3/2007 17:37'!
testWith
	self assertTagName: #button.
	self assert: (self firstElement attributes at: 'type') = 'submit'.! !

TagTestCase subclass: #HVCommonTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 7/25/2007 00:14'!
setUp
	super setUp.
	self tag tag: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:19'!
testClass
	self should:
		[self tag
			class: 'test';
			with: []]
	addAttribute: 'class'
	withValue: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:19'!
testClasses
	self should:
		[self tag
			classes: {'test1'. 'test2'};
			with: []]
	addAttribute: 'class'
	withValue: 'test1 test2'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 14:55'!
testDefaultSpace
	self should:
	[self tag
		defaultSpace;
		with: []]
	addAttribute: 'xml:space'
	withValue: 'default'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:08'!
testOnClick
	self should:
		[self tag
			onClick: 'test';
			with: []]
	addAttribute: 'onclick'
	withValue: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:10'!
testOnDoubleClick
	self should:
		[self tag
			onDoubleClick: 'test';
			with: []]
	addAttribute: 'ondblclick'
	withValue: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:10'!
testOnKeyDown
	self should:
		[self tag
			onKeyDown: 'test';
			with: []]
	addAttribute: 'onkeydown'
	withValue: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:10'!
testOnKeyPress
	self should:
		[self tag
			onKeyPress: 'test';
			with: []]
	addAttribute: 'onkeypress'
	withValue: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:10'!
testOnKeyUp
	self should:
		[self tag
			onKeyUp: 'test';
			with: []]
	addAttribute: 'onkeyup'
	withValue: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:10'!
testOnMouseDown
	self should:
		[self tag
			onMouseDown: 'test';
			with: []]
	addAttribute: 'onmousedown'
	withValue: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:10'!
testOnMouseMove
	self
		should:
		[self tag
			onMouseMove: 'test';
			with: []]
	addAttribute: 'onmousemove'
	withValue: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:10'!
testOnMouseOut
	self
		should:
		[self tag
			onMouseOut: 'test';
			with: []]
		addAttribute: 'onmouseout'
		withValue: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:10'!
testOnMouseOver
	self
		should:
		[self tag
			onMouseOver: 'test';
			with: []]
		addAttribute: 'onmouseover'
		withValue: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:11'!
testOnMouseUp

	self should:
	[self tag
		onMouseUp: 'test';
		with: []]
	addAttribute: 'onmouseup'
	withValue: 'test'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 14:56'!
testPreserveSpace
	self should:
	[self tag
		preserveSpace;
		with: []]
	addAttribute: 'xml:space'
	withValue: 'preserve'! !

!HVCommonTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 14:57'!
testTitle
	self should:
	[self tag
		title: 'test';
		with: []]
	addAttribute: 'title'
	withValue: 'test'! !

TagTestCase subclass: #HVDirectionTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVDirectionTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/30/2007 17:13'!
testClass
	self
		should:
			[self tag
				class: 'test';
				leftToRight;
				with: []]
		addAttribute: 'class'
		withValue: 'test'! !

!HVDirectionTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/30/2007 17:14'!
testOnClick
	self
		shouldnt: [self tag onClick: 'test']
		understandAttribute: 'onclick'! !

!HVDirectionTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 11:19'!
testWith
	self
		should: [self tag with: []]
		raise: HVAttributeError
		description: '''dir'' not set'.
	self tag attributeAt: 'dir' put: 'ltr'.
	self assertTagName: #bdo! !

!HVDirectionTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/30/2007 17:15'!
testXmlLang
	self
		shouldnt: [self tag xmlLang: 'it']
		understandAttribute: 'xml:lang'! !

TagTestCase subclass: #HVEditTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVEditTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 00:05'!
setUp
	super setUp.
	self tag tag: 'del'! !

!HVEditTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 17:05'!
testCite
	self
		should:
			[self tag
				cite: 'test';
				with: []]
		addAttribute: 'cite'
		withValue: 'test'! !

!HVEditTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 17:07'!
testDateTime
	self
		should:
			[self tag
				dateTime: 'test';
				with: []]
		addAttribute: 'datetime'
		withValue: 'test'! !

!HVEditTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 17:04'!
testWith
	self assertTagName: #del! !

TagTestCase subclass: #HVFormElementTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVFormElementTagTest methodsFor: 'as yet unclassified' stamp: 'gc 11/3/2007 21:38'!
classToTest
	^ HVInputTag ! !

!HVFormElementTagTest methodsFor: 'as yet unclassified' stamp: 'gc 11/3/2007 21:36'!
testName
	self should:
		[self tag
			name: 'test';
			with: []]
	addAttribute: 'name'
	withValue: 'test'.! !

!HVFormElementTagTest methodsFor: 'as yet unclassified' stamp: 'gc 11/3/2007 22:02'!
testNameAccessors
	self tag name: 'test'.
	self assert: self tag name = 'test'! !

TagTestCase subclass: #HVFormTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 11:22'!
setUp
	super setUp.
	self tag action: 'test'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 11:12'!
testAccept
	self should:
		[self tag
			accept: 'test';
			with: []]
	addAttribute: 'accept'
	withValue: 'test'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 11:15'!
testAcceptCharset
	self should:
		[self tag
			acceptCharset: 'test';
			with: []]
	addAttribute: 'accept-charset'
	withValue: 'test'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 11:12'!
testAcceptCharsets
	self should:
		[self tag
			acceptCharsets: {'test1'. 'test2'};
			with: []]
	addAttribute: 'accept-charset'
	withValue: 'test1 test2'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 11:12'!
testAccepts
	self should:
		[self tag
			accepts: {'test1'. 'test2'};
			with: []]
	addAttribute: 'accept'
	withValue: 'test1 test2'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 18:48'!
testAction
	self should:
		[self tag
			action: 'test';
			with: []]
	addAttribute: 'action'
	withValue: 'test'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 18:51'!
testEncodingType
	self should:
		[self tag
			encodingType: 'test';
			with: []]
	addAttribute: 'enctype'
	withValue: 'test'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 19:05'!
testMultipartData
	self 
		should: 
			[(self tag)
				beMultipart;
				with: []]
		addAttribute: 'enctype'
		withValue: tag class multipartFormData! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 11/3/2007 15:11'!
testName
	self should:
		[self tag
			name: 'test';
			with: []]
	addAttribute: 'id'
	withValue: 'test'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 19:09'!
testOnReset
	self should:
		[self tag
			onReset: 'test';
			with: []]
	addAttribute: 'onreset'
	withValue: 'test'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 19:11'!
testOnSubmit
	self should:
		[self tag
			onSubmit: 'test';
			with: []]
	addAttribute: 'onsubmit'
	withValue: 'test'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 19:06'!
testUseGet
	self should:
		[self tag
			useGet;
			with: []]
	addAttribute: 'method'
	withValue: 'get'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 19:08'!
testUsePost
	self should:
		[self tag
			usePost;
			with: []]
	addAttribute: 'method'
	withValue: 'post'! !

!HVFormTagTest methodsFor: 'tests' stamp: 'gc 11/3/2007 17:37'!
testWith
	self tag attributes removeKey: 'action'.
	self
		should: [self tag with: []]
		raise: HVAttributeError
		description: '''action'' not set'.
	self tag action: 'test'.
	self assertTagName: #form.
	self assert: (self firstElement attributes at: 'method') = 'get'! !

TagTestCase subclass: #HVHeadTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVHeadTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 15:17'!
testClass
	self
		should: [self tag class: 'test']
		raise: MessageNotUnderstood! !

!HVHeadTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 15:16'!
testEvents
	self
		should: [self tag onClick: 'test']
		raise: MessageNotUnderstood! !

!HVHeadTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:41'!
testProfile
	self should:
	[self tag
		profile: 'test';
		with: []]
	addAttribute: 'profile'
	withValue: 'test'! !

!HVHeadTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 15:03'!
testProfiles
	self should:
	[self tag
		profiles: {'test1'. 'test2'};
		with: []]
	addAttribute: 'profile'
	withValue: 'test1 test2'! !

!HVHeadTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 15:18'!
testTitle
	self
		should: [self tag title: 'test']
		raise: MessageNotUnderstood! !

!HVHeadTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 14:42'!
testWith
	self assertTagName: #head! !

TagTestCase subclass: #HVHeadingTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVHeadingTagTest methodsFor: 'tests' stamp: 'gc 2/10/2007 18:22'!
setUp
	super setUp.
	self tag level: 2! !

!HVHeadingTagTest methodsFor: 'tests' stamp: 'gc 2/17/2007 16:25'!
testWith
	self assertTagName: #h2! !

TagTestCase subclass: #HVHtmlTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVHtmlTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 15:19'!
testClass
	self
		should: [self tag class: 'test']
		raise: MessageNotUnderstood! !

!HVHtmlTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 15:21'!
testEvents
	self
		should: [self tag onClick: 'test']
		raise: MessageNotUnderstood! !

!HVHtmlTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 15:21'!
testTitle
	self
		should: [self tag title: 'test']
		raise: MessageNotUnderstood ! !

!HVHtmlTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 15:08'!
testVersion
	self
		should:
			[self tag
				version: 'test';
				with: []]
		addAttribute: 'version'
		withValue: 'test'.! !

!HVHtmlTagTest methodsFor: 'tests' stamp: 'gc 11/3/2007 17:38'!
testWith
	self assertTagName: #html.
	self assert: (self firstElement attributes at: 'xmlns') = tag class xmlns.! !

!HVHtmlTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 15:06'!
testXmlns
	self
		should:
			[self tag
				xmlns: 'test';
				with: []]
		addAttribute: 'xmlns'
		withValue: 'test'.! !

TagTestCase subclass: #HVImageTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVImageTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 11:36'!
setUp
	super setUp.
	self tag attributeAt: 'src' put: ''.
	self tag attributeAt: 'alt' put: ''! !

!HVImageTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 11:36'!
testAlternativeText
	self
		should:
			[self tag
				alternativeText: 'test';
				with: []]
		addAttribute: 'alt'
		withValue: 'test'! !

!HVImageTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 12:24'!
testHeight
	self
		should:
			[self tag
				height: 42;
				with: []]
		addAttribute: 'height'
		withValue: '42'.
	
	self
		should: [self tag height: -42]
		raise: HVAttributeError! !

!HVImageTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 12:15'!
testIsMap
	self
		should:
			[self tag
				isMap;
				with: []]
		addAttribute: 'ismap'
		withValue: 'ismap'.! !

!HVImageTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 11:37'!
testLongDescription
	self
		should:
			[self tag
				longDescription: 'test';
				with: []]
		addAttribute: 'longdesc'
		withValue: 'test'! !

!HVImageTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 11:37'!
testSource
	self
		should:
			[self tag
				source: 'test';
				with: []]
		addAttribute: 'src'
		withValue: 'test'! !

!HVImageTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 12:40'!
testSourceAlternativeText
	self
		should:
			[self tag
				source: 'test'
				alternativeText: 'test']
		addAttribute: 'src'
		withValue: 'test'! !

!HVImageTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 12:30'!
testUseMap
	self
		should:
			[self tag
				useMap: 'test';
				with: []]
		addAttribute: 'usemap'
		withValue: 'test'.! !

!HVImageTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 12:24'!
testWidth
	self
		should:
			[self tag
				width: 42;
				with: []]
		addAttribute: 'width'
		withValue: '42'.
	
	self
		should: [self tag width: -42]
		raise: HVAttributeError! !

!HVImageTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 12:25'!
testWith
	self tag: (self classToTest canvas: self canvas).
	self
		should: [self tag with: []]
		raise: HVAttributeError.
	self tag attributeAt: 'src' put: ''.
	self
		should: [self tag with: []]
		raise: HVAttributeError.
	self tag attributeAt: 'alt' put: ''.
	self assertTagName: #img.
	self assert: (self canvas contents endsWith: '/>')! !

TagTestCase subclass: #HVInputTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 11:58'!
testAccept
	self should:
		[self tag
			accept: 'test';
			with: []]
	addAttribute: 'accept'
	withValue: 'test'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 11:58'!
testAccepts
	self should:
		[self tag
			accepts: {'test1'. 'test2'};
			with: []]
	addAttribute: 'accept'
	withValue: 'test1 test2'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 20:02'!
testAccessKey
	self should:
		[self tag
			accessKey: $t;
			with: []]
	addAttribute: 'accesskey'
	withValue: 't'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 20:04'!
testAlt
	self should:
		[self tag
			alt: 'test';
			with: []]
	addAttribute: 'alt'
	withValue: 'test'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 20:04'!
testAlternativeText
	self should:
		[self tag
			alternativeText: 'test';
			with: []]
	addAttribute: 'alt'
	withValue: 'test'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 11:59'!
testChecked
	self
		should: 
			[self tag
				checked;
				with: []]
	 	addAttribute: 'checked'
		withValue: 'checked'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/15/2007 19:17'!
testDisabled
	self 
		should: 
			[(self tag)
				disabled;
				with: []]
		addAttribute: 'disabled'
		withValue: 'disabled'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 14:58'!
testIsMap
	self should:
		[self tag
			isMap;
			with: []]
	addAttribute: 'ismap'
	withValue: 'ismap'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:26'!
testMaxLength
	self should:
		[self tag
			maxLength: 42;
			with: []]
	addAttribute: 'maxlength'
	withValue: '42'.

	self
		should: [self tag maxLength: -42]
		raise: HVAttributeError! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 19:54'!
testOnBlur
	self should:
		[self tag
			onBlur: 'test';
			with: []]
	addAttribute: 'onblur'
	withValue: 'test'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 19:54'!
testOnChange
	self should:
		[self tag
			onChange: 'test';
			with: []]
	addAttribute: 'onchange'
	withValue: 'test'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 19:54'!
testOnFocus
	self should:
		[self tag
			onFocus: 'test';
			with: []]
	addAttribute: 'onfocus'
	withValue: 'test'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 19:55'!
testOnSelect
	self should:
		[self tag
			onSelect: 'test';
			with: []]
	addAttribute: 'onselect'
	withValue: 'test'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/15/2007 19:24'!
testReadonly
	self 
		should: 
			[(self tag)
				readonly;
				with: []]
		addAttribute: 'readonly'
		withValue: 'readonly'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:26'!
testSize
	self should:
		[self tag
			size: 42;
			with: []]
	addAttribute: 'size'
	withValue: '42'.

	self
		should: [self tag size: -42]
		raise: HVAttributeError! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:36'!
testSource
	self
		shouldnt:
			[self tag
				source: 'test';
				with: []]
		understandAttribute: 'src'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:26'!
testTabIndex
	self should:
		[self tag
			tabIndex: 42;
			with: []]
	addAttribute: 'tabindex'
	withValue: '42'.

	self
		should: [self tag tabIndex: -42]
		raise: HVAttributeError	! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 20:14'!
testType
	self should:
		[self tag
			type: 'test';
			with: []]
	addAttribute: 'type'
	withValue: 'test'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/11/2007 23:45'!
testUseMap
	self should:
		[self tag
			useMap: 'test';
			with: []]
	addAttribute: 'usemap'
	withValue: 'test'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 7/12/2007 00:12'!
testValue
	self should:
		[self tag
			value: 'test']
	addAttribute: 'value'
	withValue: 'test'! !

!HVInputTagTest methodsFor: 'tests' stamp: 'gc 11/3/2007 17:38'!
testWith
	self assertTagName: 'input'.
	self assert: (self firstElement attributes at: 'type') = 'text'.
	self assert: (self canvas contents endsWith: '/>')! !

TagTestCase subclass: #HVLabelTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVLabelTagTest methodsFor: 'tests' stamp: 'gc 7/17/2007 10:27'!
testAccessKey
	self should: 
	[self tag
		accessKey: $a;
		with: []]
	addAttribute: 'accesskey'
	withValue: 'a'! !

!HVLabelTagTest methodsFor: 'tests' stamp: 'gc 7/17/2007 10:29'!
testFor
	self should: 
	[self tag
		for: 'test';
		with: []]
	addAttribute: 'for'
	withValue: 'test'! !

!HVLabelTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 19:51'!
testOnBlur
	self should:
		[self tag
			onBlur: 'test';
			with: []]
	addAttribute: 'onblur'
	withValue: 'test'! !

!HVLabelTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 19:51'!
testOnFocus
	self should:
		[self tag
			onFocus: 'test';
			with: []]
	addAttribute: 'onfocus'
	withValue: 'test'! !

!HVLabelTagTest methodsFor: 'tests' stamp: 'gc 7/17/2007 10:27'!
testWith
	self assertTagName: 'label'! !

TagTestCase subclass: #HVLegendTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVLegendTagTest methodsFor: 'tests' stamp: 'gc 7/17/2007 10:18'!
testAccessKey
	self
		should: 
			[self tag
				accessKey: $a;
				with: []]
		addAttribute: 'accesskey'
		withValue: 'a'! !

!HVLegendTagTest methodsFor: 'tests' stamp: 'gc 7/17/2007 10:11'!
testWith
	self assertTagName: 'legend'! !

TagTestCase subclass: #HVLinkTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVLinkTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:40'!
testAllMedia
	self
		should:
			[self tag
				allMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'all'! !

!HVLinkTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:40'!
testAuralMedia
	self
		should:
			[self tag
				auralMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'aural'! !

!HVLinkTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:40'!
testBrailleMedia
	self
		should:
			[self tag
				brailleMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'braille'! !

!HVLinkTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:40'!
testHandheldMedia
	self
		should:
			[self tag
				handheldMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'handheld'! !

!HVLinkTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:40'!
testMedia
	self
		should:
			[self tag
				media: 'test';
				with: []]
		addAttribute: 'media'
		withValue: 'test'! !

!HVLinkTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:40'!
testPrintMedia
	self
		should:
			[self tag
				printMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'print'! !

!HVLinkTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:41'!
testProjectionMedia
	self
		should:
			[self tag
				projectionMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'projection'! !

!HVLinkTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:41'!
testScreenMedia
	self
		should:
			[self tag
				screenMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'screen'! !

!HVLinkTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:41'!
testTtyMedia
	self
		should:
			[self tag
				ttyMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'tty'! !

!HVLinkTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:43'!
testTvMedia
	self
		should:
			[self tag
				tvMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'tv'! !

!HVLinkTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:49'!
testWith
	self assertTagName: #link! !

TagTestCase subclass: #HVMapTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVMapTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 14:51'!
testClasses
	self
		should: [self tag classes: {}]
		raise: HVAttributeError! !

!HVMapTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 14:04'!
testWith
	self assertTagName: #map! !

TagTestCase subclass: #HVMetaTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 13:26'!
testClass
	self
		shouldnt: [self tag class: 'test'] understandAttribute: 'class'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 13:27'!
testClasses
	self
		shouldnt: [self tag classes: {'test'}] understandAttribute: 'class'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:06'!
testContent
	self
		should:
			[self tag
				content: 'test']
		addAttribute: 'content'
		withValue: 'test'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:08'!
testContentType
	self
		should:
			[self tag
				contentType;
				content: 'test']
		addAttribute: 'http-equiv'
		withValue: 'content-type'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:08'!
testExpires
	self
		should:
			[self tag
				expires;
				content: '']
		addAttribute: 'http-equiv'
		withValue: 'expires'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:08'!
testHttpEquiv
	self
		should:
			[self tag
				httpEquiv: 'test';
				content: '']
		addAttribute: 'http-equiv'
		withValue: 'test'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:08'!
testHttpEquivalent
	self
		should:
			[self tag
				httpEquivalent: 'test';
				content: '']
		addAttribute: 'http-equiv'
		withValue: 'test'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:09'!
testName
	self
		should:
			[self tag
				name: 'test';
				content: '']
		addAttribute: 'name'
		withValue: 'test'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 13:28'!
testOnClick
	self
		shouldnt: [self tag onClick: 'test'] understandAttribute: 'onclick'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:14'!
testRefresh
	self
		should:
			[self tag
				refresh;
				content: '']
		addAttribute: 'http-equiv'
		withValue: 'refresh'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:14'!
testScheme
	self
		should:
			[self tag
				scheme: 'test';
				content: '']
		addAttribute: 'scheme'
		withValue: 'test'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:14'!
testSetCookie
	self
		should:
			[self tag
				setCookie;
				content: '']
		addAttribute: 'http-equiv'
		withValue: 'set-cookie'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 13:27'!
testTitle
	self
		shouldnt: [self tag title: 'test'] understandAttribute: 'title'! !

!HVMetaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:08'!
testWith
	self
		should: [self tag with: []]
		raise: HVAttributeError.
	self tag content: 'test'.
	self assertTagName: #meta.
	self assert: (self canvas contents endsWith: '/>')! !

TagTestCase subclass: #HVObjectTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 15:39'!
testArchive
	self
		should:
			[self tag
				archive: 'test';
				with: []]
		addAttribute: 'archive'
		withValue: 'test'! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 15:41'!
testArchives
	self
		should:
			[self tag
				archives: {'test1'. 'test2'};
				with: []]
		addAttribute: 'archive'
		withValue: 'test1 test2'! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 15:29'!
testClassId
	self
		should:
			[self tag
				classId: 'test';
				with: []]
		addAttribute: 'classid'
		withValue: 'test'! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 15:30'!
testCodeBase
	self
		should:
			[self tag
				codeBase: 'test';
				with: []]
		addAttribute: 'codebase'
		withValue: 'test'! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 15:31'!
testCodeType
	self
		should:
			[self tag
				codeType: 'test';
				with: []]
		addAttribute: 'codetype'
		withValue: 'test'! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 15:32'!
testData
	self
		should:
			[self tag
				data: 'test';
				with: []]
		addAttribute: 'data'
		withValue: 'test'! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 15:44'!
testDeclare
	self
		should:
			[self tag
				declare;
				with: []]
		addAttribute: 'declare'
		withValue: 'declare'! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 18:37'!
testDeclareOnly
	self
		should:
			[self tag
				declareOnly;
				with: []]
		addAttribute: 'declare'
		withValue: 'declare'! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:26'!
testHeight
	self
		should:
			[self tag
				height: 42;
				with: []]
		addAttribute: 'height'
		withValue: '42'.
	
	self
		should: [self tag height: -42]
		raise: HVAttributeError! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 15:54'!
testName
	self
		should:
			[self tag
				name: 'test';
				with: []]
		addAttribute: 'name'
		withValue: 'test'.! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 15:46'!
testStandby
	self
		should:
			[self tag
				standby: 'test';
				with: []]
		addAttribute: 'standby'
		withValue: 'test'! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:27'!
testTabIndex
	self
		should:
			[self tag
				tabIndex: 42;
				with: []]
		addAttribute: 'tabindex'
		withValue: '42'.
	
	self
		should: [self tag tabIndex: -42]
		raise: HVAttributeError! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 15:36'!
testType
	self
		should:
			[self tag
				type: 'test';
				with: []]
		addAttribute: 'type'
		withValue: 'test'! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 14:57'!
testUseMap
	self
		should:
			[self tag
				useMap: 'test';
				with: []]
		addAttribute: 'usemap'
		withValue: 'test'! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:27'!
testWidth
	self
		should:
			[self tag
				width: 42;
				with: []]
		addAttribute: 'width'
		withValue: '42'.
	
	self
		should: [self tag width: -42]
		raise: HVAttributeError! !

!HVObjectTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 15:27'!
testWith
	self assertTagName: 'object'! !

TagTestCase subclass: #HVOptionGroupTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVOptionGroupTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 18:24'!
testDisabled
	self
		should:
			[self tag
				disabled;
				with: []]
		addAttribute: 'disabled'
		withValue: 'disabled'! !

!HVOptionGroupTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 18:26'!
testLabel
	self
		should:
			[self tag
				label: 'test';
				with: []]
		addAttribute: 'label'
		withValue: 'test'! !

!HVOptionGroupTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 18:22'!
testWith
	self assertTagName: #optgroup! !

TagTestCase subclass: #HVOptionTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVOptionTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 11:36'!
testDisabled
	self 
		should: 
			[(self tag)
				disabled;
				with: []]
		addAttribute: 'disabled'
		withValue: 'disabled'! !

!HVOptionTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 11:39'!
testLabel
	self should:
		[self tag
			label: 'test';
			with: []]
	addAttribute: 'label'
	withValue: 'test'! !

!HVOptionTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 11:37'!
testSelected
	self 
		should: 
			[(self tag)
				selected;
				with: []]
		addAttribute: 'selected'
		withValue: 'selected'! !

!HVOptionTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 11:39'!
testValue
	self should:
		[self tag
			value: 'test';
			with: []]
	addAttribute: 'value'
	withValue: 'test'! !

!HVOptionTagTest methodsFor: 'nil' stamp: 'gc 7/17/2007 11:34'!
testWith
	self assertTagName: 'option'! !

TagTestCase subclass: #HVParameterTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVParameterTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:30'!
testBeData
	self
		should:
			[self tag
				name: 'test';
				beData;
				with: []]
		addAttribute: 'valuetype'
		withValue: 'data'! !

!HVParameterTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:31'!
testBeObject
	self
		should:
			[self tag
				name: 'test';
				beObject;
				with: []]
		addAttribute: 'valuetype'
		withValue: 'object'! !

!HVParameterTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:31'!
testBeReference
	self
		should:
			[self tag
				name: 'test';
				beReference;
				with: []]
		addAttribute: 'valuetype'
		withValue: 'ref'! !

!HVParameterTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 18:40'!
testClass
	self
		should: [self tag class: 'test']
		raise: MessageNotUnderstood ! !

!HVParameterTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 18:51'!
testId
	self
		should:
			[self tag
				name: 'test';
				id: 'test';
				with: []]
		addAttribute: 'id'
		withValue: 'test'! !

!HVParameterTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:26'!
testName
	self
		should:
			[self tag
				name: 'test';
				with: []]
		addAttribute: 'name'
		withValue: 'test'! !

!HVParameterTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:32'!
testType
	self
		should:
			[self tag
				name: 'test';
				type: 'test';
				with: []]
		addAttribute: 'type'
		withValue: 'test'! !

!HVParameterTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:27'!
testValue
	self
		should:
			[self tag
				name: 'test';
				value: 'test';
				with: []]
		addAttribute: 'value'
		withValue: 'test'! !

!HVParameterTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 16:29'!
testValueType
	self
		should:
			[self tag
				name: 'test';
				valueType: 'data';
				with: []]
		addAttribute: 'valuetype'
		withValue: 'data'! !

!HVParameterTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:27'!
testWith
	self
		should: [self tag with: []]
		raise: HVAttributeError.
	self tag attributeAt: 'name' put: 'test'.
	self assertTagName: #param.
	self assert: self canvas contents = '<param name="test"/>'! !

TagTestCase subclass: #HVRubyTextTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVRubyTextTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 16:06'!
testRubyBaseSpan
	self
		should:
			[self tag
				rubyBaseSpan: 42;
				with: []]
		addAttribute: 'rbspan'
		withValue: '42'! !

!HVRubyTextTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 16:05'!
testWith
	self assertTagName: #rt! !

TagTestCase subclass: #HVScriptTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVScriptTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:18'!
setUp
	super setUp.
	self tag type: 'test'! !

!HVScriptTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:07'!
testCharset
	self
		should:
			[self tag
				charSet: 'test';
				with: []]
		addAttribute: 'charset'
		withValue: 'test'! !

!HVScriptTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:08'!
testDeferred
	self
		should:
			[self tag
				deferred;
				with: []]
		addAttribute: 'defer'
		withValue: 'defer'! !

!HVScriptTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:10'!
testSource
	self
		should:
			[self tag
				source: 'test';
				with: []]
		addAttribute: 'src'
		withValue: 'test'! !

!HVScriptTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:10'!
testType
	self
		should:
			[self tag
				type: 'test';
				with: []]
		addAttribute: 'type'
		withValue: 'test'! !

!HVScriptTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:19'!
testWith
	self assertTagName: #script.
	self tag attributes removeKey: 'type'.
	self
		should: [self tag with: []]
		raise: HVAttributeError! !

TagTestCase subclass: #HVSelectTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVSelectTagTest methodsFor: 'tests' stamp: 'gc 7/17/2007 11:04'!
testBeMultiple
	self 
		should: 
			[(self tag)
				beMultiple;
				with: []]
		addAttribute: 'multiple'
		withValue: 'multiple'! !

!HVSelectTagTest methodsFor: 'tests' stamp: 'gc 7/17/2007 11:01'!
testDisabled
	self 
		should: 
			[(self tag)
				disabled;
				with: []]
		addAttribute: 'disabled'
		withValue: 'disabled'! !

!HVSelectTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 19:57'!
testOnBlur
	self should:
		[self tag
			onBlur: 'test';
			with: []]
	addAttribute: 'onblur'
	withValue: 'test'! !

!HVSelectTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 19:57'!
testOnChange
	self should:
		[self tag
			onChange: 'test';
			with: []]
	addAttribute: 'onchange'
	withValue: 'test'! !

!HVSelectTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 19:56'!
testOnFocus
	self should:
		[self tag
			onFocus: 'test';
			with: []]
	addAttribute: 'onfocus'
	withValue: 'test'! !

!HVSelectTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:32'!
testSize
	self should:
		[self tag
			size: 42;
			with: []]
	addAttribute: 'size'
	withValue: '42'.

	self
		should: [self tag size: -42]
		raise: HVAttributeError! !

!HVSelectTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:27'!
testTabIndex
	self should:
		[self tag
			tabIndex: 42;
			with: []]
	addAttribute: 'tabindex'
	withValue: '42'.

	self
		should: [self tag tabIndex: -42]
		raise: HVAttributeError.	! !

!HVSelectTagTest methodsFor: 'tests' stamp: 'gc 7/17/2007 10:59'!
testWith
	self assertTagName: 'select'! !

TagTestCase subclass: #HVStyleTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:21'!
testAllMedia
	self
		should:
			[self tag
				allMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'all'! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:27'!
testAuralMedia
	self
		should:
			[self tag
				auralMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'aural'! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:27'!
testBrailleMedia
	self
		should:
			[self tag
				brailleMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'braille'! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:21'!
testClass
	self
		should: [self tag class: 'test']
		raise: MessageNotUnderstood! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 20:21'!
testClasses
	self
		should: [self tag classes: {'test'}]
		raise: MessageNotUnderstood! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:26'!
testHandheldMedia
	self
		should:
			[self tag
				handheldMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'handheld'! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:20'!
testMedia
	self
		should:
			[self tag
				media: 'test';
				with: []]
		addAttribute: 'media'
		withValue: 'test'! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:26'!
testPrintMedia
	self
		should:
			[self tag
				printMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'print'! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:26'!
testProjectionMedia
	self
		should:
			[self tag
				projectionMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'projection'! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:22'!
testScreenMedia
	self
		should:
			[self tag
				screenMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'screen'! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:22'!
testTtyMedia
	self
		should:
			[self tag
				ttyMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'tty'! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:23'!
testTvMedia
	self
		should:
			[self tag
				tvMedia;
				with: []]
		addAttribute: 'media'
		withValue: 'tv'! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:28'!
testType
	self
		should:
			[self tag
				type: 'test';
				with: []]
		addAttribute: 'type'
		withValue: 'test'! !

!HVStyleTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/25/2007 15:16'!
testWith
	self assertTagName: #style! !

TagTestCase subclass: #HVTableCellTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 22:09'!
setUp
	super setUp.
	self tag tag: 'td'! !

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 20:31'!
testAbbreviation
	self
		should:
			[self tag
				abbreviation: 'test';
				with: []]
		addAttribute: 'abbr'
		withValue: 'test'! !

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 20:34'!
testAxis
	self
		should:
			[self tag
				axis: 'test';
				with: []]
		addAttribute: 'axis'
		withValue: 'test'! !

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 21:07'!
testColumnGroupScope
	self
		should:
			[self tag
				columnGroupScope;
				with: []]
		addAttribute: 'scope'
		withValue: 'colgroup'.! !

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 21:06'!
testColumnScope
	self
		should:
			[self tag
				columnScope;
				with: []]
		addAttribute: 'scope'
		withValue: 'col'.! !

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:28'!
testColumnSpan
	self
		should:
			[self tag
				columnSpan: 42;
				with: []]
		addAttribute: 'colspan'
		withValue: '42'.
	
	self
		should: [self tag columnSpan: -42]
		raise: HVAttributeError ! !

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 21:02'!
testHeaders
	self
		should:
			[self tag
				headers: {'test1'. 'test2'};
				with: []]
		addAttribute: 'headers'
		withValue: 'test1,test2'.! !

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 21:06'!
testRowGroupScope
	self
		should:
			[self tag
				rowGroupScope;
				with: []]
		addAttribute: 'scope'
		withValue: 'rowgroup'.! !

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 21:05'!
testRowScope
	self
		should:
			[self tag
				rowScope;
				with: []]
		addAttribute: 'scope'
		withValue: 'row'.! !

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:28'!
testRowSpan
	self
		should:
			[self tag
				rowSpan: 42;
				with: []]
		addAttribute: 'rowspan'
		withValue: '42'.
	
	self
		should: [self tag rowSpan: -42]
		raise: HVAttributeError.! !

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 21:04'!
testScope
	self
		should:
			[self tag
				scope: 'col';
				with: []]
		addAttribute: 'scope'
		withValue: 'col'.! !

!HVTableCellTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 20:21'!
testWith
	self assertTagName: #td! !

TagTestCase subclass: #HVTableColumnElementTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVTableColumnElementTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 23:27'!
setUp
	super setUp.
	self tag tag: 'col'! !

!HVTableColumnElementTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 13:35'!
testRelativeWidth
	self
		should:
			[self tag
				relativeWidth: 'test';
				with: []]
		addAttribute: 'width'
		withValue: 'test'! !

!HVTableColumnElementTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/24/2007 23:28'!
testSpan
	self
		should:
			[self tag
				span: 42;
				with: []]
		addAttribute: 'span'
		withValue: '42'! !

TagTestCase subclass: #HVTableElementTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 23:07'!
setUp
	super setUp.
	self tag tag: 'tr'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:26'!
testAlignment
	self
		should:
			[self tag
				alignment: 'left';
				with: []]
		addAttribute: 'align'
		withValue: 'left'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:57'!
testBaselineAlignment
	self
		should:
			[self tag
				baselineAlignment;
				with: []]
		addAttribute: 'valign'
		withValue: 'baseline'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:56'!
testBottomAlignment
	self
		should:
			[self tag
				bottomAlignment;
				with: []]
		addAttribute: 'valign'
		withValue: 'bottom'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:27'!
testCenterAlignment
	self
		should:
			[self tag
				centerAlignment;
				with: []]
		addAttribute: 'align'
		withValue: 'center'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:28'!
testCharacter
	self
		should: [self tag character: $t]
		raise: HVAttributeError.

	self
		should:
			[self tag
				characterAlignment;
				character: $t;
				with: []]
		addAttribute: 'char'
		withValue: 't'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:30'!
testCharacterAlignment
	self
		should:
			[self tag
				characterAlignment;
				with: []]
		addAttribute: 'align'
		withValue: 'char'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:28'!
testCharacterOffset
	self
		should: [self tag characterOffset: 42]
		raise: HVAttributeError.
	self should: 
			[(self tag)
				characterAlignment;
				character: $t;
				characterOffset: -42]
		raise: HVAttributeError.
	self 
		should: 
			[(self tag)
				characterAlignment;
				character: $t;
				characterOffset: 42;
				with: []]
		addAttribute: 'charoff'
		withValue: '42'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:29'!
testJustifiedAlignment
	self
		should:
			[self tag
				justifiedAlignment;
				with: []]
		addAttribute: 'align'
		withValue: 'justify'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:26'!
testLeftAlignment
	self
		should:
			[self tag
				leftAlignment;
				with: []]
		addAttribute: 'align'
		withValue: 'left'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:55'!
testMiddleAlignment
	self
		should:
			[self tag
				middleAlignment;
				with: []]
		addAttribute: 'valign'
		withValue: 'middle'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:28'!
testRightAlignment
	self
		should:
			[self tag
				rightAlignment;
				with: []]
		addAttribute: 'align'
		withValue: 'right'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:55'!
testTopAlignment
	self
		should:
			[self tag
				topAlignment;
				with: []]
		addAttribute: 'valign'
		withValue: 'top'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:54'!
testVerticalAlignment
	self
		should:
			[self tag
				verticalAlignment: 'middle';
				with: []]
		addAttribute: 'valign'
		withValue: 'middle'! !

!HVTableElementTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:10'!
testWith
	self assertTagName: #tr! !

TagTestCase subclass: #HVTableTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 20:03'!
testAboveFrame
	self
		should:
			[self tag
				aboveFrame;
				with: []]
		addAttribute: 'frame'
		withValue: 'above'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:58'!
testAllRules
	self
		should:
			[self tag
				allRules;
				with: []]
		addAttribute: 'rules'
		withValue: 'all'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:44'!
testBelowFrame
	self
		should:
			[self tag
				belowFrame;
				with: []]
		addAttribute: 'frame'
		withValue: 'below'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:30'!
testBorder
	self
		should:
			[self tag
				border: 42;
				with: []]
		addAttribute: 'border'
		withValue: '42'.
	
	self
		should: [self tag border: -42]
		raise: HVAttributeError.! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:45'!
testBorderFrame
	self
		should:
			[self tag
				borderFrame;
				with: []]
		addAttribute: 'frame'
		withValue: 'border'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:46'!
testBoxFrame
	self
		should:
			[self tag
				boxFrame;
				with: []]
		addAttribute: 'frame'
		withValue: 'box'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:40'!
testCellPadding
	self
		should:
			[self tag
				cellPadding: 42;
				with: []]
		addAttribute: 'cellpadding'
		withValue: '42'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:40'!
testCellSpacing
	self
		should:
			[self tag
				cellSpacing: 42;
				with: []]
		addAttribute: 'cellspacing'
		withValue: '42'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:57'!
testColumnRules
	self
		should:
			[self tag
				columnRules;
				with: []]
		addAttribute: 'rules'
		withValue: 'cols'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:42'!
testFrame
	self
		should:
			[self tag
				frame: 'border';
				with: []]
		addAttribute: 'frame'
		withValue: 'border'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:56'!
testGroupRules
	self
		should:
			[self tag
				groupRules;
				with: []]
		addAttribute: 'rules'
		withValue: 'groups'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:49'!
testHorizontalFrame
	self
		should:
			[self tag
				horizontalFrame;
				with: []]
		addAttribute: 'frame'
		withValue: 'hsides'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:50'!
testLeftSideFrame
	self
		should:
			[self tag
				leftSideFrame;
				with: []]
		addAttribute: 'frame'
		withValue: 'lhs'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:58'!
testNoRules
	self
		should:
			[self tag
				noRules;
				with: []]
		addAttribute: 'rules'
		withValue: 'none'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:51'!
testRightSideFrame
	self
		should:
			[self tag
				rightSideFrame;
				with: []]
		addAttribute: 'frame'
		withValue: 'rhs'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:54'!
testRowRules
	self
		should:
			[self tag
				rowRules;
				with: []]
		addAttribute: 'rules'
		withValue: 'rows'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:54'!
testRules
	self
		should:
			[self tag
				rules: 'none';
				with: []]
		addAttribute: 'rules'
		withValue: 'none'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 19:00'!
testSummary
	self
		should:
			[self tag
				summary: 'test';
				with: []]
		addAttribute: 'summary'
		withValue: 'test'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:53'!
testVerticalFrame
	self
		should:
			[self tag
				verticalFrame;
				with: []]
		addAttribute: 'frame'
		withValue: 'vsides'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:52'!
testVoidFrame
	self
		should:
			[self tag
				voidFrame;
				with: []]
		addAttribute: 'frame'
		withValue: 'void'! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/31/2007 12:30'!
testWidth
	self 
		should: 
			[(self tag)
				width: 42;
				with: []]
		addAttribute: 'width'
		withValue: '42'.
		
	self
		should: [self tag width: -42]
		raise: HVAttributeError.! !

!HVTableTagTest methodsFor: 'tests' stamp: 'gc 7/24/2007 18:36'!
testWith
	self assertTagName: #table! !

TagTestCase subclass: #HVTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-Canvas-Tests'!

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 13:53'!
setUp
	super setUp.
	self tag tag: 'test'.
	! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 13:55'!
testAttributeAt
	self tag attributes at: 'class' put: 'test'.
	self assert: (self tag attributeAt: 'class') = 'test'! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 13:56'!
testAttributeAtIfAbsent
	self tag attributeAt: 'class' put: 'test'.
	self assert: (self tag attributeAt: 'class' ifAbsent: ['foo']) = 'test'.
	self assert: (self tag attributeAt: 'test' ifAbsent: ['foo']) = 'foo'! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 13:57'!
testAttributeAtIfAbsentPut
	self assert: (self tag attributeAt: 'class' ifAbsentPut: ['test']) = 'test'.
	self assert: (self tag attributeAt: 'class') = 'test'! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 13:56'!
testAttributeAtPut
	self tag attributeAt: 'class' put: 'test'.
	self assert: (self tag attributes at: 'class') = 'test'! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 14:30'!
testAttributeError
	self
		should: [self tag attributeError: 'test']
		raise: HVAttributeError
		description: 'test'
		! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 14:51'!
testCloseSelfTag
	| t |
	t := self tag.
	t closeTag.
	self assert: canvas contents = '</test>'
! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 14:51'!
testCloseTag
	| t |
	t := self tag.
	t closeTag: t tag.
	self assert: canvas contents = '</test>'
! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 14:29'!
testDoesNotUnderstandAttribute
	[self tag doesNotUnderstandAttribute: 'test']
		on: HVAttributeNotUnderstood
		do: 
		[:error | 
		self assert: error htmlTag = self tag.
		self assert: error attribute = 'test']! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 14:51'!
testOpenSelfTag
	| t |
	t := self tag.
	t openTag.
	self assert: canvas contents = ('<', t tag, '>')
! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 14:51'!
testOpenTag
	| t |
	t := self tag.
	t openTag: t tag.
	self assert: canvas contents = ('<', t tag, '>')
! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 14:52'!
testOpenTagWithAttributes
	| t |
	t := self tag.
	t attributeAt: 'test' put: 'test'.
	t openTag: t tag.
	self assert: canvas contents = '<test test="test">'
! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 11/3/2007 17:38'!
testText
	self tag text: 'test'.
	self assert: self firstElement contents first string = 'test'! !

!HVTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 13:53'!
testWith
	self assertTagName: #test! !

TagTestCase subclass: #HVTextAreaTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 17:16'!
testAccessKey
	self should: 
	[self tag
		accessKey: $a;
		with: []]
	addAttribute: 'accesskey'
	withValue: 'a'! !

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 17:18'!
testCols
	self
		should: 
			[self tag
				cols: 42;
				with: []]
		addAttribute: 'cols'
		withValue: '42'! !

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 17:19'!
testColumns
	self
		should: 
			[self tag
				columns: 42;
				with: []]
		addAttribute: 'cols'
		withValue: '42'! !

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 17:20'!
testDisabled
	self 
		should: 
			[(self tag)
				disabled;
				with: []]
		addAttribute: 'disabled'
		withValue: 'disabled'! !

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 19:58'!
testOnBlur
	self should:
		[self tag
			onBlur: 'test';
			with: []]
	addAttribute: 'onblur'
	withValue: 'test'! !

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 19:58'!
testOnChange
	self should:
		[self tag
			onChange: 'test';
			with: []]
	addAttribute: 'onchange'
	withValue: 'test'! !

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 19:58'!
testOnFocus
	self should:
		[self tag
			onFocus: 'test';
			with: []]
	addAttribute: 'onfocus'
	withValue: 'test'! !

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/31/2007 19:58'!
testOnSelect
	self should:
		[self tag
			onSelect: 'test';
			with: []]
	addAttribute: 'onselect'
	withValue: 'test'! !

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 17:48'!
testReadonly
	self
		should: 
			[self tag
				readonly;
				with: []]
		addAttribute: 'readonly'
		withValue: 'readonly'! !

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 17:59'!
testRows
	self
		should: 
			[self tag
				rows: 42;
				with: []]
		addAttribute: 'rows'
		withValue: '42'! !

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 18:06'!
testTabIndex
	self should: 
	[self tag
		tabIndex: 42;
		with: []]
	addAttribute: 'tabindex'
	withValue: '42'! !

!HVTextAreaTagTest methodsFor: 'as yet unclassified' stamp: 'gc 7/17/2007 17:08'!
testWith
	self assertTagName: 'textarea'! !

TagTestCase subclass: #HVTextTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-XHTMLCanvas-Tests'!

!HVTextTagTest methodsFor: 'tests' stamp: 'gc 7/30/2007 17:34'!
setUp
	super setUp.
	self tag tag: 'q'! !

!HVTextTagTest methodsFor: 'tests' stamp: 'gc 7/23/2007 23:12'!
testCite
	self
		should:
			[self tag
				cite: 'test';
				with: []]
		addAttribute: 'cite'
		withValue: 'test'! !

!TagTestCase class methodsFor: 'testing' stamp: 'gc 2/9/2007 14:30'!
isAbstract
	^ self name = #TagTestCase! !

!TagTestCase methodsFor: 'accessing' stamp: 'gc 11/3/2007 17:38'!
assertTagName: tagName 
	self tag with: [].
	self assert: self firstElement name = tagName! !

!TagTestCase methodsFor: 'accessing' stamp: 'gc 2/9/2007 13:17'!
canvas
	^canvas! !

!TagTestCase methodsFor: 'accessing' stamp: 'gc 2/9/2007 13:17'!
canvas: anObject
	canvas := anObject! !

!TagTestCase methodsFor: 'accessing' stamp: 'gc 7/24/2007 20:17'!
classToTest
	| class |
	class := self class name.
	class := class copyFrom: 1 to: class size - 4.
	^ Smalltalk classNamed: class! !

!TagTestCase methodsFor: 'accessing' stamp: 'gc 11/3/2007 17:38'!
firstElement
	| dom |
	dom := XMLDOMParser parseDocumentFrom: self canvas contents readStream.
	^ dom elements first! !

!TagTestCase methodsFor: 'tests' stamp: 'gc 7/24/2007 20:16'!
setUp
	self canvas: (WriteStream on: String new).
	self tag: (self classToTest canvas: self canvas)! !

!TagTestCase methodsFor: 'accessing' stamp: 'gc 11/3/2007 17:38'!
should: code addAttribute: attribute withValue: value 
	| base |
	code value.
	base := self firstElement.
	self assert: (base attributes at: attribute ifAbsent: [self fail]) = value! !

!TagTestCase methodsFor: 'accessing' stamp: 'gc 2/12/2007 11:08'!
shouldnt: aBlock understandAttribute: aString
	self
		should: aBlock
		raise: HVAttributeNotUnderstood.
	aBlock
		on: HVAttributeNotUnderstood
		do: [:error | self assert: error attribute = aString]! !

!TagTestCase methodsFor: 'accessing' stamp: 'gc 2/9/2007 13:52'!
tag
	^tag! !

!TagTestCase methodsFor: 'accessing' stamp: 'gc 2/9/2007 13:52'!
tag: anObject
	tag := anObject! !
HVHttpView initialize!
SwikiFormatter initialize!
